#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <stdlib.h>
#include "arrays.h"
#include "arrays.c"
#include "grph1_.h"
#include "grph2_.h"
#include "math1_.h"
#include "math2_.h"
#include "misc1_.h"
#ifdef __cplusplus
}
#endif

static int
not_here(s)
char *s;
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(name, arg)
char *name;
int arg;
{
    errno = 0;
    switch (*name) {
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


MODULE = DCL		PACKAGE = DCL


double
constant(name,arg)
	char *		name
	int		arg

void
csgi(ret_val, ic)
    char *  ret_val
    integer ic
    CODE:
    csgi_(ret_val, strlen(ret_val), &ic);

integer
isgc(ch)
    char *  ch
    CODE:
    RETVAL =     isgc_(ch, strlen(ch));
    OUTPUT:
    RETVAL

integer
isgtrc(ctr)
    char *  ctr
    CODE:
    RETVAL =     isgtrc_(ctr, strlen(ctr));
    OUTPUT:
    RETVAL

void
scplu(n, upx, upy, upz)
    integer n
    real *  upx
    real *  upy
    real *  upz
    CODE:
    scplu_(&n, upx, upy, upz);

void
scplv(n, vpx, vpy, vpz)
    integer n
    real *  vpx
    real *  vpy
    real *  vpz
    CODE:
    scplv_(&n, vpx, vpy, vpz);

void
scqpli(index)
    integer index
    CODE:
    scqpli_(&index);

void
scspli(index)
    integer index
    CODE:
    scspli_(&index);

void
scplzu(n, upx, upy, upz, index)
    integer n
    real *  upx
    real *  upy
    real *  upz
    integer index
    CODE:
    scplzu_(&n, upx, upy, upz, &index);

void
scplzv(n, vpx, vpy, vpz, index)
    integer n
    real *  vpx
    real *  vpy
    real *  vpz
    integer index
    CODE:
    scplzv_(&n, vpx, vpy, vpz, &index);

void
scpmu(n, upx, upy, upz)
    integer n
    real *  upx
    real *  upy
    real *  upz
    CODE:
    scpmu_(&n, upx, upy, upz);

void
scpmv(n, vpx, vpy, vpz)
    integer n
    real *  vpx
    real *  vpy
    real *  vpz
    CODE:
    scpmv_(&n, vpx, vpy, vpz);

void
scqpmi(index)
    integer index
    CODE:
    scqpmi_(&index);

void
scqpms(rsize)
    real rsize
    CODE:
    scqpms_(&rsize);

void
scqpmt(itype)
    integer itype
    CODE:
    scqpmt_(&itype);

void
scspmi(index)
    integer index
    CODE:
    scspmi_(&index);

void
scspms(rsize)
    real rsize
    CODE:
    scspms_(&rsize);

void
scspmt(itype)
    integer itype
    CODE:
    scspmt_(&itype);

void
scpmzu(n, upx, upy, upz, itype, index, rsize)
    integer n
    real *  upx
    real *  upy
    real *  upz
    integer itype
    integer index
    real rsize
    CODE:
    scpmzu_(&n, upx, upy, upz, &itype, &index, &rsize);

void
scpmzv(n, vpx, vpy, vpz, itype, index, rsize)
    integer n
    real *  vpx
    real *  vpy
    real *  vpz
    integer itype
    integer index
    real rsize
    CODE:
    scpmzv_(&n, vpx, vpy, vpz, &itype, &index, &rsize);

void
scqeye(xeye3, yeye3, zeye3)
    real *  xeye3
    real *  yeye3
    real *  zeye3
    CODE:
    scqeye_(xeye3, yeye3, zeye3);

void
scseye(xeye3, yeye3, zeye3)
    real xeye3
    real yeye3
    real zeye3
    CODE:
    scseye_(&xeye3, &yeye3, &zeye3);

void
scqlog(lxlog3, lylog3, lzlog3)
    logical *  lxlog3
    logical *  lylog3
    logical *  lzlog3
    CODE:
    scqlog_(lxlog3, lylog3, lzlog3);

void
scslog(lxlog3, lylog3, lzlog3)
    logical lxlog3
    logical lylog3
    logical lzlog3
    CODE:
    scslog_(&lxlog3, &lylog3, &lzlog3);

void
scqobj(xobj3, yobj3, zobj3)
    real *  xobj3
    real *  yobj3
    real *  zobj3
    CODE:
    scqobj_(xobj3, yobj3, zobj3);

void
scsobj(xobj3, yobj3, zobj3)
    real xobj3
    real yobj3
    real zobj3
    CODE:
    scsobj_(&xobj3, &yobj3, &zobj3);

void
scqorg(simfac, vxorg3, vyorg3, vzorg3)
    real *  simfac
    real *  vxorg3
    real *  vyorg3
    real *  vzorg3
    CODE:
    scqorg_(simfac, vxorg3, vyorg3, vzorg3);

void
scsorg(simfac, vxorg3, vyorg3, vzorg3)
    real simfac
    real vxorg3
    real vyorg3
    real vzorg3
    CODE:
    scsorg_(&simfac, &vxorg3, &vyorg3, &vzorg3);

void
scqpln(ixax, iyax, sect)
    integer ixax
    integer iyax
    real *  sect
    CODE:
    scqpln_(&ixax, &iyax, sect);

void
scspln(ixax, iyax, sect)
    integer ixax
    integer iyax
    real sect
    CODE:
    scspln_(&ixax, &iyax, &sect);

void
scsprj()
    CODE:
    scsprj_();

void
scstrf()
    CODE:
    scstrf_();

integer
scqtrn(itr3)
    integer itr3
    CODE:
    scqtrn_(&itr3);
    RETVAL =     itr3;
    OUTPUT:
    RETVAL

void
scstrn(itr3)
    integer itr3
    CODE:
    scstrn_(&itr3);

void
scqvpt(vxmin, vxmax, vymin, vymax, vzmin, vzmax)
    real *  vxmin
    real *  vxmax
    real *  vymin
    real *  vymax
    real *  vzmin
    real *  vzmax
    CODE:
    scqvpt_(vxmin, vxmax, vymin, vymax, vzmin, vzmax);

void
scsvpt(vxmin, vxmax, vymin, vymax, vzmin, vzmax)
    real vxmin
    real vxmax
    real vymin
    real vymax
    real vzmin
    real vzmax
    CODE:
    scsvpt_(&vxmin, &vxmax, &vymin, &vymax, &vzmin, &vzmax);

void
scqwnd(uxmin, uxmax, uymin, uymax, uzmin, uzmax)
    real *  uxmin
    real *  uxmax
    real *  uymin
    real *  uymax
    real *  uzmin
    real *  uzmax
    CODE:
    scqwnd_(uxmin, uxmax, uymin, uymax, uzmin, uzmax);

void
scswnd(uxmin, uxmax, uymin, uymax, uzmin, uzmax)
    real uxmin
    real uxmax
    real uymin
    real uymax
    real uzmin
    real uzmax
    CODE:
    scswnd_(&uxmin, &uxmax, &uymin, &uymax, &uzmin, &uzmax);

void
scqtnp(itpat1, itpat2)
    integer *  itpat1
    integer *  itpat2
    CODE:
    scqtnp_(itpat1, itpat2);

void
scstnp(itpat1, itpat2)
    integer itpat1
    integer itpat2
    CODE:
   scstnp_(&itpat1, &itpat2);

void
sctnu(upx, upy, upz)
    real *  upx
    real *  upy
    real *  upz
    CODE:
    sctnu_(upx, upy, upz);

void
sctnv(vpx, vpy, vpz)
    real *  vpx
    real *  vpy
    real *  vpz
    CODE:
    sctnv_(vpx, vpy, vpz);

void
sctnzu(upx, upy, upz, itpat1, itpat2)
    real *  upx
    real *  upy
    real *  upz
    integer itpat1
    integer itpat2
    CODE:
    sctnzu_(upx, upy, upz, &itpat1, &itpat2);

void
sctnzv(vpx, vpy, vpz, itpat1, itpat2)
    real *  vpx
    real *  vpy
    real *  vpz
    integer itpat1
    integer itpat2
    CODE:
    sctnzv_(vpx, vpy, vpz, &itpat1, &itpat2);

void
sglar(rx1, ry1, rx2, ry2)
    real rx1
    real ry1
    real rx2
    real ry2
    CODE:
    sglar_(&rx1, &ry1, &rx2, &ry2);

void
sglau(ux1, uy1, ux2, uy2)
    real ux1
    real uy1
    real ux2
    real uy2
    CODE:
    sglau_(&ux1, &uy1, &ux2, &uy2);

void
sglav(vx1, vy1, vx2, vy2)
    real vx1
    real vy1
    real vx2
    real vy2
    CODE:
    sglav_(&vx1, &vy1, &vx2, &vy2);

integer
sgqlai()
    CODE:
    integer index;
    sgqlai_(&index);
    RETVAL =     index;
    OUTPUT:
    RETVAL

integer
sgqlat()
    CODE:
    integer itype;
    sgqlat_(&itype);
    RETVAL =     itype;
    OUTPUT:
    RETVAL

void
sgslai(index)
    integer index
    CODE:
    sgslai_(&index);

void
sgslat(itype)
    integer itype
    CODE:
    sgslat_(&itype);

void
sglazr(rx1, ry1, rx2, ry2, itype, index)
    real rx1
    real ry1
    real rx2
    real ry2
    integer itype
    integer index
    CODE:
    sglazr_(&rx1, &ry1, &rx2, &ry2, &itype, &index);

void
sglazu(ux1, uy1, ux2, uy2, itype, index)
    real ux1
    real uy1
    real ux2
    real uy2
    integer itype
    integer index
    CODE:
    sglazu_(&ux1, &uy1, &ux2, &uy2, &itype, &index);

void
sglazv(vx1, vy1, vx2, vy2, itype, index)
    real vx1
    real vy1
    real vx2
    real vy2
    integer itype
    integer index
    CODE:
    sglazv_(&vx1, &vy1, &vx2, &vy2, &itype, &index);

void
sglnr(rx1, ry1, rx2, ry2)
    real rx1
    real ry1
    real rx2
    real ry2
    CODE:
    sglnr_(&rx1, &ry1, &rx2, &ry2);

void
sglnu(ux1, uy1, ux2, uy2)
    real ux1
    real uy1
    real ux2
    real uy2
    CODE:
    sglnu_(&ux1, &uy1, &ux2, &uy2);

void
sglnv(vx1, vy1, vx2, vy2)
    real vx1
    real vy1
    real vx2
    real vy2
    CODE:
    sglnv_(&vx1, &vy1, &vx2, &vy2);

integer
sgqlni()
    CODE:
    integer index; 
    sgqlni_(&index);
    RETVAL =     index;
    OUTPUT:
    RETVAL

void
sgslni(index)
    integer index
    CODE:
    sgslni_(&index);

void
sglnzr(rx1, ry1, rx2, ry2, index)
    real rx1
    real ry1
    real rx2
    real ry2
    integer index
    CODE:
    sglnzr_(&rx1, &ry1, &rx2, &ry2, &index);

void
sglnzu(ux1, uy1, ux2, uy2, index)
    real ux1
    real uy1
    real ux2
    real uy2
    integer index
    CODE:
    sglnzu_(&ux1, &uy1, &ux2, &uy2, &index);

void
sglnzv(vx1, vy1, vx2, vy2, index)
    real vx1
    real vy1
    real vx2
    real vy2
    integer index
    CODE:
    sglnzv_(&vx1, &vy1, &vx2, &vy2, &index);

void
sgcls()
    CODE:
    sgcls_();

void
sgfrm()
    CODE:
    sgfrm_();

void
sginit()
    CODE:
    sginit_();

void
sgopn(iws)
    integer iws
    CODE:
    sgopn_(&iws);

integer
sgiget(cp)
    char *  cp 
    CODE:
    integer ipara;
    sgiget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
sgiset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    sgiset_(cp, &ipara, strlen(cp));

void
sgistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    sgistx_(cp, &ipara, strlen(cp));

logical
sglget(cp)
    char *  cp 
    CODE:
    logical ipara;
    sglget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
sglset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    sglset_(cp, &ipara, strlen(cp));

void
sglstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    sglstx_(cp, &ipara, strlen(cp));

void
sgpget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    sgpget_(cp, ipara, strlen(cp));

void
sgpset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    sgpset_(cp, ipara, strlen(cp));

void
sgpstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    sgpstx_(cp, ipara, strlen(cp));

real
sgrget(cp)
    char *  cp 
    CODE:
    real  ipara;
    sgrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
sgrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    sgrset_(cp, &ipara, strlen(cp));

void
sgrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    sgrstx_(cp, &ipara, strlen(cp));

void
sgplr(n, rpx, rpy)
    integer n
    real *  rpx
    real *  rpy
    CODE:
    sgplr_(&n, rpx, rpy);

void
sgplu(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    sgplu_(&n, upx, upy);

void
sgplv(n, vpx, vpy)
    integer n
    real *  vpx
    real *  vpy
    CODE:
    sgplv_(&n, vpx, vpy);

integer
sgqpli()
    CODE:
    integer index;
    sgqpli_(&index);
    RETVAL =     index;
    OUTPUT:
    RETVAL

integer
sgqplt()
    CODE:
    integer itype;
    sgqplt_(&itype);
    RETVAL =     itype;
    OUTPUT:
    RETVAL

void
sgspli(index)
    integer index
    CODE:
    sgspli_(&index);

void
sgsplt(itype)
    integer itype
    CODE:
    sgsplt_(&itype);

void
sgplzr(n, rpx, rpy, itype, index)
    integer n
    real *  rpx
    real *  rpy
    integer itype
    integer index
    CODE:
    sgplzr_(&n, rpx, rpy, &itype, &index);

void
sgplzu(n, upx, upy, itype, index)
    integer n
    real *  upx
    real *  upy
    integer itype
    integer index
    CODE:
    sgplzu_(&n, upx, upy, &itype, &index);

void
sgplzv(n, vpx, vpy, itype, index)
    integer n
    real *  vpx
    real *  vpy
    integer itype
    integer index
    CODE:
    sgplzv_(&n, vpx, vpy, &itype, &index);

void
sgpmr(n, rpx, rpy)
    integer n
    real *  rpx
    real *  rpy
    CODE:
    sgpmr_(&n, rpx, rpy);

void
sgpmu(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    sgpmu_(&n, upx, upy);

void
sgpmv(n, vpx, vpy)
    integer n
    real *  vpx
    real *  vpy
    CODE:
    sgpmv_(&n, vpx, vpy);

integer
sgqpmi()
    CODE:
    integer index;
    sgqpmi_(&index);
    RETVAL =     index;
    OUTPUT:
    RETVAL

real
sgqpms()
    CODE:
    real rsize;
    sgqpms_(&rsize);
    RETVAL =     rsize;
    OUTPUT:
    RETVAL

integer
sgqpmt()
    CODE:
    integer itype;
    sgqpmt_(&itype);
    RETVAL =     itype;
    OUTPUT:
    RETVAL

void
sgspmi(index)
    integer index
    CODE:
    sgspmi_(&index);

void
sgspms(rsize)
    real rsize
    CODE:
    sgspms_(&rsize);

void
sgspmt(itype)
    integer itype
    CODE:
    sgspmt_(&itype);

void
sgpmzr(n, rpx, rpy, itype, index, rsize)
    integer n
    real *  rpx
    real *  rpy
    integer itype
    integer index
    real rsize
    CODE:
    sgpmzr_(&n, rpx, rpy, &itype, &index, &rsize);

void
sgpmzu(n, upx, upy, itype, index, rsize)
    integer n
    real *  upx
    real *  upy
    integer itype
    integer index
    real rsize
    CODE:
    sgpmzu_(&n, upx, upy, &itype, &index, &rsize);

void
sgpmzv(n, vpx, vpy, itype, index, rsize)
    integer n
    real *  vpx
    real *  vpy
    integer itype
    integer index
    real rsize
    CODE:
    sgpmzv_(&n, vpx, vpy, &itype, &index, &rsize);

void
sgpqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    sgpqcp_(&idx, cp, strlen(cp));

void
sgpqid(cp, idx)
    char *  cp
    integer idx
    CODE:
    sgpqid_(cp, &idx, strlen(cp));

void
sgpqnp(ncp)
    integer ncp
    CODE:
    sgpqnp_(&ncp);

void
sgpqvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    sgpqvl_(&idx, &ipara);

void
sgpsvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    sgpsvl_(&idx, &ipara);

void
sgpwsn()
    CODE:
    sgpwsn_();

void
sgqmpl(plx, ply, plrot)
    real *  plx
    real *  ply
    real *  plrot
    CODE:
    sgqmpl_(plx, ply, plrot);

void
sgsmpl(plx, ply, plrot)
    real plx
    real ply
    real plrot
    CODE:
    sgsmpl_(&plx, &ply, &plrot);

void
sgnplc()
    CODE:
    sgnplc_();

void
sgqplc(charx)
    char *  charx
    CODE:
    sgqplc_(charx, strlen(charx));

real
sgqpls()
    CODE:
    real rsize;
    sgqpls_(&rsize);
    RETVAL =     rsize;
    OUTPUT:
    RETVAL

void
sgsplc(charx)
    char *  charx
    CODE:
    sgsplc_(charx, strlen(charx));

void
sgspls(rsize)
    real rsize
    CODE:
    sgspls_(&rsize);

void
sgqsim(simfac, vxoff, vyoff)
    real *  simfac
    real *  vxoff
    real *  vyoff
    CODE:
    sgqsim_(simfac, vxoff, vyoff);

void
sgssim(simfac, vxoff, vyoff)
    real simfac
    real vxoff
    real vyoff
    CODE:
    sgssim_(&simfac, &vxoff, &vyoff);

void
sgstrf()
    CODE:
    sgstrf_();

integer
sgqtrn()
    CODE:
    integer itr;
    sgqtrn_(&itr);
    RETVAL =     itr;
    OUTPUT:
    RETVAL

void
sgstrn(itr)
    integer itr
    CODE:
    sgstrn_(&itr);

void
sgqtxy(txmin, txmax, tymin, tymax)
    real *  txmin
    real *  txmax
    real *  tymin
    real *  tymax
    CODE:
    sgqtxy_(txmin, txmax, tymin, tymax);

void
sgstxy(txmin, txmax, tymin, tymax)
    real txmin
    real txmax
    real tymin
    real tymax
    CODE:
    sgstxy_(&txmin, &txmax, &tymin, &tymax);

void
sgqvpt(vxmin, vxmax, vymin, vymax)
    real *  vxmin
    real *  vxmax
    real *  vymin
    real *  vymax
    CODE:
    sgqvpt_(vxmin, vxmax, vymin, vymax);

void
sgsvpt(vxmin, vxmax, vymin, vymax)
    real vxmin
    real vxmax
    real vymin
    real vymax
    CODE:
    sgsvpt_(&vxmin, &vxmax, &vymin, &vymax);

void
sgqwnd(uxmin, uxmax, uymin, uymax)
    real *  uxmin
    real *  uxmax
    real *  uymin
    real *  uymax
    CODE:
    sgqwnd_(uxmin, uxmax, uymin, uymax);

void
sgswnd(uxmin, uxmax, uymin, uymax)
    real uxmin
    real uxmax
    real uymin
    real uymax
    CODE:
    sgswnd_(&uxmin, &uxmax, &uymin, &uymax);

integer
sgqtnp()
    CODE:
    integer itpat;
    sgqtnp_(&itpat);
    RETVAL =     itpat;
    OUTPUT:
    RETVAL

void
sgstnp(itpat)
    integer itpat
    CODE:
    sgstnp_(&itpat);

void
sgtnr(n, rpx, rpy)
    integer n
    real *  rpx
    real *  rpy
    CODE:
    sgtnr_(&n, rpx, rpy);

void
sgtnu(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    sgtnu_(&n, upx, upy);

void
sgtnv(n, vpx, vpy)
    integer n
    real *  vpx
    real *  vpy
    CODE:
    sgtnv_(&n, vpx, vpy);

void
sgtnzr(n, rpx, rpy, itpat)
    integer n
    real *  rpx
    real *  rpy
    integer itpat
    CODE:
    sgtnzr_(&n, rpx, rpy, &itpat);

void
sgtnzu(n, upx, upy, itpat)
    integer n
    real *  upx
    real *  upy
    integer itpat
    CODE:
    sgtnzu_(&n, upx, upy, &itpat);

void
sgtnzv(n, vpx, vpy, itpat)
    integer n
    real *  vpx
    real *  vpy
    integer itpat
    CODE:
    sgtnzv_(&n, vpx, vpy, &itpat);

integer
sgtrln(ctl)
    char *  ctl 
    CODE:
    integer ntx;
    sgtrln_(ctl, &ntx, strlen(ctl));
    RETVAL =     ntx;
    OUTPUT:
    RETVAL

void
sgtrls(ctl, cts)
    char *  ctl
    char *  cts
    CODE:
    sgtrls_(ctl, cts, strlen(ctl), strlen(cts));

void
sgtrnl(ntx, ctl)
    integer ntx
    char *  ctl
    CODE:
    sgtrnl_(&ntx, ctl, strlen(ctl));

void
sgtrns(ntx, cts)
    integer ntx
    char *  cts
    CODE:
    sgtrns_(&ntx, cts, strlen(cts));

logical
sgtrqf(ntx)
    integer ntx 
    CODE:
    logical ltr;
    sgtrqf_(&ntx, &ltr);
    RETVAL =     ltr;
    OUTPUT:
    RETVAL

void
sgtrsl(cts, ctl)
    char *  cts
    char *  ctl
    CODE:
    sgtrsl_(cts, ctl, strlen(cts), strlen(ctl));

integer
sgtrsn(cts)
    char *  cts 
    CODE:
    integer ntx;
    sgtrsn_(cts, &ntx, strlen(cts));
    RETVAL =     ntx;
    OUTPUT:
    RETVAL

integer
sgqtxc()
    CODE:
    integer icent;
    sgqtxc_(&icent);
    RETVAL =     icent;
    OUTPUT:
    RETVAL

integer
sgqtxi()
    CODE:
    integer index;
    sgqtxi_(&index);
    RETVAL =     index;
    OUTPUT:
    RETVAL

integer
sgqtxr()
    CODE:
    integer irota;
    sgqtxr_(&irota);
    RETVAL =     irota;
    OUTPUT:
    RETVAL

real
sgqtxs()
    CODE:
    real rsize;
    sgqtxs_(&rsize);
    RETVAL =     rsize;
    OUTPUT:
    RETVAL

void
sgstxc(icent)
    integer icent
    CODE:
    sgstxc_(&icent);

void
sgstxi(index)
    integer index
    CODE:
    sgstxi_(&index);

void
sgstxr(irota)
    integer irota
    CODE:
    sgstxr_(&irota);

void
sgstxs(rsize)
    real rsize
    CODE:
    sgstxs_(&rsize);

void
sgtxr(rx, ry, chars)
    real rx
    real ry
    char *  chars
    CODE:
    sgtxr_(&rx, &ry, chars, strlen(chars));

void
sgtxu(ux, uy, chars)
    real ux
    real uy
    char *  chars
    CODE:
    sgtxu_(&ux, &uy, chars, strlen(chars));

void
sgtxv(vx, vy, chars)
    real vx
    real vy
    char *  chars
    CODE:
    sgtxv_(&vx, &vy, chars, strlen(chars));

void
sgtxzr(rx, ry, chars, rsize, irota, icent, index)
    real rx
    real ry
    char *  chars
    real rsize
    integer irota
    integer icent
    integer index
    CODE:
    sgtxzr_(&rx, &ry, chars, &rsize, &irota, &icent, &index, strlen(chars));

void
sgtxzu(ux, uy, chars, rsize, irota, icent, index)
    real ux
    real uy
    char *  chars
    real rsize
    integer irota
    integer icent
    integer index
    CODE:
    sgtxzu_(&ux, &uy, chars, &rsize, &irota, &icent, &index, strlen(chars));

void
sgtxzv(vx, vy, chars, rsize, irota, icent, index)
    real vx
    real vy
    char *  chars
    real rsize
    integer irota
    integer icent
    integer index
    CODE:
    sgtxzv_(&vx, &vy, chars, &rsize, &irota, &icent, &index, strlen(chars));

void
slinit(wxmax, wymax, fact)
    real wxmax
    real wymax
    real fact
    CODE:
    slinit_(&wxmax, &wymax, &fact);

void
slsize(cszez)
    char *  cszez
    CODE:
    slsize_(cszez, strlen(cszez));

void
slform(dxa, dya)
    real dxa
    real dya
    CODE:
    slform_(&dxa, &dya);

void
sldiv(cform, ix, iy)
    char *  cform
    integer ix
    integer iy
    CODE:
    sldiv_(cform, &ix, &iy, strlen(cform));

void
slmgn(xl, xr, yb, yt)
    real xl
    real xr
    real yb
    real yt
    CODE:
    slmgn_(&xl, &xr, &yb, &yt);

void
slrat(rx, ry)
    real rx
    real ry
    CODE:
    slrat_(&rx, &ry);

void
slpvpc(index, rc)
    integer index
    real rc
    CODE:
    slpvpc_(&index, &rc);

void
slpvpr(index)
    integer index
    CODE:
    slpvpr_(&index);

void
slpwvc(index, rc)
    integer index
    real rc
    CODE:
    slpwvc_(&index, &rc);

void
slpwvr(index)
    integer index
    CODE:
    slpwvr_(&index);

void
slpwwc(index, rc)
    integer index
    real rc
    CODE:
    slpwwc_(&index, &rc);

void
slpwwr(index)
    integer index
    CODE:
    slpwwr_(&index);

void
sldttl(nt)
    integer nt
    CODE:
    sldttl_(&nt);

void
slsttl(cttl, cside, px, py, ht, nt)
    char *  cttl
    char *  cside
    real px
    real py
    real ht
    integer nt
    CODE:
    slsttl_(cttl, cside, &px, &py, &ht, &nt, strlen(cttl), strlen(cside));

void
stepr2()
    CODE:
    stepr2_();

void
stfpr2(x, y, rx, ry)
    real x
    real y
    real *  rx
    real *  ry
    CODE:
    stfpr2_(&x, &y, rx, ry);

void
stfpr3(x, y, z__, rx, ry)
    real x
    real y
    real z__
    real *  rx
    real *  ry
    CODE:
    stfpr3_(&x, &y, &z__, rx, ry);

void
stipr2(rx, ry, x, y)
    real rx
    real ry
    real *  x
    real *  y
    CODE:
    stipr2_(&rx, &ry, x, y);

void
strpr2()
    CODE:
    strpr2_();

void
stspr2(ix, iy, sect)
    integer ix
    integer iy
    real sect
    CODE:
    stspr2_(&ix, &iy, &sect);

void
stspr3(xfc, yfc, zfc, theta, phi, psi, fac, zview, rxoff, ryoff)
    real xfc
    real yfc
    real zfc
    real theta
    real phi
    real psi
    real fac
    real zview
    real rxoff
    real ryoff
    CODE:
    stspr3_(&xfc, &yfc, &zfc, &theta, &phi, &psi, &fac, &zview, &rxoff, &ryoff);

void
stfrad(x, y, rx, ry)
    real x
    real y
    real *  rx
    real *  ry
    CODE:
    stfrad_(&x, &y, rx, ry);

void
stirad(rx, ry, x, y)
    real rx
    real ry
    real *  x
    real *  y
    CODE:
    stirad_(&rx, &ry, x, y);

void
stsrad(lxdeg, lydeg)
    logical lxdeg
    logical lydeg
    CODE:
    stsrad_(&lxdeg, &lydeg);

void
stfrot(ux, uy, tx, ty)
    real ux
    real uy
    real *  tx
    real *  ty
    CODE:
    stfrot_(&ux, &uy, tx, ty);

void
stirot(tx, ty, ux, uy)
    real tx
    real ty
    real *  ux
    real *  uy
    CODE:
    stirot_(&tx, &ty, ux, uy);

void
stsrot(theta, phi, psi)
    real theta
    real phi
    real psi
    CODE:
    stsrot_(&theta, &phi, &psi);

void
stftr3(ux, uy, uz, vx, vy, vz)
    real ux
    real uy
    real uz
    real *  vx
    real *  vy
    real *  vz
    CODE:
    stftr3_(&ux, &uy, &uz, vx, vy, vz);

void
stslg3(lxlg, lylg, lzlg)
    logical lxlg
    logical lylg
    logical lzlg
    CODE:
    stslg3_(&lxlg, &lylg, &lzlg);

void
stsrd3(lxrd, lyrd, lzrd)
    logical lxrd
    logical lyrd
    logical lzrd
    CODE:
    stsrd3_(&lxrd, &lyrd, &lzrd);

void
ststr3(itr, cxa, cya, cza, vxoff, vyoff, vzoff)
    integer itr
    real cxa
    real cya
    real cza
    real vxoff
    real vyoff
    real vzoff
    CODE:
    ststr3_(&itr, &cxa, &cya, &cza, &vxoff, &vyoff, &vzoff);

void
stftrf(ux, uy, vx, vy)
    real ux
    real uy
    real *  vx
    real *  vy
    CODE:
    stftrf_(&ux, &uy, vx, vy);

void
stitrf(vx, vy, ux, uy)
    real vx
    real vy
    real *  ux
    real *  uy
    CODE:
    stitrf_(&vx, &vy, ux, uy);

logical
stqtrf()
    CODE:
    logical lmapa;
    stqtrf_(&lmapa);
    RETVAL =     lmapa;
    OUTPUT:
    RETVAL

void
ststrf(lmapa)
    logical lmapa
    CODE:
    ststrf_(&lmapa);

void
stftrn(ux, uy, vx, vy)
    real ux
    real uy
    real *  vx
    real *  vy
    CODE:
    stftrn_(&ux, &uy, vx, vy);

void
stitrn(vx, vy, ux, uy)
    real vx
    real vy
    real *  ux
    real *  uy
    CODE:
    stitrn_(&vx, &vy, ux, uy);

void
ststrn(itr, cxa, cya, vxoff, vyoff)
    integer itr
    real cxa
    real cya
    real vxoff
    real vyoff
    CODE:
    ststrn_(&itr, &cxa, &cya, &vxoff, &vyoff);

void
stfwtr(rx, ry, wx, wy)
    real rx
    real ry
    real *  wx
    real *  wy
    CODE:
    stfwtr_(&rx, &ry, wx, wy);

void
stiwtr(wx, wy, rx, ry)
    real wx
    real wy
    real *  rx
    real *  ry
    CODE:
    stiwtr_(&wx, &wy, rx, ry);

void
stqwrc(wsxmn, wsxmx, wsymn, wsymx)
    real *  wsxmn
    real *  wsxmx
    real *  wsymn
    real *  wsymx
    CODE:
    stqwrc_(wsxmn, wsxmx, wsymn, wsymx);

void
stqwtr(rxmin, rxmax, rymin, rymax, wxmin, wxmax, wymin, wymax, iwtrf)
    real *  rxmin
    real *  rxmax
    real *  rymin
    real *  rymax
    real *  wxmin
    real *  wxmax
    real *  wymin
    real *  wymax
    integer *  iwtrf
    CODE:
    stqwtr_(rxmin, rxmax, rymin, rymax, wxmin, wxmax, wymin, wymax, iwtrf);

void
stswrc(wsxmn, wsxmx, wsymn, wsymx)
    real wsxmn
    real wsxmx
    real wsymn
    real wsymx
    CODE:
    stswrc_(&wsxmn, &wsxmx, &wsymn, &wsymx);

void
stswtr(rxmin, rxmax, rymin, rymax, wxmin, wxmax, wymin, wymax, iwtrf)
    real rxmin
    real rxmax
    real rymin
    real rymax
    real wxmin
    real wxmax
    real wymin
    real wymax
    integer iwtrf
    CODE:
    stswtr_(&rxmin, &rxmax, &rymin, &rymax, &wxmin, &wxmax, &wymin, &wymax, &iwtrf);

void
swcget(cp, cpara)
    char *  cp
    char *  cpara
    CODE:
    swcget_(cp, cpara, strlen(cp), strlen(cpara));

void
swcset(cp, cpara)
    char *  cp
    char *  cpara
    CODE:
    swcset_(cp, cpara, strlen(cp), strlen(cpara));

void
swcstx(cp, cpara)
    char *  cp
    char *  cpara
    CODE:
    swcstx_(cp, cpara, strlen(cp), strlen(cpara));

void
swdcls()
    CODE:
    swdcls_();

void
swdopn()
    CODE:
    swdopn_();

void
swfint(wx, wy, iwx, iwy)
    real wx
    real wy
    integer *  iwx
    integer *  iwy
    CODE:
    swfint_(&wx, &wy, iwx, iwy);

void
swgcls()
    CODE:
    swgcls_();

void
swgmov(wx, wy)
    real wx
    real wy
    CODE:
    swgmov_(&wx, &wy);

void
swgopn()
    CODE:
    swgopn_();

void
swgplt(wx, wy)
    real wx
    real wy
    CODE:
    swgplt_(&wx, &wy);

void
swgton(np, wpx, wpy, itpat)
    integer np
    real wpx
    real wpy
    integer itpat
    CODE:
    swgton_(&np, &wpx, &wpy, &itpat);

void
swicls()
    CODE:
    swicls_();

void
swidat(image, nlen)
    integer image
    integer nlen
    CODE:
    swidat_(&image, &nlen);

void
swiint(iwx, iwy, wx, wy)
    integer iwx
    integer iwy
    real *  wx
    real *  wy
    CODE:
    swiint_(&iwx, &iwy, wx, wy);

void
swiopn(iwx, iwy, imw, imh)
    integer iwx
    integer iwy
    integer imw
    integer imh
    CODE:
    swiopn_(&iwx, &iwy, &imw, &imh);

void
swocls(cobj)
    char *  cobj
    CODE:
    swocls_(cobj, strlen(cobj));

void
swoopn(cobj, comm)
    char *  cobj
    char *  comm
    CODE:
    swoopn_(cobj, comm, strlen(cobj), strlen(comm));

void
swpcls()
    CODE:
    swpcls_();

void
swpopn()
    CODE:
    swpopn_();

logical
swqclc()
    CODE:
    logical lclatr;
    swqclc_(&lclatr);
    RETVAL =     lclatr;
    OUTPUT:
    RETVAL

logical
swqimc()
    CODE:
    logical limatr;
    swqimc_(&limatr);
    RETVAL =     limatr;
    OUTPUT:
    RETVAL

void
swqpnt(wx, wy, mb)
    real *  wx
    real *  wy
    integer *  mb
    CODE:
    swqpnt_(wx, wy, mb);

logical
swqptc()
    CODE:
    logical lptatr;
    swqptc_(&lptatr);
    RETVAL =     lptatr;
    OUTPUT:
    RETVAL

void
swqrct(wsxmn, wsxmx, wsymn, wsymx, fact)
    real *  wsxmn
    real *  wsxmx
    real *  wsymn
    real *  wsymx
    real *  fact
    CODE:
    swqrct_(wsxmn, wsxmx, wsymn, wsymx, fact);

logical
swqtnc()
    CODE:
    logical ltnatr;
    swqtnc_(&ltnatr);
    RETVAL =     ltnatr;
    OUTPUT:
    RETVAL

logical
swqwdc()
    CODE:
    logical lwdatr;
    swqwdc_(&lwdatr);
    RETVAL =     lwdatr;
    OUTPUT:
    RETVAL

void
swscli(iclidx)
    integer iclidx
    CODE:
    swscli_(&iclidx);

void
swsrot(iwtrot)
    integer iwtrot
    CODE:
    swsrot_(&iwtrot);

void
swswdi(iwdidx)
    integer iwdidx
    CODE:
    swswdi_(&iwdidx);

integer
swiget(cp)
    char *  cp 
    CODE:
    integer ipara;
    swiget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
swiset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    swiset_(cp, &ipara, strlen(cp));

void
swistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    swistx_(cp, &ipara, strlen(cp));

logical
swlget(cp)
    char *  cp 
    CODE:
    logical ipara;
    swlget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
swlset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    swlset_(cp, &ipara, strlen(cp));

void
swlstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    swlstx_(cp, &ipara, strlen(cp));

void
swpget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    swpget_(cp, ipara, strlen(cp));

void
swpset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    swpset_(cp, ipara, strlen(cp));

void
swpstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    swpstx_(cp, ipara, strlen(cp));

real
swrget(cp)
    char *  cp 
    CODE:
    real ipara;
    swrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
swrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    swrset_(cp, &ipara, strlen(cp));

void
swrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    swrstx_(cp, &ipara, strlen(cp));

void
swqfnm(cpara, cfname)
    char *  cpara
    char *  cfname
    CODE:
    swqfnm_(cpara, cfname, strlen(cpara), strlen(cfname));

void
szcltn(icpat, maxcli)
    integer icpat
    integer maxcli
    CODE:
    szcltn_(&icpat, &maxcli);

void
szfont(ifont, iposx, nchar, ckx, cky, len)
    integer ifont
    integer iposx
    integer nchar
    char *  ckx
    char *  cky
    integer len
    CODE:
    szfont_(&ifont, &iposx, &nchar, ckx, cky, &len, strlen(ckx), strlen(cky));

void
szl3cl()
    CODE:
    szl3cl_();

void
szl3op(index)
    integer index
    CODE:
    szl3op_(&index);

void
szl3zu(n, u3x, u3y, u3z)
    integer n
    real *  u3x
    real *  u3y
    real *  u3z
    CODE:
    szl3zu_(&n, u3x, u3y, u3z);

void
szl3zv(n, v3x, v3y, v3z)
    integer n
    real *  v3x
    real *  v3y
    real *  v3z
    CODE:
    szl3zv_(&n, v3x, v3y, v3z);

void
szlacl()
    CODE:
    szlacl_();

void
szlaop(itype, index)
    integer itype
    integer index
    CODE:
    szlaop_(&itype, &index);

void
szlazr(rx1, ry1, rx2, ry2)
    real rx1
    real ry1
    real rx2
    real ry2
    CODE:
    szlazr_(&rx1, &ry1, &rx2, &ry2);

void
szlazu(ux1, uy1, ux2, uy2)
    real ux1
    real uy1
    real ux2
    real uy2
    CODE:
    szlazu_(&ux1, &uy1, &ux2, &uy2);

void
szlazv(vx1, vy1, vx2, vy2)
    real vx1
    real vy1
    real vx2
    real vy2
    CODE:
    szlazv_(&vx1, &vy1, &vx2, &vy2);

void
szlncl()
    CODE:
    szlncl_();

void
szlnop(index)
    integer index
    CODE:
    szlnop_(&index);

void
szlnzr(rx1, ry1, rx2, ry2)
    real rx1
    real ry1
    real rx2
    real ry2
    CODE:
    szlnzr_(&rx1, &ry1, &rx2, &ry2);

void
szlnzu(ux1, uy1, ux2, uy2)
    real ux1
    real uy1
    real ux2
    real uy2
    CODE:
    szlnzu_(&ux1, &uy1, &ux2, &uy2);

void
szlnzv(vx1, vy1, vx2, vy2)
    real vx1
    real vy1
    real vx2
    real vy2
    CODE:
    szlnzv_(&vx1, &vy1, &vx2, &vy2);

void
szm3cl()
    CODE:
    szm3cl_();

void
szm3op(itype, index, rsize)
    integer itype
    integer index
    real rsize
    CODE:
    szm3op_(&itype, &index, &rsize);

void
szm3zu(n, upx, upy, upz)
    integer n
    real *  upx
    real *  upy
    real *  upz
    CODE:
    szm3zu_(&n, upx, upy, upz);

void
szm3zv(n, vpx, vpy, vpz)
    integer n
    real *  vpx
    real *  vpy
    real *  vpz
    CODE:
    szm3zv_(&n, vpx, vpy, vpz);

void
szcll3()
    CODE:
    szcll3_();

void
szmvl3(sx, sy, sz)
    real sx
    real sy
    real sz
    CODE:
    szmvl3_(&sx, &sy, &sz);

void
szopl3()
    CODE:
    szopl3_();

void
szpll3(sx, sy, sz)
    real sx
    real sy
    real sz
    CODE:
    szpll3_(&sx, &sy, &sz);

void
szcllc()
    CODE:
    szcllc_();

void
szcrst()
    CODE:
    szcrst_();

void
szmvlc(vx, vy)
    real vx
    real vy
    CODE:
    szmvlc_(&vx, &vy);

void
szoplc()
    CODE:
    szoplc_();

void
szpllc(vx, vy)
    real vx
    real vy
    CODE:
    szpllc_(&vx, &vy);

void
szclld()
    CODE:
    szclld_();

void
szmvld(vx, vy)
    real vx
    real vy
    CODE:
    szmvld_(&vx, &vy);

void
szopld()
    CODE:
    szopld_();

void
szplld(vx, vy)
    real vx
    real vy
    CODE:
    szplld_(&vx, &vy);

integer
szqtyz()
    CODE:
    integer ipat;
    szqtyz_(&ipat);
    RETVAL =     ipat;
    OUTPUT:
    RETVAL

void
szstyz(ipat)
    integer ipat
    CODE:
    szstyz_(&ipat);

void
szcllp()
    CODE:
    szcllp_();

void
szmvlp(vx, vy)
    real vx
    real vy
    CODE:
    szmvlp_(&vx, &vy);

void
szoplp()
    CODE:
    szoplp_();

void
szpllp(vx, vy)
    real vx
    real vy
    CODE:
    szpllp_(&vx, &vy);

void
szcllr()
    CODE:
    szcllr_();

void
szmvlr(rx, ry)
    real rx
    real ry
    CODE:
    szmvlr_(&rx, &ry);

void
szoplr()
    CODE:
    szoplr_();

void
szpllr(rx, ry)
    real rx
    real ry
    CODE:
    szpllr_(&rx, &ry);

void
szcllt()
    CODE:
    szcllt_();

void
szmvlt(tx, ty)
    real tx
    real ty
    CODE:
    szmvlt_(&tx, &ty);

void
szoplt()
    CODE:
    szoplt_();

void
szpllt(tx, ty)
    real tx
    real ty
    CODE:
    szpllt_(&tx, &ty);

void
szcllu()
    CODE:
    szcllu_();

void
szmvlu(ux, uy)
    real ux
    real uy
    CODE:
    szmvlu_(&ux, &uy);

void
szoplu()
    CODE:
    szoplu_();

void
szpllu(ux, uy)
    real ux
    real uy
    CODE:
    szpllu_(&ux, &uy);

void
szcllv()
    CODE:
    szcllv_();

void
szmvlv(vx, vy)
    real vx
    real vy
    CODE:
    szmvlv_(&vx, &vy);

void
szoplv()
    CODE:
    szoplv_();

void
szpllv(vx, vy)
    real vx
    real vy
    CODE:
    szpllv_(&vx, &vy);

void
szcllz()
    CODE:
    szcllz_();

void
szmvlz(rx, ry)
    real rx
    real ry
    CODE:
    szmvlz_(&rx, &ry);

void
szoplz()
    CODE:
    szoplz_();

void
szpllz(rx, ry)
    real rx
    real ry
    CODE:
    szpllz_(&rx, &ry);

void
szclsv()
    CODE:
    szclsv_();

void
szmvsv(vx, vy)
    real vx
    real vy
    CODE:
    szmvsv_(&vx, &vy);

void
szopsv()
    CODE:
    szopsv_();

void
szplsv(vx, vy)
    real vx
    real vy
    CODE:
    szplsv_(&vx, &vy);

void
szcltp()
    CODE:
    szcltp_();

void
szoptp()
    CODE:
    szoptp_();

logical
szqtmd()
    CODE:
    logical lhard;
    szqtmd_(&lhard);
    RETVAL =     lhard;
    OUTPUT:
    RETVAL

void
szstmd(lhard)
    logical lhard
    CODE:
    szstmd_(&lhard);

void
szsttp(vx, vy)
    real vx
    real vy
    CODE:
    szsttp_(&vx, &vy);

void
szcltr()
    CODE:
    szcltr_();

void
szoptr()
    CODE:
    szoptr_();

void
szsttr(rx, ry)
    real rx
    real ry
    CODE:
    szsttr_(&rx, &ry);

void
szclts()
    CODE:
    szclts_();

void
szopts()
    CODE:
    szopts_();

void
szstts(vx, vy)
    real vx
    real vy
    CODE:
    szstts_(&vx, &vy);

void
sztits(itpat)
    integer itpat
    CODE:
    sztits_(&itpat);

void
szcltt()
    CODE:
    szcltt_();

void
szoptt()
    CODE:
    szoptt_();

void
szsttt(tx, ty)
    real tx
    real ty
    CODE:
    szsttt_(&tx, &ty);

void
szcltu()
    CODE:
    szcltu_();

void
szoptu()
    CODE:
    szoptu_();

void
szsttu(ux, uy)
    real ux
    real uy
    CODE:
    szsttu_(&ux, &uy);

void
szcltv()
    CODE:
    szcltv_();

void
szoptv()
    CODE:
    szoptv_();

void
szsttv(vx, vy)
    real vx
    real vy
    CODE:
    szsttv_(&vx, &vy);

void
szcltz()
    CODE:
    szcltz_();

void
szoptz()
    CODE:
    szoptz_();

void
szsttz(rx, ry)
    real rx
    real ry
    CODE:
    szsttz_(&rx, &ry);

void
sztitz(itpat)
    integer itpat
    CODE:
    sztitz_(&itpat);

void
szplcl()
    CODE:
    szplcl_();

void
szplop(itype, index)
    integer itype
    integer index
    CODE:
    szplop_(&itype, &index);

void
szplzr(n, rpx, rpy)
    integer n
    real *  rpx
    real *  rpy
    CODE:
    szplzr_(&n, rpx, rpy);

void
szplzu(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    szplzu_(&n, upx, upy);

void
szplzv(n, vpx, vpy)
    integer n
    real *  vpx
    real *  vpy
    CODE:
    szplzv_(&n, vpx, vpy);

void
szpmcl()
    CODE:
    szpmcl_();

void
szpmop(itype, index, rsize)
    integer itype
    integer index
    real rsize
    CODE:
    szpmop_(&itype, &index, &rsize);

void
szpmzr(n, rpx, rpy)
    integer n
    real *  rpx
    real *  rpy
    CODE:
    szpmzr_(&n, rpx, rpy);

void
szpmzu(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    szpmzu_(&n, upx, upy);

void
szpmzv(n, vpx, vpy)
    integer n
    real *  vpx
    real *  vpy
    CODE:
    szpmzv_(&n, vpx, vpy);

void
szsidx(index)
    integer index
    CODE:
    szsidx_(&index);

void
szslti(itype, index)
    integer itype
    integer index
    CODE:
    szslti_(&itype, &index);

integer
szqtni()
    CODE:
    integer itpat;
    szqtni_(&itpat);
    RETVAL =     itpat;
    OUTPUT:
    RETVAL

void
szstni(itpat)
    integer itpat
    CODE:
    szstni_(&itpat);

void
szt3cl()
    CODE:
    szt3cl_();

integer
szqtyp()
    CODE:
    integer itype;
    szqtyp_(&itype);
    RETVAL =     itype;
    OUTPUT:
    RETVAL

void
szstyp(itype)
    integer itype
    CODE:
    szstyp_(&itype);

void
szt3op(itpat1, itpat2)
    integer itpat1
    integer itpat2
    CODE:
    szt3op_(&itpat1, &itpat2);

void
szt3zu(upx, upy, upz)
    real upx
    real upy
    real upz
    CODE:
    szt3zu_(&upx, &upy, &upz);

void
szt3zv(vpx, vpy, vpz)
    real vpx
    real vpy
    real vpz
    CODE:
    szt3zv_(&vpx, &vpy, &vpz);

void
sztncl()
    CODE:
    sztncl_();

void
sztnop(itpat)
    integer itpat
    CODE:
    sztnop_(&itpat);

void
sztnzr(n, rpx, rpy)
    integer n
    real *  rpx
    real *  rpy
    CODE:
    sztnzr_(&n, rpx, rpy);

void
sztnzu(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    sztnzu_(&n, upx, upy);

void
sztnzv(n, vpx, vpy)
    integer n
    real *  vpx
    real *  vpy
    CODE:
    sztnzv_(&n, vpx, vpy);

void
sztxcl()
    CODE:
    sztxcl_();

void
sztxop(rsize, irota, icent, index)
    real rsize
    integer irota
    integer icent
    integer index
    CODE:
    sztxop_(&rsize, &irota, &icent, &index);

void
sztxwv(vx, vy, chars)
    real vx
    real vy
    char *  chars
    CODE:
    sztxwv_(&vx, &vy, chars, strlen(chars));

void
sztxzr(rx, ry, chars)
    real rx
    real ry
    char *  chars
    CODE:
    sztxzr_(&rx, &ry, chars, strlen(chars));

void
sztxzu(ux, uy, chars)
    real ux
    real uy
    char *  chars
    CODE:
    sztxzu_(&ux, &uy, chars, strlen(chars));

void
sztxzv(vx, vy, chars)
    real vx
    real vy
    char *  chars
    CODE:
    sztxzv_(&vx, &vy, chars, strlen(chars));

doublereal
szxmod(x)
    real x
    CODE:
    RETVAL =     szxmod_(&x);
    OUTPUT:
    RETVAL

void
csblbl(ret_val, ufac, uoff, cunit__)
    char *  ret_val
    real *  ufac
    real *  uoff
    char *  cunit__
    CODE:
    csblbl_(ret_val, strlen(ret_val), ufac, uoff, cunit__,
	    strlen(cunit__));

void
grinit()
    CODE:
    grinit_();

void
grcls()
    CODE:
    grcls_();

void
grfig()
    CODE:
    grfig_();

void
grfrm()
    CODE:
    grfrm_();

void
gropn(iws)
    integer iws
    CODE:
    gropn_(&iws);

void
grsmpl(plx, ply, plrot)
    real plx
    real ply
    real plrot
    CODE:
    grsmpl_(&plx, &ply, &plrot);

void
grssim(simfac, vxoff, vyoff)
    real simfac
    real vxoff
    real vyoff
    CODE:
    grssim_(&simfac, &vxoff, &vyoff);

void
grstrf()
    CODE:
    grstrf_();

void
grstrn(itr)
    integer itr
    CODE:
    grstrn_(&itr);

void
grstxy(txmin, txmax, tymin, tymax)
    real txmin
    real txmax
    real tymin
    real tymax
    CODE:
    grstxy_(&txmin, &txmax, &tymin, &tymax);

void
grsvpt(vxmin, vxmax, vymin, vymax)
    real vxmin
    real vxmax
    real vymin
    real vymax
    CODE:
    grsvpt_(&vxmin, &vxmax, &vymin, &vymax);

void
grswnd(uxmin, uxmax, uymin, uymax)
    real uxmin
    real uxmax
    real uymin
    real uymax
    CODE:
    grswnd_(&uxmin, &uxmax, &uymin, &uymax);

integer
iueton(zlev)
    real zlev
    CODE:
    RETVAL =     iueton_(&zlev);
    OUTPUT:
    RETVAL

integer
iuwgx(ux)
    real ux
    CODE:
    RETVAL =     iuwgx_(&ux);
    OUTPUT:
    RETVAL

integer
iuwgy(uy)
    real uy
    CODE:
    RETVAL =     iuwgy_(&uy);
    OUTPUT:
    RETVAL

doublereal
rudlev(nlev)
    integer nlev
    CODE:
    RETVAL =     rudlev_(&nlev);
    OUTPUT:
    RETVAL

doublereal
ruwgx(ix)
    integer ix
    CODE:
    RETVAL =     ruwgx_(&ix);
    OUTPUT:
    RETVAL

doublereal
ruwgy(iy)
    integer iy
    CODE:
    RETVAL =     ruwgy_(&iy);
    OUTPUT:
    RETVAL

integer
uciget(cp)
    char *  cp 
    CODE:
    integer ipara;
    uciget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uciset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    uciset_(cp, &ipara, strlen(cp));

void
ucistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    ucistx_(cp, &ipara, strlen(cp));

logical
uclget(cp)
    char *  cp 
    CODE:
    logical ipara;
    uclget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uclset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uclset_(cp, &ipara, strlen(cp));

void
uclstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uclstx_(cp, &ipara, strlen(cp));

void
ucpget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    ucpget_(cp, ipara, strlen(cp));

void
ucpset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    ucpset_(cp, ipara, strlen(cp));

void
ucpstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    ucpstx_(cp, ipara, strlen(cp));

real
ucrget(cp)
    char *  cp 
    CODE:
    real ipara;
    ucrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
ucrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    ucrset_(cp, &ipara, strlen(cp));

void
ucrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    ucrstx_(cp, &ipara, strlen(cp));

void
ucpqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    ucpqcp_(&idx, cp, strlen(cp));

void
ucpqid(cp, idx)
    char *  cp
    integer idx
    CODE:
    ucpqid_(cp, &idx, strlen(cp));

void
ucpqnp(ncp)
    integer ncp
    CODE:
    ucpqnp_(&ncp);

void
ucpqvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    ucpqvl_(&idx, &ipara);

void
ucpsvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    ucpsvl_(&idx, &ipara);

void
ucxacl(cside, jd0, nd)
    char *  cside
    integer jd0
    integer nd
    CODE:
    ucxacl_(cside, &jd0, &nd, strlen(cside));

void
ucxady(cside, jd0, nd)
    char *  cside
    integer jd0
    integer nd
    CODE:
    ucxady_(cside, &jd0, &nd, strlen(cside));

void
ucxamn(cside, jd0, nd)
    char *  cside
    integer jd0
    integer nd
    CODE:
    ucxamn_(cside, &jd0, &nd, strlen(cside));

void
ucxayr(cside, jd0, nd)
    char *  cside
    integer jd0
    integer nd
    CODE:
    ucxayr_(cside, &jd0, &nd, strlen(cside));

void
ucyacl(cside, jd0, nd)
    char *  cside
    integer jd0
    integer nd
    CODE:
    ucyacl_(cside, &jd0, &nd, strlen(cside));

void
ucyady(cside, jd0, nd)
    char *  cside
    integer jd0
    integer nd
    CODE:
    ucyady_(cside, &jd0, &nd, strlen(cside));

void
ucyamn(cside, jd0, nd)
    char *  cside
    integer jd0
    integer nd
    CODE:
    ucyamn_(cside, &jd0, &nd, strlen(cside));

void
ucyayr(cside, jd0, nd)
    char *  cside
    integer jd0
    integer nd
    CODE:
    ucyayr_(cside, &jd0, &nd, strlen(cside));

void
udcntr(z__, mx, nx, ny)
    real *  z__
    integer mx
    integer nx
    integer ny
    CODE:
    udcntr_(z__, &mx, &nx, &ny);

void
udcntz(z__, mx, nx, ny, ibr, nbr2)
    real *  z__
    integer mx
    integer nx
    integer ny
    integer ibr
    integer nbr2
    CODE:
    udcntz_(z__, &mx, &nx, &ny, &ibr, &nbr2);

void
udgcla(xmin, xmax, dx)
    real xmin
    real xmax
    real dx
    CODE:
    udgcla_(&xmin, &xmax, &dx);

void
udgclb(z__, mx, nx, ny, dx)
    real *  z__
    integer mx
    integer nx
    integer ny
    real dx
    CODE:
    udgclb_(z__, &mx, &nx, &ny, &dx);

void
udgrdn(mode, ix, iy, k, jx, jy, jk)
    integer mode
    integer ix
    integer iy
    integer k
    integer jx
    integer jy
    integer jk
    CODE:
    udgrdn_(&mode, &ix, &iy, &k, &jx, &jy, &jk);

void
udiclr(ix, n)
    integer ix
    integer n
    CODE:
    udiclr_(&ix, &n);

void
uddclv(zlev)
    real zlev
    CODE:
    uddclv_(&zlev);

void
udiclv()
    CODE:
    udiclv_();

integer
udqcln()
    CODE:
    integer nlev;
    udqcln_(&nlev);
    RETVAL =     nlev;
    OUTPUT:
    RETVAL

void
udqclv(zlev, indx, ityp, clv, hl, nlev)
    real *  zlev
    integer *  indx
    integer *  ityp
    char *  clv
    real *  hl
    integer nlev
    CODE:
    udqclv_(zlev, indx, ityp, clv, hl, &nlev, strlen(clv));

void
udsclv(zlev, indx, ityp, clv, hl)
    real zlev
    integer indx
    integer ityp
    char *  clv
    real hl
    CODE:
    udsclv_(&zlev, &indx, &ityp, clv, &hl, strlen(clv));

void
udqfmt(cfmt)
    char *  cfmt
    CODE:
    udqfmt_(cfmt, strlen(cfmt));

void
udsfmt(cfmt)
    char *  cfmt
    CODE:
    udsfmt_(cfmt, strlen(cfmt));

integer
udiget(cp)
    char *  cp 
    CODE:
    integer ipara;
    udiget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
udiset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    udiset_(cp, &ipara, strlen(cp));

void
udistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    udistx_(cp, &ipara, strlen(cp));

logical
udlget(cp)
    char *  cp 
    CODE:
    logical ipara;
    udlget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
udlset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    udlset_(cp, &ipara, strlen(cp));

void
udlstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    udlstx_(cp, &ipara, strlen(cp));

void
udpget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    udpget_(cp, ipara, strlen(cp));

void
udpset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    udpset_(cp, ipara, strlen(cp));

void
udpstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    udpstx_(cp, ipara, strlen(cp));

real
udrget(cp)
    char *  cp 
    CODE:
    real ipara;
    udrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
udrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    udrset_(cp, &ipara, strlen(cp));

void
udrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    udrstx_(cp, &ipara, strlen(cp));

void
udpqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    udpqcp_(&idx, cp, strlen(cp));

integer
udpqid(cp)
    char *  cp 
    CODE:
    integer idx;
    udpqid_(cp, &idx, strlen(cp));
    RETVAL =     idx;
    OUTPUT:
    RETVAL

integer
udpqnp()
    CODE:
    integer ncp;
    udpqnp_(&ncp);
    RETVAL =     ncp;
    OUTPUT:
    RETVAL

integer
udpqvl(idx)
    integer idx 
    CODE:
    integer ipara;
    udpqvl_(&idx, &ipara);
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
udpsvl(idx, ipara)
    integer idx 
    integer ipara
    CODE:
    udpsvl_(&idx, &ipara);

void
uegtla(xmin, xmax, dx)
    real xmin
    real xmax
    real dx
    CODE:
    uegtla_(&xmin, &xmax, &dx);

void
uegtlb(z__, mx, nx, ny, dx)
    real *  z__
    integer mx
    integer nx
    integer ny
    real dx
    CODE:
    uegtlb_(z__, &mx, &nx, &ny, &dx);

void
ueitlv()
    CODE:
    ueitlv_();

integer
ueqntl()
    CODE:
    integer nton;
    ueqntl_(&nton);
    RETVAL =     nton;
    OUTPUT:
    RETVAL

void
ueqtlv(tlev1, tlev2, ipat, iton)
    real *  tlev1
    real *  tlev2
    integer *  ipat
    integer iton
    CODE:
    ueqtlv_(tlev1, tlev2, ipat, &iton);

void
uestlv(tlev1, tlev2, ipat)
    real tlev1
    real tlev2
    integer ipat
    CODE:
    uestlv_(&tlev1, &tlev2, &ipat);

integer
ueiget(cp)
    char *  cp 
    CODE:
    integer ipara;
    ueiget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
ueiset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    ueiset_(cp, &ipara, strlen(cp));

void
ueistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    ueistx_(cp, &ipara, strlen(cp));

void
uelget(cp)
    char *  cp 
    CODE:
    logical ipara;
    uelget_(cp, &ipara, strlen(cp));

void
uelset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uelset_(cp, &ipara, strlen(cp));

void
uelstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uelstx_(cp, &ipara, strlen(cp));

void
uepget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uepget_(cp, ipara, strlen(cp));

void
uepset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uepset_(cp, ipara, strlen(cp));

void
uepstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uepstx_(cp, ipara, strlen(cp));

real
uerget(cp)
    char *  cp 
    CODE:
    real ipara;
    uerget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uerset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    uerset_(cp, &ipara, strlen(cp));

void
uerstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    uerstx_(cp, &ipara, strlen(cp));

void
uepqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    uepqcp_(&idx, cp, strlen(cp));

integer
uepqid(cp)
    char *  cp 
    CODE:
    integer idx;
    uepqid_(cp, &idx, strlen(cp));
    RETVAL =     idx;
    OUTPUT:
    RETVAL

integer
uepqnp()
    CODE:
    integer ncp;
    uepqnp_(&ncp);
    RETVAL =     ncp;
    OUTPUT:
    RETVAL

integer
uepqvl(idx)
    integer idx 
    CODE:
    integer ipara;
    uepqvl_(&idx, &ipara);
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uepsvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    uepsvl_(&idx, &ipara);

void
uestln(tlevn, ipatn, nton)
    real *  tlevn
    integer *  ipatn
    integer nton
    CODE:
    uestln_(tlevn, ipatn, &nton);

void
uetonc(z__, mx, nx, ny)
    real *  z__
    integer mx
    integer nx
    integer ny
    CODE:
    uetonc_(z__, &mx, &nx, &ny);

void
uetone(z__, mx, nx, ny)
    real *  z__
    integer mx
    integer nx
    integer ny
    CODE:
    uetone_(z__, &mx, &nx, &ny);

void
uetonf(z__, mx, nx, ny)
    real *  z__
    integer mx
    integer nx
    integer ny
    CODE:
    uetonf_(z__, &mx, &nx, &ny);

void
uezchk(z__, mx, nx, ny, cname, istat)
    real *  z__
    integer *  mx
    integer *  nx
    integer *  ny
    char *  cname
    integer *  istat
    CODE:
    uezchk_(z__, mx, nx, ny, cname, istat, strlen(cname));

integer
ugiget(cp)
    char *  cp 
    CODE:
    integer ipara;
    ugiget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
ugiset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    ugiset_(cp, &ipara, strlen(cp));

void
ugistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    ugistx_(cp, &ipara, strlen(cp));

logical
uglget(cp)
    char *  cp 
    CODE:
    logical ipara;
    uglget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uglset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uglset_(cp, &ipara, strlen(cp));

void
uglstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uglstx_(cp, &ipara, strlen(cp));

void
ugpget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    ugpget_(cp, ipara, strlen(cp));

void
ugpset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    ugpset_(cp, ipara, strlen(cp));

void
ugpstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    ugpstx_(cp, ipara, strlen(cp));

real
ugrget(cp)
    char *  cp 
    CODE:
    real ipara;
    ugrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
ugrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    ugrset_(cp, &ipara, strlen(cp));

void
ugrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    ugrstx_(cp, &ipara, strlen(cp));

void
ugpqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    ugpqcp_(&idx, cp, strlen(cp));

integer
ugpqid(cp)
    char *  cp 
    CODE:
    integer idx;
    ugpqid_(cp, &idx, strlen(cp));
    RETVAL =     idx;
    OUTPUT:
    RETVAL

integer
ugpqnp()
    CODE:
    integer ncp;
    ugpqnp_(&ncp);
    RETVAL =     ncp;
    OUTPUT:
    RETVAL

integer
ugpqvl(idx)
    integer idx 
    CODE:
    integer ipara;
    ugpqvl_(&idx, &ipara);
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
ugpsvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    ugpsvl_(&idx, &ipara);

void
ugsut(cside, cttl)
    char *  cside
    char *  cttl
    CODE:
    ugsut_(cside, cttl, strlen(cside), strlen(cttl));

void
ugvect(u, mu, v, mv, nx, ny)
    real *  u
    integer mu
    real *  v
    integer mv
    integer nx
    integer ny
    CODE:
    ugvect_(u, &mu, v, &mv, &nx, &ny);

void
uhbra(n, upx1, upx2, upy)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    CODE:
    uhbra_(&n, upx1, upx2, upy);

void
uhbraz(n, upx1, upx2, upy, itpat1, itpat2, rsize)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    integer itpat1
    integer itpat2
    real rsize
    CODE:
    uhbraz_(&n, upx1, upx2, upy, &itpat1, &itpat2, &rsize);

void
uhbrf(n, upx1, upx2, upy)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    CODE:
    uhbrf_(&n, upx1, upx2, upy);

void
uhbrfz(n, upx1, upx2, upy, itype, index, rsize)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    integer itype
    integer index
    real rsize
    CODE:
    uhbrfz_(&n, upx1, upx2, upy, &itype, &index, &rsize);

void
uhbrl(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    uhbrl_(&n, upx, upy);

void
uhbrlz(n, upx, upy, itype, index, rsize)
    integer n
    real *  upx
    real *  upy
    integer itype
    integer index
    real rsize
    CODE:
    uhbrlz_(&n, upx, upy, &itype, &index, &rsize);

void
uhbxa(n, upx1, upx2, upy)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    CODE:
    uhbxa_(&n, upx1, upx2, upy);

void
uhbxaz(n, upx1, upx2, upy, itpat1, itpat2)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    integer itpat1
    integer itpat2
    CODE:
    uhbxaz_(&n, upx1, upx2, upy, &itpat1, &itpat2);

void
uhbxf(n, upx1, upx2, upy)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    CODE:
    uhbxf_(&n, upx1, upx2, upy);

void
uhbxfz(n, upx1, upx2, upy, itype, index)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    integer itype
    integer index
    CODE:
    uhbxfz_(&n, upx1, upx2, upy, &itype, &index);

void
uhbxl(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    uhbxl_(&n, upx, upy);

void
uhbxlz(n, upx, upy, itype, index)
    integer n
    real *  upx
    real *  upy
    integer itype
    integer index
    CODE:
    uhbxlz_(&n, upx, upy, &itype, &index);

void
uhdif(n, upx1, upx2, upy)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    CODE:
    uhdif_(&n, upx1, upx2, upy);

void
uhdifz(n, upx1, upx2, upy, itpat1, itpat2)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    integer itpat1
    integer itpat2
    CODE:
    uhdifz_(&n, upx1, upx2, upy, &itpat1, &itpat2);

void
uherb(n, upx1, upx2, upy)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    CODE:
    uherb_(&n, upx1, upx2, upy);

void
uherbz(n, upx1, upx2, upy, itype, index, rsize)
    integer n
    real *  upx1
    real *  upx2
    real *  upy
    integer itype
    integer index
    real rsize
    CODE:
    uherbz_(&n, upx1, upx2, upy, &itype, &index, &rsize);

integer
uliget(cp)
    char *  cp 
    CODE:
    integer ipara;
    uliget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uliset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    uliset_(cp, &ipara, strlen(cp));

void
ulistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    ulistx_(cp, &ipara, strlen(cp));

logical
ullget(cp)
    char *  cp 
    CODE:
    logical ipara;
    ullget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
ullset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    ullset_(cp, &ipara, strlen(cp));

void
ullstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    ullstx_(cp, &ipara, strlen(cp));

void
ulpget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    ulpget_(cp, ipara, strlen(cp));

void
ulpset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    ulpset_(cp, ipara, strlen(cp));

void
ulpstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    ulpstx_(cp, ipara, strlen(cp));

real
ulrget(cp)
    char *  cp 
    CODE:
    real ipara;
    ulrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
ulrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    ulrset_(cp, &ipara, strlen(cp));

void
ulrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    ulrstx_(cp, &ipara, strlen(cp));

void
ulpqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    ulpqcp_(&idx, cp, strlen(cp));

void
ulpqid(cp)
    char *  cp 
    CODE:
    integer idx;
    ulpqid_(cp, &idx, strlen(cp));

integer
ulpqnp()
    CODE:
    integer ncp;
    ulpqnp_(&ncp);
    RETVAL =     ncp;
    OUTPUT:
    RETVAL

integer
ulpqvl(idx)
    integer idx 
    CODE:
    integer ipara;
    ulpqvl_(&idx, &ipara);
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
ulpsvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    ulpsvl_(&idx, &ipara);

void
ulqxbl(bl, nbl)
    real *  bl
    integer *  nbl
    CODE:
    ulqxbl_(bl, nbl);

void
ulsxbl(bl, nbl)
    real bl
    integer nbl
    CODE:
    ulsxbl_(&bl, &nbl);

void
ulxlbl(bl, nbl, inum)
    real *  bl
    integer *  nbl
    integer *  inum
    CODE:
    ulxlbl_(bl, nbl, inum);

void
ulxlog(cside, nlbl, nticks)
    char *  cside
    integer nlbl
    integer nticks
    CODE:
    ulxlog_(cside, &nlbl, &nticks, strlen(cside));

void
ulxqfm(cxfmt)
    char *  cxfmt
    CODE:
    ulxqfm_(cxfmt, strlen(cxfmt));

void
ulxsfm(cxfmt)
    char *  cxfmt
    CODE:
    ulxsfm_(cxfmt, strlen(cxfmt));

void
ulqybl(bl, nbl)
    real *  bl
    integer *  nbl
    CODE:
    ulqybl_(bl, nbl);

void
ulsybl(bl, nbl)
    real bl
    integer nbl
    CODE:
    ulsybl_(&bl, &nbl);

void
ulylbl(bl, nbl, inum)
    real *  bl
    integer nbl
    integer inum
    CODE:
    ulylbl_(bl, &nbl, &inum);

void
ulylog(cside, nlbl, nticks)
    char *  cside
    integer nlbl
    integer nticks
    CODE:
    ulylog_(cside, &nlbl, &nticks, strlen(cside));

void
ulyqfm(cyfmt)
    char *  cyfmt
    CODE:
    ulyqfm_(cyfmt, strlen(cyfmt));

void
ulysfm(cyfmt)
    char *  cyfmt
    CODE:
    ulysfm_(cyfmt, strlen(cyfmt));

void
umbndc(xmin, xmax, ymin, ymax)
    real xmin
    real xmax
    real ymin
    real ymax
    CODE:
    umbndc_(&xmin, &xmax, &ymin, &ymax);

void
umbndp(vxmin, vxmax, vymin, vymax)
    real vxmin
    real vxmax
    real vymin
    real vymax
    CODE:
    umbndp_(&vxmin, &vxmax, &vymin, &vymax);

void
uminit()
    CODE:
    uminit_();

void
umpfit()
    CODE:
    umpfit_();

integer
umiget(cp)
    char *  cp 
    CODE:
    integer ipara;
    umiget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
umiset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    umiset_(cp, &ipara, strlen(cp));

void
umistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    umistx_(cp, &ipara, strlen(cp));

logical
umlget(cp)
    char *  cp 
    CODE:
    logical ipara;
    umlget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
umlset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    umlset_(cp, &ipara, strlen(cp));

void
umlstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    umlstx_(cp, &ipara, strlen(cp));

void
umpget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    umpget_(cp, ipara, strlen(cp));

void
umpset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    umpset_(cp, &ipara, strlen(cp));

void
umpstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    umpstx_(cp, ipara, strlen(cp));

real
umrget(cp)
    char *  cp 
    CODE:
    real ipara;
    umrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
umrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    umrset_(cp, &ipara, strlen(cp));

void
umrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    umrstx_(cp, &ipara, strlen(cp));

void
umpglb()
    CODE:
    umpglb_();

void
umpgrd()
    CODE:
    umpgrd_();

void
umplim()
    CODE:
    umplim_();

void
umpmap(cdsn)
    char *  cdsn
    CODE:
    umpmap_(cdsn, strlen(cdsn));

void
umpqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    umpqcp_(&idx, cp, strlen(cp));

integer
umpqid(cp)
    char *  cp 
    CODE:
    integer idx;
    umpqid_(cp, &idx, strlen(cp));
    RETVAL =     idx;
    OUTPUT:
    RETVAL

integer
umpqnp()
    CODE:
    integer ncp;
    umpqnp_(&ncp);
    RETVAL =     ncp;
    OUTPUT:
    RETVAL

integer
umpqvl(idx)
    integer idx 
    CODE:
    integer ipara;
    umpqvl_(&idx, &ipara);
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
umpsvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    umpsvl_(&idx, &ipara);

void
umqfnm(cpara, cfname)
    char *  cpara
    char *  cfname
    CODE:
    umqfnm_(cpara, cfname, strlen(cpara), strlen(cfname));

void
umqtxy(txminz, txmaxz, tyminz, tymaxz)
    real txminz
    real txmaxz
    real tyminz
    real tymaxz
    CODE:
    umqtxy_(&txminz, &txmaxz, &tyminz, &tymaxz);

void
umqcnt(xcnt, ycnt, rot)
    real xcnt
    real ycnt
    real rot
    CODE:
    umqcnt_(&xcnt, &ycnt, &rot);

void
umscnt(xcnt, ycnt, rot)
    real xcnt
    real ycnt
    real rot
    CODE:
    umscnt_(&xcnt, &ycnt, &rot);

void
umscom()
    CODE:
    umscom_();

void
umqcwd(xcntr, ycntr, r__)
    real *  xcntr
    real *  ycntr
    real *  r__
    CODE:
    umqcwd_(xcntr, ycntr, r__);

void
umscwd(xcntr, ycntr, r__)
    real xcntr
    real ycntr
    real r__
    CODE:
    umscwd_(&xcntr, &ycntr, &r__);

void
umsgrd()
    CODE:
    umsgrd_();

void
umspct()
    CODE:
    umspct_();

void
umspcw()
    CODE:
    umspcw_();

void
umspdf()
    CODE:
    umspdf_();

void
umqpnt(n, uxa, uya)
    integer n
    real *  uxa
    real *  uya
    CODE:
    umqpnt_(&n, uxa, uya);

void
umqptn(n)
    integer *  n
    CODE:
    umqptn_(n);

void
umrpnt()
    CODE:
    umrpnt_();

void
umspnt(n, ux, uy)
    integer n
    real *  ux
    real *  uy
    CODE:
    umspnt_(&n, ux, uy);

void
umsppt()
    CODE:
    umsppt_();

void
umspwd()
    CODE:
    umspwd_();

void
umstvz()
    CODE:
    umstvz_();

void
uscget(cp, cpara)
    char *  cp
    char *  cpara
    CODE:
    uscget_(cp, cpara, strlen(cp), strlen(cpara));

void
uscset(cp, cpara)
    char *  cp
    char *  cpara
    CODE:
    uscset_(cp, cpara, strlen(cp), strlen(cpara));

void
uscstx(cp, cpara)
    char *  cp
    char *  cpara
    CODE:
    uscstx_(cp, cpara, strlen(cp), strlen(cpara));

void
uschvl(x, chx)
    real x
    char *  chx
    CODE:
    uschvl_(&x, chx, strlen(chx));

void
uscqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    uscqcp_(&idx, cp, strlen(cp));

integer
uscqid(cp)
    char *  cp 
    CODE:
    integer idx;
    uscqid_(cp, &idx, strlen(cp));
    RETVAL =     idx;
    OUTPUT:
    RETVAL

integer
uscqnp()
    CODE:
    integer ncp;
    uscqnp_(&ncp);
    RETVAL =     ncp;
    OUTPUT:
    RETVAL

void
uscqvl(idx, cval)
    integer idx
    char *  cval
    CODE:
    uscqvl_(&idx, cval, strlen(cval));

void
uscsvl(idx, cval)
    integer idx
    char *  cval
    CODE:
    uscsvl_(&idx, cval, strlen(cval));

void
usdaxs()
    CODE:
    usdaxs_();

void
usgrph(n, x, y)
    integer n
    real *  x
    real *  y
    CODE:
    usgrph_(&n, x, y);

void
usinit()
    CODE:
    usinit_();

void
uspfit()
    CODE:
    uspfit_();

integer
usiget(cp)
    char *  cp 
    CODE:
    integer ipara;
    usiget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
usiset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    usiset_(cp, &ipara, strlen(cp));

void
usistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    usistx_(cp, &ipara, strlen(cp));

logical
uslget(cp)
    char *  cp 
    CODE:
    logical ipara;
    uslget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uslset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uslset_(cp, &ipara, strlen(cp));

void
uslstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uslstx_(cp, &ipara, strlen(cp));

void
uspget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uspget_(cp, ipara, strlen(cp));

void
uspset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uspset_(cp, ipara, strlen(cp));

void
uspstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uspstx_(cp, ipara, strlen(cp));

real
usrget(cp)
    char *  cp 
    CODE:
    real ipara;
    usrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
usrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    usrset_(cp, &ipara, strlen(cp));

void
usrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    usrstx_(cp, &ipara, strlen(cp));

void
uspqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    uspqcp_(&idx, cp, strlen(cp));

integer
uspqid(cp)
    char *  cp 
    CODE:
    integer idx;
    uspqid_(cp, &idx, strlen(cp));
    RETVAL =     idx;
    OUTPUT:
    RETVAL

integer
uspqnp()
    CODE:
    integer ncp;
    uspqnp_(&ncp);
    RETVAL =     ncp;
    OUTPUT:
    RETVAL

integer
uspqvl(idx)
    integer idx 
    CODE:
    integer ipara;
    uspqvl_(&idx, &ipara);
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uspsvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    uspsvl_(&idx, &ipara);

void
usspnt(n, x, y)
    integer n
    real *  x
    real *  y
    CODE:
    usspnt_(&n, x, y);

void
ussttl(cxttl, cxunit, cyttl, cyunit)
    char *  cxttl
    char *  cxunit
    char *  cyttl
    char *  cyunit
    CODE:
    ussttl_(cxttl, cxunit, cyttl, cyunit, strlen(cxttl), strlen(cxunit), strlen(cyttl), strlen(cyunit));

void
usurdl(umin, umax, vmin, vmax)
    real umin
    real umax
    real vmin
    real vmax
    CODE:
    usurdl_(&umin, &umax, &vmin, &vmax);

void
usurdt(umin, umax, vmin, vmax, dut)
    real umin
    real umax
    real vmin
    real vmax
    real dut
    CODE:
    usurdt_(&umin, &umax, &vmin, &vmax, &dut);

void
ususcl(caxis, umin, umax, vmin, vmax)
    char *  caxis
    real umin
    real umax
    real vmin
    real vmax
    CODE:
    ususcl_(caxis, &umin, &umax, &vmin, &vmax, strlen(caxis));

void
ususcu(caxis, umin, umax, vmin, vmax, mode)
    char *  caxis
    real umin
    real umax
    real vmin
    real vmax
    integer mode
    CODE:
    ususcu_(caxis, &umin, &umax, &vmin, &vmax, &mode, strlen(caxis));

void
uswapz(x1, x2, n)
    real *  x1
    real *  x2
    integer n
    CODE:
    uswapz_(x1, x2, &n);

void
usxaxl(cxs)
    char *  cxs
    CODE:
    usxaxl_(cxs, strlen(cxs));

void
usxaxs(cside)
    char *  cside
    CODE:
    usxaxs_(cside, strlen(cside));

void
usxaxu(cxs)
    char *  cxs
    CODE:
    usxaxu_(cxs, strlen(cxs));

void
usxoff(cxs)
    char *  cxs
    CODE:
    usxoff_(cxs, strlen(cxs));

void
usxsub(cxa, cya, clabel, rlbl)
    char *  cxa
    char *  cya
    char *  clabel
    real rlbl
    CODE:
    usxsub_(cxa, cya, clabel, &rlbl, strlen(cxa), strlen(cya), strlen(clabel));

void
usyaxl(cys)
    char *  cys
    CODE:
    usyaxl_(cys, strlen(cys));

void
usyaxs(cside)
    char *  cside
    CODE:
    usyaxs_(cside, strlen(cside));

void
usyaxu(cys)
    char *  cys
    CODE:
    usyaxu_(cys, strlen(cys));

void
usyoff(cys)
    char *  cys
    CODE:
    usyoff_(cys, strlen(cys));

void
usysub(cya, cxa, clabel, rlbl)
    char *  cya
    char *  cxa
    char *  clabel
    real rlbl
    CODE:
    usysub_(cya, cxa, clabel, &rlbl, strlen(cya), strlen(cxa), strlen(clabel));

void
uszdgt(umin, umax, dul, maxdgt, uoff, ufact, ndgt, ldgt)
    real umin
    real umax
    real dul
    integer maxdgt
    real uoff
    real ufact
    integer ndgt
    integer ldgt
    CODE:
    uszdgt_(&umin, &umax, &dul, &maxdgt, &uoff, &ufact, &ndgt, &ldgt);

void
uuinit()
    CODE:
    uuinit_();

void
uulin(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    uulin_(&n, upx, upy);

void
uulinz(n, upx, upy, itype, index)
    integer n
    real *  upx
    real *  upy
    integer itype
    integer index
    CODE:
    uulinz_(&n, upx, upy, &itype, &index);

void
uumrk(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    uumrk_(&n, upx, upy);

void
uumrkz(n, upx, upy, itype, index, rsize)
    integer n
    real *  upx
    real *  upy
    integer itype
    integer index
    real rsize
    CODE:
    uumrkz_(&n, upx, upy, &itype, &index, &rsize);

integer
uuiget(cp)
    char *  cp 
    CODE:
    integer ipara;
    uuiget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uuiset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    uuiset_(cp, &ipara, strlen(cp));

void
uuistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    uuistx_(cp, &ipara, strlen(cp));

logical
uulget(cp)
    char *  cp 
    CODE:
    logical ipara;
    uulget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uulset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uulset_(cp, &ipara, strlen(cp));

void
uulstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uulstx_(cp, &ipara, strlen(cp));

void
uupget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uupget_(cp, ipara, strlen(cp));

void
uupset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uupset_(cp, ipara, strlen(cp));

void
uupstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uupstx_(cp, ipara, strlen(cp));

real
uurget(cp)
    char *  cp 
    CODE:
    real ipara;
    uurget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uurset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    uurset_(cp, &ipara, strlen(cp));

void
uurstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    uurstx_(cp, &ipara, strlen(cp));

void
uupqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    uupqcp_(&idx, cp, strlen(cp));

integer
uupqid(cp)
    char *  cp 
    CODE:
    integer idx;
    uupqid_(cp, &idx, strlen(cp));
    RETVAL =     idx;
    OUTPUT:
    RETVAL

integer
uupqnp()
    CODE:
    integer ncp;
    uupqnp_(&ncp);
    RETVAL =     ncp;
    OUTPUT:
    RETVAL

void
uupqvl(idx)
    integer idx 
    CODE:
    integer ipara;
    uupqvl_(&idx, &ipara);

void
uupsvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    uupsvl_(&idx, &ipara);

void
uuqarp(itpt1, itpt2)
    integer *  itpt1
    integer *  itpt2
    CODE:
    uuqarp_(itpt1, itpt2);

void
uusarp(itpt1, itpt2)
    integer itpt1
    integer itpt2
    CODE:
    uusarp_(&itpt1, &itpt2);

real
uuqbrs()
    CODE:
    real rsize;
    uuqbrs_(&rsize);
    RETVAL =     rsize;
    OUTPUT:
    RETVAL

void
uusbrs(rsize)
    real rsize
    CODE:
    uusbrs_(&rsize);

integer
uuqebi()
    CODE:
    integer index;
    uuqebi_(&index);
    RETVAL =     index;
    OUTPUT:
    RETVAL

real
uuqebs()
    CODE:
    real rsize;
    uuqebs_(&rsize);
    RETVAL =     rsize;
    OUTPUT:
    RETVAL

void
uuqebt()
    CODE:
    integer itype;
    uuqebt_(&itype);

void
uusebi(index)
    integer index
    CODE:
    uusebi_(&index);

void
uusebs(rsize)
    real rsize
    CODE:
    uusebs_(&rsize);

void
uusebt(itype)
    integer itype
    CODE:
    uusebt_(&itype);

integer
uuqfri()
    CODE:
    integer index;
    uuqfri_(&index);
    RETVAL =     index;
    OUTPUT:
    RETVAL

integer
uuqfrt()
    CODE:
    integer itype;
    uuqfrt_(&itype);
    RETVAL =     itype;
    OUTPUT:
    RETVAL

void
uusfri(index)
    integer index
    CODE:
    uusfri_(&index);

void
uusfrt(itype)
    integer itype
    CODE:
    uusfrt_(&itype);

void
uuqidv(umin, umax)
    real *  umin
    real *  umax
    CODE:
    uuqidv_(umin, umax);

void
uusidv(umin, umax)
    real umin
    real umax
    CODE:
    uusidv_(&umin, &umax);

integer
uuqlni()
    CODE:
    integer index;
    uuqlni_(&index);
    RETVAL =     index;
    OUTPUT:
    RETVAL

integer
uuqlnt()
    CODE:
    integer itype;
    uuqlnt_(&itype);
    RETVAL =     itype;
    OUTPUT:
    RETVAL

void
uuslni(index)
    integer index
    CODE:
    uuslni_(&index);

void
uuslnt(itype)
    integer itype
    CODE:
    uuslnt_(&itype);

integer
uuqmki()
    CODE:
    integer index;
    uuqmki_(&index);
    RETVAL =     index;
    OUTPUT:
    RETVAL

real
uuqmks()
    CODE:
    real rsize;
    uuqmks_(&rsize);
    RETVAL =     rsize;
    OUTPUT:
    RETVAL

integer
uuqmkt()
    CODE:
    integer itype;
    uuqmkt_(&itype);
    RETVAL =     itype;
    OUTPUT:
    RETVAL

void
uusmki(index)
    integer index
    CODE:
    uusmki_(&index);

void
uusmks(rsize)
    real rsize
    CODE:
    uusmks_(&rsize);

void
uusmkt(itype)
    integer itype
    CODE:
    uusmkt_(&itype);

void
uvbra(n, upx, upy1, upy2)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    CODE:
    uvbra_(&n, upx, upy1, upy2);

void
uvbraz(n, upx, upy1, upy2, itpat1, itpat2, rsize)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    integer itpat1
    integer itpat2
    real rsize
    CODE:
    uvbraz_(&n, upx, upy1, upy2, &itpat1, &itpat2, &rsize);

void
uvbrf(n, upx, upy1, upy2)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    CODE:
    uvbrf_(&n, upx, upy1, upy2);

void
uvbrfz(n, upx, upy1, upy2, itype, index, rsize)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    integer itype
    integer index
    real rsize
    CODE:
    uvbrfz_(&n, upx, upy1, upy2, &itype, &index, &rsize);

void
uvbrl(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    uvbrl_(&n, upx, upy);

void
uvbrlz(n, upx, upy, itype, index, rsize)
    integer n
    real *  upx
    real *  upy
    integer itype
    integer index
    real rsize
    CODE:
    uvbrlz_(&n, upx, upy, &itype, &index, &rsize);

void
uvbxa(n, upx, upy1, upy2)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    CODE:
    uvbxa_(&n, upx, upy1, upy2);

void
uvbxaz(n, upx, upy1, upy2, itpat1, itpat2)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    integer itpat1
    integer itpat2
    CODE:
    uvbxaz_(&n, upx, upy1, upy2, &itpat1, &itpat2);

void
uvbxf(n, upx, upy1, upy2)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    CODE:
    uvbxf_(&n, upx, upy1, upy2);

void
uvbxfz(n, upx, upy1, upy2, itype, index)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    integer itype
    integer index
    CODE:
    uvbxfz_(&n, upx, upy1, upy2, &itype, &index);

void
uvbxl(n, upx, upy)
    integer n
    real *  upx
    real *  upy
    CODE:
    uvbxl_(&n, upx, upy);

void
uvbxlz(n, upx, upy, itype, index)
    integer n
    real *  upx
    real *  upy
    integer itype
    integer index
    CODE:
    uvbxlz_(&n, upx, upy, &itype, &index);

void
uvdif(n, upx, upy1, upy2)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    CODE:
    uvdif_(&n, upx, upy1, upy2);

void
uvdifz(n, upx, upy1, upy2, itpat1, itpat2)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    integer itpat1
    integer itpat2
    CODE:
    uvdifz_(&n, upx, upy1, upy2, &itpat1, &itpat2);

void
uverb(n, upx, upy1, upy2)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    CODE:
    uverb_(&n, upx, upy1, upy2);

void
uverbz(n, upx, upy1, upy2, itype, index, rsize)
    integer n
    real *  upx
    real *  upy1
    real *  upy2
    integer itype
    integer index
    real rsize
    CODE:
    uverbz_(&n, upx, upy1, upy2, &itype, &index, &rsize);

void
uwdflt(nx, ny)
    integer nx
    integer ny
    CODE:
    uwdflt_(&nx, &ny);

void
uwigxi()
    CODE:
    uwigxi_();

void
uwqgxi(ux, iux, frac)
    real ux
    integer *  iux
    real *  frac
    CODE:
    uwqgxi_(&ux, iux, frac);

void
uwigyi()
    CODE:
    uwigyi_();

void
uwqgyi(uy, iuy, frac)
    real uy
    integer *  iuy
    real *  frac
    CODE:
    uwqgyi_(&uy, iuy, frac);

void
uwqgxa(xp, nx)
    real *  xp
    integer *  nx
    CODE:
    uwqgxa_(xp, nx);

void
uwqgxb(uxmin, uxmax, nx)
    real uxmin
    real uxmax
    integer nx
    CODE:
    uwqgxb_(&uxmin, &uxmax, &nx);

logical
uwqgxz()
    CODE:
    logical lsetx;
    uwqgxz_(&lsetx);
    RETVAL =     lsetx;
    OUTPUT:
    RETVAL

void
uwsgxa(xp, nx)
    real *  xp
    integer nx
    CODE:
    uwsgxa_(xp, &nx);

void
uwsgxb(uxmin, uxmax, nx)
    real uxmin
    real uxmax
    integer nx
    CODE:
    uwsgxb_(&uxmin, &uxmax, &nx);

void
uwsgxz(lsetx)
    logical lsetx
    CODE:
    uwsgxz_(&lsetx);

void
uwqgya(yp, ny)
    real *  yp
    integer *  ny
    CODE:
    uwqgya_(yp, ny);

void
uwqgyb(uymin, uymax, ny)
    real uymin
    real uymax
    integer ny
    CODE:
    uwqgyb_(&uymin, &uymax, &ny);

logical
uwqgyz()
    CODE:
    logical lsety;
    uwqgyz_(&lsety);
    RETVAL =     lsety;
    OUTPUT:
    RETVAL

void
uwsgya(yp, ny)
    real *  yp
    integer ny
    CODE:
    uwsgya_(yp, &ny);

void
uwsgyb(uymin, uymax, ny)
    real uymin
    real uymax
    integer ny
    CODE:
    uwsgyb_(&uymin, &uymax, &ny);

void
uwsgyz(lsety)
    logical lsety
    CODE:
    uwsgyz_(&lsety);

void
uxaxdv(cside, dx1, dx2)
    char *  cside
    real dx1
    real dx2
    CODE:
    uxaxdv_(cside, &dx1, &dx2, strlen(cside));

void
uxaxlb(cside, ux1, n1, ux2, ch, nc, n2)
    char *  cside
    real *  ux1
    integer n1
    real *  ux2
    char *  ch
    integer nc
    integer n2
    CODE:
    uxaxlb_(cside, ux1, &n1, ux2, ch, &nc, &n2, strlen(cside), strlen(ch));

void
uxaxnm(cside, ux1, n1, ux2, n2)
    char *  cside
    real *  ux1
    integer n1
    real *  ux2
    integer n2
    CODE:
    uxaxnm_(cside, ux1, &n1, ux2, &n2, strlen(cside));

void
uxmttl(cside, cttl, px)
    char *  cside
    char *  cttl
    real px
    CODE:
    uxmttl_(cside, cttl, &px, strlen(cside), strlen(cttl));

void
uxpaxs(cside, islct)
    char *  cside
    integer islct
    CODE:
    uxpaxs_(cside, &islct, strlen(cside));

void
uxplbl(cside, islct, ux, ch, nc, n)
    char *  cside
    integer islct
    real *  ux
    char *  ch
    integer nc
    integer n
    CODE:
    uxplbl_(cside, &islct, ux, ch, &nc, &n, strlen(cside), strlen(ch));

void
uxpnum(cside, islct, ux, n)
    char *  cside
    integer islct
    real *  ux
    integer n
    CODE:
    uxpnum_(cside, &islct, ux, &n, strlen(cside));

void
uxqfmt(cfmt)
    char *  cfmt
    CODE:
    uxqfmt_(cfmt, strlen(cfmt));

void
uxsfmt(cfmt)
    char *  cfmt
    CODE:
    uxsfmt_(cfmt, strlen(cfmt));

void
uxptmk(cside, islct, ux, n)
    char *  cside
    integer islct
    real *  ux
    integer n
    CODE:
    uxptmk_(cside, &islct, ux, &n, strlen(cside));

void
uxpttl(cside, islct, cttl, px)
    char *  cside
    integer islct
    char *  cttl
    real px
    CODE:
    uxpttl_(cside, &islct, cttl, &px, strlen(cside), strlen(cttl));

void
uxsaxs(cside)
    char *  cside
    CODE:
    uxsaxs_(cside, strlen(cside));

void
uxsaxz(cside, roffx)
    char *  cside
    real roffx
    CODE:
    uxsaxz_(cside, &roffx, strlen(cside));

void
uxsttl(cside, cttl, px)
    char *  cside
    char *  cttl
    real px
    CODE:
    uxsttl_(cside, cttl, &px, strlen(cside), strlen(cttl));

void
uyaxdv(cside, dy1, dy2)
    char *  cside
    real dy1
    real dy2
    CODE:
    uyaxdv_(cside, &dy1, &dy2, strlen(cside));

void
uyaxlb(cside, uy1, n1, uy2, ch, nc, n2)
    char *  cside
    real *  uy1
    integer n1
    real *  uy2
    char *  ch
    integer nc
    integer n2
    CODE:
    uyaxlb_(cside, uy1, &n1, uy2, ch, &nc, &n2, strlen(cside), strlen(ch));

void
uyaxnm(cside, uy1, n1, uy2, n2)
    char *  cside
    real *  uy1
    integer n1
    real *  uy2
    integer n2
    CODE:
    uyaxnm_(cside, uy1, &n1, uy2, &n2, strlen(cside));

void
uymttl(cside, cttl, px)
    char *  cside
    char *  cttl
    real px
    CODE:
    uymttl_(cside, cttl, &px, strlen(cside), strlen(cttl));

void
uypaxs(cside, islct)
    char *  cside
    integer islct
    CODE:
    uypaxs_(cside, &islct, strlen(cside));

void
uyplbl(cside, islct, uy, ch, nc, n)
    char *  cside
    integer islct
    real *  uy
    char *  ch
    integer nc
    integer n
    CODE:
    uyplbl_(cside, &islct, uy, ch, &nc, &n, strlen(cside), strlen(ch));

void
uypnum(cside, islct, uy, n)
    char *  cside
    integer islct
    real *  uy
    integer n
    CODE:
    uypnum_(cside, &islct, uy, &n, strlen(cside));

void
uyqfmt(cfmt)
    char *  cfmt
    CODE:
    uyqfmt_(cfmt, strlen(cfmt));

void
uysfmt(cfmt)
    char *  cfmt
    CODE:
    uysfmt_(cfmt, strlen(cfmt));

void
uyptmk(cside, islct, uy, n)
    char *  cside
    integer islct
    real *  uy
    integer n
    CODE:
    uyptmk_(cside, &islct, uy, &n, strlen(cside));

void
uypttl(cside, islct, cttl, px)
    char *  cside
    integer islct
    char *  cttl
    real px
    CODE:
    uypttl_(cside, &islct, cttl, &px, strlen(cside), strlen(cttl));

void
uysaxs(cside)
    char *  cside
    CODE:
    uysaxs_(cside, strlen(cside));

void
uysaxz(cside, roffy)
    char *  cside
    real roffy
    CODE:
    uysaxz_(cside, &roffy, strlen(cside));

void
uysttl(cside, cttl, px)
    char *  cside
    char *  cttl
    real px
    CODE:
    uysttl_(cside, cttl, &px, strlen(cside), strlen(cttl));

void
uzfact(rfact)
    real rfact
    CODE:
    uzfact_(&rfact);

void
uzinit()
    CODE:
    uzinit_();

integer
uziget(cp)
    char *  cp 
    CODE:
    integer ipara;
    uziget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uziset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    uziset_(cp, &ipara, strlen(cp));

void
uzistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    uzistx_(cp, &ipara, strlen(cp));

logical
uzlget(cp)
    char *  cp 
    CODE:
    logical ipara;
    uzlget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uzlset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uzlset_(cp, &ipara, strlen(cp));

void
uzlstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    uzlstx_(cp, &ipara, strlen(cp));

void
uzpget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uzpget_(cp, ipara, strlen(cp));

void
uzpset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uzpset_(cp, &ipara, strlen(cp));

void
uzpstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    uzpstx_(cp, ipara, strlen(cp));

real
uzrget(cp)
    char *  cp 
    CODE:
    real ipara;
    uzrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uzrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    uzrset_(cp, &ipara, strlen(cp));

void
uzrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    uzrstx_(cp, &ipara, strlen(cp));

void
uzpqcp(idx, cp)
    integer idx
    char *  cp
    CODE:
    uzpqcp_(&idx, cp, strlen(cp));

integer
uzpqid(cp)
    char *  cp 
    CODE:
    integer idx;
    uzpqid_(cp, &idx, strlen(cp));
    RETVAL =     idx;
    OUTPUT:
    RETVAL

integer
uzpqnp()
    CODE:
    integer ncp;
    uzpqnp_(&ncp);
    RETVAL =     ncp;
    OUTPUT:
    RETVAL

integer
uzpqvl(idx)
    integer idx 
    CODE:
    integer ipara;
    uzpqvl_(&idx, &ipara);
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
uzprst()
    CODE:
    uzprst_();

void
uzpsav()
    CODE:
    uzpsav_();

void
uzpsvl(idx, ipara)
    integer idx
    integer ipara
    CODE:
    uzpsvl_(&idx, &ipara);

void
glcget(cp, cpara)
    char *  cp
    char *  cpara
    CODE:
    glcget_(cp, cpara, strlen(cp), strlen(cpara));

void
glcset(cp, cpara)
    char *  cp
    char *  cpara
    CODE:
    glcset_(cp, cpara, strlen(cp), strlen(cpara));

void
glcstx(cp, cpara)
    char *  cp
    char *  cpara
    CODE:
    glcstx_(cp, cpara, strlen(cp), strlen(cpara));

integer
gliget(cp)
    char *  cp 
    CODE:
    integer ipara;
    gliget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
gliset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    gliset_(cp, &ipara, strlen(cp));

void
glistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    glistx_(cp, &ipara, strlen(cp));

logical
gllget(cp)
    char *  cp 
    CODE:
    logical ipara;
    gllget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
gllset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    gllset_(cp, &ipara, strlen(cp));

void
gllstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    gllstx_(cp, &ipara, strlen(cp));

void
glpget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    glpget_(cp, ipara, strlen(cp));

void
glpset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    glpset_(cp, ipara, strlen(cp));

void
glpstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    glpstx_(cp, ipara, strlen(cp));

real
glrget(cp)
    char *  cp 
    CODE:
    real ipara;
    glrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
glrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    glrset_(cp, &ipara, strlen(cp));

void
glrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    glrstx_(cp, &ipara, strlen(cp));

void
glqfnm(cpara, cfname)
    char *  cpara
    char *  cfname
    CODE:
    glqfnm_(cpara, cfname, strlen(cpara), strlen(cfname));

void
msgdmp(clev, csub, cmsg)
    char *  clev
    char *  csub
    char *  cmsg
    CODE:
    msgdmp_(clev, csub, cmsg, strlen(clev), strlen(csub), strlen(cmsg));

void
rtcenv(cpfix, cp, cval)
    char *  cpfix
    char *  cp
    char *  cval
    CODE:
    rtcenv_(cpfix, cp, cval, strlen(cpfix), strlen(cp), strlen(cval));

void
rtcget(cpfix, cp, cpara, max__)
    char *  cpfix
    char *  cp
    char *  cpara
    integer *  max__
    CODE:
    rtcget_(cpfix, cp, cpara, max__, strlen(cpfix), strlen(cp), strlen(cpara));

void
rtcopt(cpfix, cp, cval)
    char *  cpfix
    char *  cp
    char *  cval
    CODE:
    rtcopt_(cpfix, cp, cval, strlen(cpfix), strlen(cp), strlen(cval));

void
rtcxfl(cpfix, cp, cval)
    char *  cpfix
    char *  cp
    char *  cval
    CODE:
    rtcxfl_(cpfix, cp, cval, strlen(cpfix), strlen(cp), strlen(cval));

void
rtpenv(cpfix, cp, ipara)
    char *  cpfix
    char *  cp
    void *  ipara
    CODE:
    rtpenv_(cpfix, cp, ipara, strlen(cpfix), strlen(cp));

void
rtpget(cpfix, cp, ipara, max__)
    char *  cpfix
    char *  cp
    void *  ipara
    integer *  max__
    CODE:
    rtpget_(cpfix, cp, ipara, max__, strlen(cpfix), strlen(cp));

void
rtpopt(cpfix, cp, ipara)
    char *  cpfix
    char *  cp
    void *  ipara
    CODE:
    rtpopt_(cpfix, cp, ipara, strlen(cpfix), strlen(cp));

void
rtpxfl(cpfix, cp, ipara)
    char *  cpfix
    char *  cp
    void *  ipara
    CODE:
    rtpxfl_(cpfix, cp, ipara, strlen(cpfix), strlen(cp));

void
cfsrch(cplist, np, cflist, nf, cfname)
    char *  cplist
    integer np
    char *  cflist
    integer nf
    char *  cfname
    CODE:
    cfsrch_(cplist, &np, cflist, &nf, cfname, strlen(cplist), strlen(cflist), strlen(cfname));

logical
lchreq(ch1, ch2)
    char *  ch1
    char *  ch2
    CODE:
    RETVAL =     lchreq_(ch1, ch2, strlen(ch1), strlen(ch2));
    OUTPUT:
    RETVAL

integer
iufopn()
    CODE:
    RETVAL =     iufopn_();
    OUTPUT:
    RETVAL

integer
igus(rx)
    real rx
    CODE:
    RETVAL =     igus_(&rx);
    OUTPUT:
    RETVAL

integer
imod(ix, id)
    integer ix
    integer id
    CODE:
    RETVAL =     imod_(&ix, &id);
    OUTPUT:
    RETVAL

doublereal
rmod(rx, rd)
    real rx
    real rd
    CODE:
    RETVAL =     rmod_(&rx, &rd);
    OUTPUT:
    RETVAL

doublereal
rexp(rx, ib, ie)
    real rx
    integer ib
    integer ie
    CODE:
    RETVAL =     rexp_(&rx, &ib, &ie);
    OUTPUT:
    RETVAL

doublereal
rfpi()
    CODE:
    RETVAL =     rfpi_();
    OUTPUT:
    RETVAL

doublereal
rd2r(x)
    real x
    CODE:
    RETVAL =     rd2r_(&x);
    OUTPUT:
    RETVAL

doublereal
rr2d(x)
    real x
    CODE:
    RETVAL =     rr2d_(&x);
    OUTPUT:
    RETVAL

void
vignn(ix, n, jx)
    integer *  ix
    integer n
    integer jx
    CODE:
    vignn_(ix, &n, &jx);

void
vrgnn(rx, n, jx)
    real *  rx
    integer n
    integer jx
    CODE:
    vrgnn_(rx, &n, &jx);

integer
dxfloc(nd, ns, np, ncp)
    integer nd
    integer *  ns
    integer *  np
    integer *  ncp
    CODE:
    dxfloc_(&nd, ns, np, ncp);
    RETVAL =     *ncp;
    OUTPUT:
    RETVAL

void
dxiloc(nd, ns, np, ncp)
    integer nd
    integer *  ns
    integer *  np
    integer ncp
    CODE:
    dxiloc_(&nd, ns, np, &ncp);

void
cladj(chr)
    char *  chr
    CODE:
    cladj_(chr, strlen(chr));

void
cradj(chr)
    char *  chr
    CODE:
    cradj_(chr, strlen(chr));

void
crvrs(chr)
    char *  chr
    CODE:
    crvrs_(chr, strlen(chr));

integer
lenb(c__)
    char *  c__
    CODE:
    RETVAL =     lenb_(c__, strlen(c__));
    OUTPUT:
    RETVAL

integer
leny(c__)
    char *  c__
    CODE:
    RETVAL =     leny_(c__, strlen(c__));
    OUTPUT:
    RETVAL

integer
lenc(c__)
    char *  c__
    CODE:
    RETVAL =     lenc_(c__, strlen(c__));
    OUTPUT:
    RETVAL

integer
lenz(c__)
    char *  c__
    CODE:
    RETVAL =     lenz_(c__, strlen(c__));
    OUTPUT:
    RETVAL

integer
ifromc(cx)
    char *  cx
    CODE:
    RETVAL =     ifromc_(cx, strlen(cx));
    OUTPUT:
    RETVAL

logical
lfromc(cx)
    char *  cx
    CODE:
    RETVAL =     lfromc_(cx, strlen(cx));
    OUTPUT:
    RETVAL

doublereal
rfromc(cx)
    char *  cx
    CODE:
    RETVAL =     rfromc_(cx, strlen(cx));
    OUTPUT:
    RETVAL

logical
lreq(x, y)
    real x
    real y
    CODE:
    RETVAL =     lreq_(&x, &y);
    OUTPUT:
    RETVAL

logical
lrne(x, y)
    real x
    real y
    CODE:
    RETVAL =     lrne_(&x, &y);
    OUTPUT:
    RETVAL

logical
lrlt(x, y)
    real x
    real y
    CODE:
    RETVAL =     lrlt_(&x, &y);
    OUTPUT:
    RETVAL

logical
lrle(x, y)
    real x
    real y
    CODE:
    RETVAL =     lrle_(&x, &y);
    OUTPUT:
    RETVAL

logical
lrgt(x, y)
    real x
    real y
    CODE:
    RETVAL =     lrgt_(&x, &y);
    OUTPUT:
    RETVAL

logical
lrge(x, y)
    real x
    real y
    CODE:
    RETVAL =     lrge_(&x, &y);
    OUTPUT:
    RETVAL

logical
lreqa(x, y, epsl)
    real x
    real y
    real epsl
    CODE:
    RETVAL =     lreqa_(&x, &y, &epsl);
    OUTPUT:
    RETVAL

logical
lrnea(x, y, epsl)
    real x
    real y
    real epsl
    CODE:
    RETVAL =     lrnea_(&x, &y, &epsl);
    OUTPUT:
    RETVAL

logical
lrlta(x, y, epsl)
    real x
    real y
    real epsl
    CODE:
    RETVAL =     lrlta_(&x, &y, &epsl);
    OUTPUT:
    RETVAL

logical
lrlea(x, y, epsl)
    real x
    real y
    real epsl
    CODE:
    RETVAL =     lrlea_(&x, &y, &epsl);
    OUTPUT:
    RETVAL

logical
lrgta(x, y, epsl)
    real x
    real y
    real epsl
    CODE:
    RETVAL =     lrgta_(&x, &y, &epsl);
    OUTPUT:
    RETVAL

logical
lrgea(x, y, epsl)
    real x
    real y
    real epsl
    CODE:
    RETVAL =     lrgea_(&x, &y, &epsl);
    OUTPUT:
    RETVAL

integer
iblklt(rx, n, rr)
    real  * rx
    integer n
    real rr
    CODE:
    RETVAL =     iblklt_(rx, &n, &rr);
    OUTPUT:
    RETVAL

integer
iblkle(rx, n, rr)
    real  * rx
    integer n
    real rr
    CODE:
    RETVAL =     iblkle_(rx, &n, &rr);
    OUTPUT:
    RETVAL

integer
iblkgt(rx, n, rr)
    real  * rx
    integer n
    real rr
    CODE:
    RETVAL =     iblkgt_(rx, &n, &rr);
    OUTPUT:
    RETVAL

integer
iblkge(rx, n, rr)
    real  * rx
    integer n
    real rr
    CODE:
    RETVAL =     iblkge_(rx, &n, &rr);
    OUTPUT:
    RETVAL

void
gnlt(rx, bx, ip)
    real rx
    real *  bx
    integer *  ip
    CODE:
    gnlt_(&rx, bx, ip);

void
gngt(rx, bx, ip)
    real rx
    real *  bx
    integer *  ip
    CODE:
    gngt_(&rx, bx, ip);

void
gnle(rx, bx, ip)
    real rx
    real *  bx
    integer *  ip
    CODE:
    gnle_(&rx, bx, ip);

void
gnge(rx, bx, ip)
    real rx
    real *  bx
    integer *  ip
    CODE:
    gnge_(&rx, bx, ip);

void
gnsblk(xb, nb)
    real *  xb
    integer nb
    CODE:
    gnsblk_(xb, &nb);

void
gnqblk(xb, nb)
    real *  xb
    integer nb
    CODE:
    gnqblk_(xb, &nb);

void
gnsave()
    CODE:
    gnsave_();

void
gnrset()
    CODE:
    gnrset_();

doublereal
rgnlt(rx)
    real rx
    CODE:
    RETVAL =     rgnlt_(&rx);
    OUTPUT:
    RETVAL

doublereal
rgnle(rx)
    real rx
    CODE:
    RETVAL =     rgnle_(&rx);
    OUTPUT:
    RETVAL

doublereal
rgngt(rx)
    real rx
    CODE:
    RETVAL =     rgngt_(&rx);
    OUTPUT:
    RETVAL

doublereal
rgnge(rx)
    real rx
    CODE:
    RETVAL =     rgnge_(&rx);
    OUTPUT:
    RETVAL

integer
irlt(rx)
    real rx
    CODE:
    RETVAL =     irlt_(&rx);
    OUTPUT:
    RETVAL

integer
irle(rx)
    real rx
    CODE:
    RETVAL =     irle_(&rx);
    OUTPUT:
    RETVAL

integer
irgt(rx)
    real rx
    CODE:
    RETVAL =     irgt_(&rx);
    OUTPUT:
    RETVAL

integer
irge(rx)
    real rx
    CODE:
    RETVAL =     irge_(&rx);
    OUTPUT:
    RETVAL

integer
indxcf(cx, n, jd, ch)
    char *  cx
    integer n
    integer jd
    char *  ch
    CODE:
    RETVAL =     indxcf_(cx, &n, &jd, ch, strlen(cx), strlen(ch));
    OUTPUT:
    RETVAL

integer
indxcl(cx, n, jd, ch)
    char *  cx
    integer n
    integer jd
    char *  ch
    CODE:
    RETVAL =     indxcl_(cx, &n, &jd, ch, strlen(cx), strlen(ch));
    OUTPUT:
    RETVAL

integer
indxnf(cx, n, jd, ch)
    char *  cx
    integer n
    integer jd
    char *  ch
    CODE:
    RETVAL =     indxnf_(cx, &n, &jd, ch, strlen(cx), strlen(ch));
    OUTPUT:
    RETVAL

integer
indxnl(cx, n, jd, ch)
    char *  cx
    integer n
    integer jd
    char *  ch
    CODE:
    RETVAL =     indxnl_(cx, &n, &jd, ch, strlen(cx), strlen(ch));
    OUTPUT:
    RETVAL

integer
indxmf(cx, n, jd, ch)
    char *  cx
    integer n
    integer jd
    char *  ch
    CODE:
    RETVAL =     indxmf_(cx, &n, &jd, ch, strlen(cx), strlen(ch));
    OUTPUT:
    RETVAL

integer
indxml(cx, n, jd, ch)
    char *  cx
    integer n
    integer jd
    char *  ch
    CODE:
    RETVAL =     indxml_(cx, &n, &jd, ch, strlen(cx), strlen(ch));
    OUTPUT:
    RETVAL

integer
indxif(ix, n, jd, ii)
    integer *  ix
    integer n
    integer jd
    integer ii
    CODE:
    RETVAL =     indxif_(ix, &n, &jd, &ii);
    OUTPUT:
    RETVAL

integer
indxil(ix, n, jd, ii)
    integer *  ix
    integer n
    integer jd
    integer ii
    CODE:
    RETVAL =     indxil_(ix, &n, &jd, &ii);
    OUTPUT:
    RETVAL

integer
indxrf(rx, n, jd, rr)
    real *  rx
    integer n
    integer jd
    real rr
    CODE:
    RETVAL =     indxrf_(rx, &n, &jd, &rr);
    OUTPUT:
    RETVAL

integer
indxrl(rx, n, jd, rr)
    real *  rx
    integer n
    integer jd
    real rr
    CODE:
    RETVAL =     indxrl_(rx, &n, &jd, &rr);
    OUTPUT:
    RETVAL

integer
nindxc(cx, n, jd, ch)
    char *  cx
    integer n
    integer jd
    char *  ch
    CODE:
    RETVAL =     nindxc_(cx, &n, &jd, ch, strlen(cx), strlen(ch));
    OUTPUT:
    RETVAL

integer
nindxn(cx, n, jd, ch)
    char *  cx
    integer n
    integer jd
    char *  ch
    CODE:
    RETVAL =     nindxn_(cx, &n, &jd, ch, strlen(cx), strlen(ch));
    OUTPUT:
    RETVAL

integer
nindxm(cx, n, jd, ch)
    char *  cx
    integer n
    integer jd
    char *  ch
    CODE:
    RETVAL =     nindxm_(cx, &n, &jd, ch, strlen(cx), strlen(ch));
    OUTPUT:
    RETVAL

integer
nindxi(ix, n, jd, ii)
    integer *  ix
    integer n
    integer jd
    integer ii
    CODE:
    RETVAL =     nindxi_(ix, &n, &jd, &ii);
    OUTPUT:
    RETVAL

integer
nindxr(rx, n, jd, rr)
    real *  rx
    integer n
    integer jd
    real rr
    CODE:
    RETVAL =     nindxr_(rx, &n, &jd, &rr);
    OUTPUT:
    RETVAL

integer
imax(ix, n, jx)
    integer *  ix
    integer n
    integer jx
    CODE:
    RETVAL =     imax_(ix, &n, &jx);
    OUTPUT:
    RETVAL

integer
imin(ix, n, jx)
    integer *  ix
    integer n
    integer jx
    CODE:
    RETVAL =     imin_(ix, &n, &jx);
    OUTPUT:
    RETVAL

integer
isum(ix, n, jx)
    integer *  ix
    integer n
    integer jx
    CODE:
    RETVAL =     isum_(ix, &n, &jx);
    OUTPUT:
    RETVAL

doublereal
rmax(rx, n, jx)
    real *  rx
    integer n
    integer jx
    CODE:
    RETVAL =     rmax_(rx, &n, &jx);
    OUTPUT:
    RETVAL

doublereal
rmin(rx, n, jx)
    real *  rx
    integer n
    integer jx
    CODE:
    RETVAL =     rmin_(rx, &n, &jx);
    OUTPUT:
    RETVAL

doublereal
rsum(rx, n, jx)
    real *  rx
    integer n
    integer jx
    CODE:
    RETVAL =     rsum_(rx, &n, &jx);
    OUTPUT:
    RETVAL

doublereal
rave(rx, n, jx)
    real *  rx
    integer n
    integer jx
    CODE:
    RETVAL =     rave_(rx, &n, &jx);
    OUTPUT:
    RETVAL

doublereal
rvar(rx, n, jx)
    real *  rx
    integer n
    integer jx
    CODE:
    RETVAL =     rvar_(rx, &n, &jx);
    OUTPUT:
    RETVAL

doublereal
rstd(rx, n, jx)
    real *  rx
    integer n
    integer jx
    CODE:
    RETVAL =     rstd_(rx, &n, &jx);
    OUTPUT:
    RETVAL

doublereal
rrms(rx, n, jx)
    real *  rx
    integer n
    integer jx
    CODE:
    RETVAL =     rrms_(rx, &n, &jx);
    OUTPUT:
    RETVAL

doublereal
ramp(rx, n, jx)
    real *  rx
    integer n
    integer jx
    CODE:
    RETVAL =     ramp_(rx, &n, &jx);
    OUTPUT:
    RETVAL

doublereal
rvmax(rx, ns, np, nq, nd)
    real *  rx
    integer *  ns
    integer *  np
    integer *  nq
    integer nd
    CODE:
    RETVAL =     rvmax_(rx, ns, np, nq, &nd);
    OUTPUT:
    RETVAL

doublereal
rvmin(rx, ns, np, nq, nd)
    real *  rx
    integer *  ns
    integer *  np
    integer *  nq
    integer nd
    CODE:
    RETVAL =     rvmin_(rx, ns, np, nq, &nd);
    OUTPUT:
    RETVAL

doublereal
rprd(rx, ry, n, jx, jy)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    CODE:
    RETVAL =     rprd_(rx, ry, &n, &jx, &jy);
    OUTPUT:
    RETVAL

doublereal
rcov(rx, ry, n, jx, jy)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    CODE:
    RETVAL =     rcov_(rx, ry, &n, &jx, &jy);
    OUTPUT:
    RETVAL

doublereal
rcor(rx, ry, n, jx, jy)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    CODE:
    RETVAL =     rcor_(rx, ry, &n, &jx, &jy);
    OUTPUT:
    RETVAL

void
vifna(ix, iy, n, jx, jy, ifna)
    integer *  ix
    integer *  iy
    integer n
    integer jx
    integer jy
    U_fp ifna
    CODE:
    vifna_(ix, iy, &n, &jx, &jy, ifna);

void
viinc(ix, iy, n, jx, jy, ii)
    integer *  ix
    integer *  iy
    integer n
    integer jx
    integer jy
    integer ii
    CODE:
    viinc_(ix, iy, &n, &jx, &jy, &ii);

void
vifct(ix, iy, n, jx, jy, ii)
    integer *  ix
    integer *  iy
    integer n
    integer jx
    integer jy
    integer ii
    CODE:
    vifct_(ix, iy, &n, &jx, &jy, &ii);

void
vicon(ix, iy, n, jx, jy, ii)
    integer *  ix
    integer *  iy
    integer n
    integer jx
    integer jy
    integer ii
    CODE:
    vicon_(ix, iy, &n, &jx, &jy, &ii);

void
viset(ix, iy, n, jx, jy)
    integer *  ix
    integer *  iy
    integer n
    integer jx
    integer jy
    CODE:
    viset_(ix, iy, &n, &jx, &jy);

void
iadd(ix, n, jx, ii)
    integer *  ix
    integer n
    integer jx
    integer ii
    CODE:
    iadd_(ix, &n, &jx, &ii);

void
imlt(ix, n, jx, ii)
    integer *  ix
    integer n
    integer jx
    integer ii
    CODE:
    imlt_(ix, &n, &jx, &ii);

void
iset(ix, n, jx, ii)
    integer *  ix
    integer n
    integer jx
    integer ii
    CODE:
    iset_(ix, &n, &jx, &ii);

void
vifnb(ix, iy, iz, n, jx, jy, jz, ifnb)
    integer *  ix
    integer *  iy
    integer *  iz
    integer n
    integer jx
    integer jy
    integer jz
    U_fp ifnb
    CODE:
    vifnb_(ix, iy, iz, &n, &jx, &jy, &jz,  ifnb);

void
viadd(ix, iy, iz, n, jx, jy, jz)
    integer *  ix
    integer *  iy
    integer *  iz
    integer n
    integer jx
    integer jy
    integer jz
    CODE:
    viadd_(ix, iy, iz, &n, &jx, &jy, &jz);

void
visub(ix, iy, iz, n, jx, jy, jz)
    integer *  ix
    integer *  iy
    integer *  iz
    integer n
    integer jx
    integer jy
    integer jz
    CODE:
    visub_(ix, iy, iz, &n, &jx, &jy, &jz);

void
vimlt(ix, iy, iz, n, jx, jy, jz)
    integer *  ix
    integer *  iy
    integer *  iz
    integer n
    integer jx
    integer jy
    integer jz
    CODE:
    vimlt_(ix, iy, iz, &n, &jx, &jy, &jz);

void
vidiv(ix, iy, iz, n, jx, jy, jz)
    integer *  ix
    integer *  iy
    integer *  iz
    integer n
    integer jx
    integer jy
    integer jz
    CODE:
    vidiv_(ix, iy, iz, &n, &jx, &jy, &jz);

void
vrfna(rx, ry, n, jx, jy, rfna)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    U_fp rfna
    CODE:
    vrfna_(rx, ry, &n, &jx, &jy,  rfna);

void
vrinc(rx, ry, n, jx, jy, rr)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    real rr
    CODE:
    vrinc_(rx, ry, &n, &jx, &jy, &rr);

void
vrfct(rx, ry, n, jx, jy, rr)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    real rr
    CODE:
    vrfct_(rx, ry, &n, &jx, &jy, &rr);

void
vrcon(rx, ry, n, jx, jy, rr)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    real rr
    CODE:
    vrcon_(rx, ry, &n, &jx, &jy, &rr);

void
vrset(rx, ry, n, jx, jy)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    CODE:
    vrset_(rx, ry, &n, &jx, &jy);

void
radd(rx, n, jx, rr)
    real *  rx
    integer n
    integer jx
    real rr
    CODE:
    radd_(rx, &n, &jx, &rr);

void
rset(rx, n, jx, rr)
    real *  rx
    integer n
    integer jx
    real rr
    CODE:
    rset_(rx, &n, &jx, &rr);

void
vrfnb(rx, ry, rz, n, jx, jy, jz, rfnb)
    real *  rx
    real *  ry
    real *  rz
    integer n
    integer jx
    integer jy
    integer jz
    U_fp rfnb
    CODE:
    vrfnb_(rx, ry, rz, &n, &jx, &jy, &jz,  rfnb);

void
vradd(rx, ry, rz, n, jx, jy, jz)
    real *  rx
    real *  ry
    real *  rz
    integer n
    integer jx
    integer jy
    integer jz
    CODE:
    vradd_(rx, ry, rz, &n, &jx, &jy, &jz);

void
vrsub(rx, ry, rz, n, jx, jy, jz)
    real *  rx
    real *  ry
    real *  rz
    integer n
    integer jx
    integer jy
    integer jz
    CODE:
    vrsub_(rx, ry, rz, &n, &jx, &jy, &jz);

void
vrmlt(rx, ry, rz, n, jx, jy, jz)
    real *  rx
    real *  ry
    real *  rz
    integer n
    integer jx
    integer jy
    integer jz
    CODE:
    vrmlt_(rx, ry, rz, &n, &jx, &jy, &jz);

void
vrdiv(rx, ry, rz, n, jx, jy, jz)
    real *  rx
    real *  ry
    real *  rz
    integer n
    integer jx
    integer jy
    integer jz
    CODE:
    vrdiv_(rx, ry, rz, &n, &jx, &jy, &jz);

void
ct2pc(r__, theta, x, y)
    real r__
    real theta
    real *  x
    real *  y
    CODE:
    ct2pc_(&r__, &theta, x, y);

void
ct2cp(x, y, r__, theta)
    real x
    real y
    real *  r__
    real *  theta
    CODE:
    ct2cp_(&x, &y, r__, theta);

void
ct2ec(u, v, x, y)
    real u
    real v
    real *  x
    real *  y
    CODE:
    ct2ec_(&u, &v, x, y);

void
ct2bc(u, v, x, y)
    real u
    real v
    real *  x
    real *  y
    CODE:
    ct2bc_(&u, &v, x, y);

void
ct2hc(u, v, x, y)
    real u
    real v
    real *  x
    real *  y
    CODE:
    ct2hc_(&u, &v, x, y);

void
ct2ch(x, y, u, v)
    real x
    real y
    real *  u
    real *  v
    CODE:
    ct2ch_(&x, &y, u, v);

void
ct3sc(r__, theta, phi, x, y, z__)
    real r__
    real theta
    real phi
    real *  x
    real *  y
    real *  z__
    CODE:
    ct3sc_(&r__, &theta, &phi, x, y, z__);

void
ct3cs(x, y, z__, r__, theta, phi)
    real x
    real y
    real z__
    real *  r__
    real *  theta
    real *  phi
    CODE:
    ct3cs_(&x, &y, &z__, r__, theta, phi);

void
cr2c(theta, x0, y0, x1, y1)
    real theta
    real x0
    real y0
    real *  x1
    real *  y1
    CODE:
    cr2c_(&theta, &x0, &y0, x1, y1);

void
cr3c(theta, phi, psi, x0, y0, z0, x1, y1, z1)
    real theta
    real phi
    real psi
    real x0
    real y0
    real z0
    real *  x1
    real *  y1
    real *  z1
    CODE:
    cr3c_(&theta, &phi, &psi, &x0, &y0, &z0, x1, y1, z1);

void
cr3s(theta, phi, psi, theta0, phi0, theta1, phi1)
    real theta
    real phi
    real psi
    real theta0
    real phi0
    real *  theta1
    real *  phi1
    CODE:
    cr3s_(&theta, &phi, &psi, &theta0, &phi0, theta1, phi1);

void
mpfcyl(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfcyl_(&xlon, &ylat, x, y);

void
mpicyl(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpicyl_(&x, &y, xlon, ylat);

void
mpfmer(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfmer_(&xlon, &ylat, x, y);

void
mpimer(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpimer_(&x, &y, xlon, ylat);

void
mpfmwd(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfmwd_(&xlon, &ylat, x, y);

void
mpimwd(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpimwd_(&x, &y, xlon, ylat);

void
mpfmwl(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfmwl_(&xlon, &ylat, x, y);

void
mpimwl(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpimwl_(&x, &y, xlon, ylat);

void
mpfhmr(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfhmr_(&xlon, &ylat, x, y);

void
mpihmr(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpihmr_(&x, &y, xlon, ylat);

void
mpfek6(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfek6_(&xlon, &ylat, x, y);

void
mpiek6(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpiek6_(&x, &y, xlon, ylat);

void
mpfktd(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfktd_(&xlon, &ylat, x, y);

void
mpiktd(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpiktd_(&x, &y, xlon, ylat);

void
mpfcon(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfcon_(&xlon, &ylat, x, y);

void
mpicon(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpicon_(&x, &y, xlon, ylat);

void
mpscon(ylat0)
    real ylat0
    CODE:
    mpscon_(&ylat0);

void
mpfcoa(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfcoa_(&xlon, &ylat, x, y);

void
mpicoa(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpicoa_(&x, &y, xlon, ylat);

void
mpscoa(ylat0)
    real ylat0
    CODE:
    mpscoa_(&ylat0);

void
mpfcoc(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfcoc_(&xlon, &ylat, x, y);

void
mpicoc(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpicoc_(&x, &y, xlon, ylat);

void
mpscoc(ylat1, ylat2)
    real ylat1
    real ylat2
    CODE:
    mpscoc_(&ylat1, &ylat2);

void
mpfbon(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfbon_(&xlon, &ylat, x, y);

void
mpibon(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpibon_(&x, &y, xlon, ylat);

void
mpsbon(ylat0)
    real ylat0
    CODE:
    mpsbon_(&ylat0);

void
mpfotg(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfotg_(&xlon, &ylat, x, y);

void
mpiotg(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpiotg_(&x, &y, xlon, ylat);

void
mpsotg(r0)
    real r0
    CODE:
    mpsotg_(&r0);

void
mpfpst(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfpst_(&xlon, &ylat, x, y);

void
mpipst(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpipst_(&x, &y, xlon, ylat);

void
mpfazm(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfazm_(&xlon, &ylat, x, y);

void
mpiazm(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpiazm_(&x, &y, xlon, ylat);

void
mpfaza(xlon, ylat, x, y)
    real xlon
    real ylat
    real *  x
    real *  y
    CODE:
    mpfaza_(&xlon, &ylat, x, y);

void
mpiaza(x, y, xlon, ylat)
    real x
    real y
    real *  xlon
    real *  ylat
    CODE:
    mpiaza_(&x, &y, xlon, ylat);

void
rffti(n, wsave)
    integer n
    real *  wsave
    CODE:
    rffti_(&n, wsave);

void
rfftf(n, r__, wsave)
    integer n
    real *  r__
    real *  wsave
    CODE:
    rfftf_(&n, r__, wsave);

void
rfftb(n, r__, wsave)
    integer n
    real *  r__
    real *  wsave
    CODE:
    rfftb_(&n, r__, wsave);

void
ezffti(n, wsave)
    integer n
    real *  wsave
    CODE:
    ezffti_(&n, wsave);

void
ezfftf(n, r__, azero, a, b, wsave)
    integer n
    real *  r__
    real *  azero
    real *  a
    real *  b
    real *  wsave
    CODE:
    ezfftf_(&n, r__, azero, a, b, wsave);

void
ezfftb(n, r__, azero, a, b, wsave)
    integer n
    real *  r__
    real *  azero
    real *  a
    real *  b
    real *  wsave
    CODE:
    ezfftb_(&n, r__, azero, a, b, wsave);

void
sinti(n, wsave)
    integer n
    real *  wsave
    CODE:
    sinti_(&n, wsave);

void
sint(n, x, wsave)
    integer n
    real *  x
    real *  wsave
    CODE:
    sint_(&n, x, wsave);

void
costi(n, wsave)
    integer n
    real *  wsave
    CODE:
    costi_(&n, wsave);

void
cost(n, x, wsave)
    integer n
    real *  x
    real *  wsave
    CODE:
    cost_(&n, x, wsave);

void
sinqi(n, wsave)
    integer n
    real *  wsave
    CODE:
    sinqi_(&n, wsave);

void
sinqf(n, x, wsave)
    integer n
    real *  x
    real *  wsave
    CODE:
    sinqf_(&n, x, wsave);

void
sinqb(n, x, wsave)
    integer n
    real *  x
    real *  wsave
    CODE:
    sinqb_(&n, x, wsave);

void
cosqi(n, wsave)
    integer n
    real *  wsave
    CODE:
    cosqi_(&n, wsave);

void
cosqf(n, x, wsave)
    integer n
    real *  x
    real *  wsave
    CODE:
    cosqf_(&n, x, wsave);

void
cosqb(n, x, wsave)
    integer n
    real *  x
    real *  wsave
    CODE:
    cosqb_(&n, x, wsave);

void
cffti(n, wsave)
    integer n
    real *  wsave
    CODE:
    cffti_(&n, wsave);

void
cfftf(n, c__, wsave)
    integer n
    real *  c__
    real *  wsave
    CODE:
    cfftf_(&n, c__, wsave);

void
cfftb(n, c__, wsave)
    integer n
    real *  c__
    real *  wsave
    CODE:
    cfftb_(&n, c__, wsave);

void
odrkg(n, fcn, t, dt, x, dx, xout, work)
    integer n
    S_fp fcn
    real *  t
    real *  dt
    real *  x
    real *  dx
    real *  xout
    real *  work
    CODE:
    odrkg_(&n,  fcn, t, dt, x, dx, xout, work);

void
odrk4(n, fcn, t, dt, x, dx, xout, work)
    integer n
    S_fp fcn
    real *  t
    real *  dt
    real *  x
    real *  dx
    real *  xout
    real *  work
    CODE:
    odrk4_(&n,  fcn, t, dt, x, dx, xout, work);

void
odrk2(n, fcn, t, dt, x, dx, xout, work)
    integer n
    S_fp fcn
    real *  t
    real *  dt
    real *  x
    real *  dx
    real *  xout
    real *  work
    CODE:
    odrk2_(&n,  fcn, t, dt, x, dx, xout, work);

void
odrk1(n, fcn, t, dt, x, dx, xout, work)
    integer n
    U_fp fcn
    real *  t
    real *  dt
    real *  x
    real *  dx
    real *  xout
    real *  work
    CODE:
    odrk1_(&n,  fcn, t, dt, x, dx, xout, work);

void
odrkgr(n, fcn, t, dt, epsl, x, work)
    integer n
    S_fp fcn
    real *  t
    real *  dt
    real *  epsl
    real *  x
    real *  work
    CODE:
    odrkgr_(&n,  fcn, t, dt, epsl, x, work);

void
odrkgs(n, fcn, t, dt, epsl, x, work)
    integer n
    S_fp fcn
    real *  t
    real *  dt
    real *  epsl
    real *  x
    real *  work
    CODE:
    odrkgs_(&n,  fcn, t, dt, epsl, x, work);

void
odrk4r(n, fcn, t, dt, epsl, x, work)
    integer n
    S_fp fcn
    real *  t
    real *  dt
    real *  epsl
    real *  x
    real *  work
    CODE:
    odrk4r_(&n,  fcn, t, dt, epsl, x, work);

void
odrk4s(n, fcn, t, dt, epsl, x, work)
    integer n
    S_fp fcn
    real *  t
    real *  dt
    real *  epsl
    real *  x
    real *  work
    CODE:
    odrk4s_(&n,  fcn, t, dt, epsl, x, work);

void
odrkdu(n, algr, fcn, t, tend, istep, x, work)
    integer n
    S_fp algr
    S_fp fcn
    real *  t
    real *  tend
    integer istep
    real *  x
    real *  work
    CODE:
    odrkdu_(&n,  algr,  fcn, t, tend, &istep, x, work);

void
odrkdv(n, steper, fcn, t, tend, dt, x, work)
    integer n
    S_fp steper
    U_fp fcn
    real *  t
    real *  tend
    real *  dt
    real *  x
    real *  work
    CODE:
    odrkdv_(&n,  steper,  fcn, t, tend, dt, x, work);

integer
odiget(cp)
    char *  cp 
    CODE:
    integer ipara;
    odiget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
odiset(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    odiset_(cp, &ipara, strlen(cp));

void
odistx(cp, ipara)
    char *  cp
    integer ipara
    CODE:
    odistx_(cp, &ipara, strlen(cp));

logical
odlget(cp)
    char *  cp 
    CODE:
    logical ipara;
    odlget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
odlset(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    odlset_(cp, &ipara, strlen(cp));

void
odlstx(cp, ipara)
    char *  cp
    logical ipara
    CODE:
    odlstx_(cp, &ipara, strlen(cp));

void
odpget(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    odpget_(cp, ipara, strlen(cp));

void
odpset(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    odpset_(cp, ipara, strlen(cp));

void
odpstx(cp, ipara)
    char *  cp
    void *  ipara
    CODE:
    odpstx_(cp, ipara, strlen(cp));

real
odrget(cp)
    char *  cp 
    CODE:
    real ipara;
    odrget_(cp, &ipara, strlen(cp));
    RETVAL =     ipara;
    OUTPUT:
    RETVAL

void
odrset(cp, ipara)
    char *  cp
    real ipara
    CODE:
    odrset_(cp, &ipara, strlen(cp));

void
odrstx(cp, ipara)
    char *  cp
    real ipara
    CODE:
    odrstx_(cp, &ipara, strlen(cp));

void
shtint(mm, jm, im, q)
    integer mm
    integer jm
    integer im
    real *  q
    CODE:
    shtint_(&mm, &jm, &im, q);

void
shtnml(mm, n, m, lr, li)
    integer mm
    integer n
    integer m
    integer lr
    integer li
    CODE:
    shtnml_(&mm, &n, &m, &lr, &li);

void
shtlap(mm, ind, a, b)
    integer mm
    integer ind
    real *  a
    real *  b
    CODE:
    shtlap_(&mm, &ind, a, b);

void
shts2w(mm, jm, isw, s, w, q)
    integer mm
    integer jm
    integer isw
    real *  s
    real *  w
    real *  q
    CODE:
    shts2w_(&mm, &jm, &isw, s, w, q);

void
shtw2g(mm, jm, im, w, g, q)
    integer mm
    integer jm
    integer im
    real *  w
    real *  g
    real *  q
    CODE:
    shtw2g_(&mm, &jm, &im, w, g, q);

void
shts2g(mm, jm, im, isw, s, w, g, q)
    integer mm
    integer jm
    integer im
    integer isw
    real *  s
    real *  w
    real *  g
    real *  q
    CODE:
    shts2g_(&mm, &jm, &im, &isw, s, w, g, q);

void
shtg2w(mm, jm, im, g, w, q)
    integer mm
    integer jm
    integer im
    real *  g
    real *  w
    real *  q
    CODE:
    shtg2w_(&mm, &jm, &im, g, w, q);

void
shtw2s(mm, jm, isw, s, w, q)
    integer mm
    integer jm
    integer isw
    real *  s
    real *  w
    real *  q
    CODE:
    shtw2s_(&mm, &jm, &isw, s, w, q);

void
shtg2s(mm, jm, im, isw, g, w, s, q)
    integer mm
    integer jm
    integer im
    integer isw
    real *  g
    real *  w
    real *  s
    real *  q
    CODE:
    shtg2s_(&mm, &jm, &im, &isw, g, w, s, q);

void
shtswa(mm, jm, isw, m1, m2, s, w, q)
    integer mm
    integer jm
    integer isw
    integer m1
    integer m2
    real *  s
    real *  w
    real *  q
    CODE:
    shtswa_(&mm, &jm, &isw, &m1, &m2, s, w, q);

void
shtwga(mm, jm, im, m1, m2, w, g, q)
    integer mm
    integer jm
    integer im
    integer m1
    integer m2
    real *  w
    real *  g
    real *  q
    CODE:
    shtwga_(&mm, &jm, &im, &m1, &m2, w, g, q);

void
shtsga(mm, jm, im, isw, m1, m2, s, w, g, q)
    integer mm
    integer jm
    integer im
    integer isw
    integer m1
    integer m2
    real *  s
    real *  w
    real *  g
    real *  q
    CODE:
    shtsga_(&mm, &jm, &im, &isw, &m1, &m2, s, w, g, q);

void
shtswm(mm, jm, m, isw, s, wr, wi, q)
    integer mm
    integer jm
    integer m
    integer isw
    real *  s
    real *  wr
    real *  wi
    real *  q
    CODE:
    shtswm_(&mm, &jm, &m, &isw, s, wr, wi, q);

void
shtwgm(mm, jm, im, m, wr, wi, g, q)
    integer mm
    integer jm
    integer im
    integer m
    real *  wr
    real *  wi
    real *  g
    real *  q
    CODE:
    shtwgm_(&mm, &jm, &im, &m, wr, wi, g, q);

void
shtsgm(mm, jm, im, m, isw, s, wr, wi, g, q)
    integer mm
    integer jm
    integer im
    integer m
    integer isw
    real *  s
    real *  wr
    real *  wi
    real *  g
    real *  q
    CODE:
    shtsgm_(&mm, &jm, &im, &m, &isw, s, wr, wi, g, q);

void
shtswz(mm, jm, isw, s, wz, q)
    integer mm
    integer jm
    integer isw
    real *  s
    real *  wz
    real *  q
    CODE:
    shtswz_(&mm, &jm, &isw, s, wz, q);

void
shtwgz(jm, im, wz, g)
    integer jm
    integer im
    real *  wz
    real *  g
    CODE:
    shtwgz_(&jm, &im, wz, g);

void
shtsgz(mm, jm, im, isw, s, wz, g, q)
    integer mm
    integer jm
    integer im
    integer isw
    real *  s
    real *  wz
    real *  g
    real *  q
    CODE:
    shtsgz_(&mm, &jm, &im, &isw, s, wz, g, q);

void
shtswj(mm, jm, isw, j, m1, m2, s, wj, q)
    integer mm
    integer jm
    integer isw
    integer j
    integer m1
    integer m2
    real *  s
    real *  wj
    real *  q
    CODE:
    shtswj_(&mm, &jm, &isw, &j, &m1, &m2, s, wj, q);

void
shtwgj(mm, im, m1, m2, wj, gj, q)
    integer mm
    integer im
    integer m1
    integer m2
    real *  wj
    real *  gj
    real *  q
    CODE:
    shtwgj_(&mm, &im, &m1, &m2, wj, gj, q);

void
shtsgj(mm, jm, im, isw, j, m1, m2, s, wj, gj, q)
    integer mm
    integer jm
    integer im
    integer isw
    integer j
    integer m1
    integer m2
    real *  s
    real *  wj
    real *  gj
    real *  q
    CODE:
    shtsgj_(&mm, &jm, &im, &isw, &j, &m1, &m2, s, wj, gj, q);

void
shtfun(mm, jm, m, fun, q)
    integer mm
    integer jm
    integer m
    real *  fun
    real *  q
    CODE:
    shtfun_(&mm, &jm, &m, fun, q);

void
shtlfw(mm, jm, m, isw, wm, sm, q)
    integer mm
    integer jm
    integer m
    integer isw
    real *  wm
    real *  sm
    real *  q
    CODE:
    shtlfw_(&mm, &jm, &m, &isw, wm, sm, q);

void
shtlbw(mm, jm, m, isw, sm, wm, q)
    integer mm
    integer jm
    integer m
    integer isw
    real *  sm
    real *  wm
    real *  q
    CODE:
    shtlbw_(&mm, &jm, &m, &isw, sm, wm, q);

void
shtlib()
    CODE:
    shtlib_();

void
vs1int(wz, nw, ix)
    real *  wz
    integer *  nw
    integer ix
    CODE:
    vs1int_(wz, nw, &ix);

void
vs1din(wz, nw, ix, x)
    real *  wz
    integer *  nw
    integer ix
    real *  x
    CODE:
    vs1din_(wz, nw, &ix, x);

void
vs1out(wz, nw, ix)
    real *  wz
    integer *  nw
    integer ix
    CODE:
    vs1out_(wz, nw, &ix);

void
vs2int(wz, nw, ix, iy)
    real *  wz
    integer *  nw
    integer ix
    integer iy
    CODE:
    vs2int_(wz, nw, &ix, &iy);

void
vs2din(wz, nw, ix, iy, x, y)
    real *  wz
    integer *  nw
    integer ix
    integer iy
    real *  x
    real *  y
    CODE:
    vs2din_(wz, nw, &ix, &iy, x, y);

void
vs2out(wz, nw, ix, iy)
    real *  wz
    integer *  nw
    integer ix
    integer iy
    CODE:
    vs2out_(wz, nw, &ix, &iy);

void
vrintr(rx, n, jx)
    real *  rx
    integer n
    integer jx
    CODE:
    vrintr_(rx, &n, &jx);

void
vrrnm(rx, ry, n, jx, jy, nb)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    integer nb
    CODE:
    vrrnm_(rx, ry, &n, &jx, &jy, &nb);

void
vrrnm0(rx, ry, n, jx, jy, nb)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    integer nb
    CODE:
    vrrnm0_(rx, ry, &n, &jx, &jy, &nb);

void
vrrnm1(rx, ry, n, jx, jy, nb)
    real *  rx
    real *  ry
    integer n
    integer jx
    integer jy
    integer nb
    CODE:
    vrrnm1_(rx, ry, &n, &jx, &jy, &nb);

void
bitpic(ip, cp)
    integer ip
    char *  cp
    CODE:
    bitpic_(&ip, cp, strlen(cp));

integer
bitpci(cp, ip)
    char *  cp
    integer  * ip
    CODE:
    bitpci_(cp, ip, strlen(cp));
    RETVAL =     *ip;
    OUTPUT:
    RETVAL

void
gbyte(npack, iout, ibit, nbits)
    integer *  npack
    integer *  iout
    integer ibit
    integer nbits
    CODE:
    gbyte_(npack, iout, &ibit, &nbits);

void
gbytes(npack, isam, ibit, nbits, nskip, iter)
    integer *  npack
    integer *  isam
    integer ibit
    integer nbits
    integer nskip
    integer iter
    CODE:
    gbytes_(npack, isam, &ibit, &nbits, &nskip, &iter);

void
sbyte(npack, iout, ibit, nbits)
    integer *  npack
    integer *  iout
    integer *  ibit
    integer *  nbits
    CODE:
    sbyte_(npack, iout, ibit, nbits);

void
sbytes(npack, isam, ibit, nbits, nskip, iter)
    integer *  npack
    integer *  isam
    integer *  ibit
    integer *  nbits
    integer *  nskip
    integer *  iter
    CODE:
    sbytes_(npack, isam, ibit, nbits, nskip, iter);

long
iand(i, j)
    long i
    long j
    CODE:
    RETVAL =     iand_(&i, &j);
    OUTPUT:
    RETVAL

long
ior(i, j)
    long i
    long j
    CODE:
    RETVAL =     ior_(&i, &j);
    OUTPUT:
    RETVAL

long
ishift(i, nshift)
    long i
    long nshift
    CODE:
    RETVAL =     ishift_(&i, &nshift);
    OUTPUT:
    RETVAL

void
cupper(ch)
    char *  ch
    CODE:
    cupper_(ch, strlen(ch));

void
clower(ch)
    char *  ch
    CODE:
    clower_(ch, strlen(ch));

logical
lchrb(ch)
    char *  ch
    CODE:
    RETVAL =     lchrb_(ch, strlen(ch));
    OUTPUT:
    RETVAL

logical
lchrc(ch)
    char *  ch
    CODE:
    RETVAL =     lchrc_(ch, strlen(ch));
    OUTPUT:
    RETVAL

logical
lchrs(ch)
    char *  ch
    CODE:
    RETVAL =     lchrs_(ch, strlen(ch));
    OUTPUT:
    RETVAL

logical
lchrl(ch)
    char *  ch
    CODE:
    RETVAL =     lchrl_(ch, strlen(ch));
    OUTPUT:
    RETVAL

logical
lchrd(ch)
    char *  ch
    CODE:
    RETVAL =     lchrd_(ch, strlen(ch));
    OUTPUT:
    RETVAL

logical
lchra(ch)
    char *  ch
    CODE:
    RETVAL =     lchra_(ch, strlen(ch));
    OUTPUT:
    RETVAL

logical
lchrf(ch)
    char *  ch
    CODE:
    RETVAL =     lchrf_(ch, strlen(ch));
    OUTPUT:
    RETVAL

logical
lchr(char__, cref)
    char *  char__
    char *  cref
    CODE:
    RETVAL =     lchr_(char__, cref, strlen(char__), strlen(cref));
    OUTPUT:
    RETVAL

void
chngc(ch, ca, cb)
    char *  ch
    char *  ca
    char *  cb
    CODE:
    chngc_(ch, ca, cb, strlen(ch), strlen(ca), strlen(cb));

void
chngi(ch, ca, ii, cfmt)
    char *  ch
    char *  ca
    integer ii
    char *  cfmt
    CODE:
    chngi_(ch, ca, &ii, cfmt, strlen(ch), strlen(ca), strlen(cfmt));

void
chngr(ch, ca, rr, cfmt)
    char *  ch
    char *  ca
    real rr
    char *  cfmt
    CODE:
    chngr_(ch, ca, &rr, cfmt, strlen(ch), strlen(ca), strlen(cfmt));

void
chval(cfmt, val, cval)
    char *  cfmt
    real val
    char *  cval
    CODE:
    chval_(cfmt, &val, cval, strlen(cfmt), strlen(cval));

void
date12(idate, iy, itd)
    integer idate
    integer *  iy
    integer *  itd
    CODE:
    date12_(&idate, iy, itd);

void
date13(idate, iy, im, id)
    integer idate
    integer *  iy
    integer *  im
    integer *  id
    CODE:
    date13_(&idate, iy, im, id);

integer
date21(iy, itd)
    integer iy
    integer itd
    CODE:
    integer idate;
    date21_(&idate, &iy, &itd);
    RETVAL =     idate;
    OUTPUT:
    RETVAL

void
date23(iy, im, id, itd)
    integer *  iy
    integer *  im
    integer *  id
    integer *  itd
    CODE:
    date23_(iy, im, id, itd);

integer
date31(iy, im, id)
    integer iy
    integer im
    integer id
    CODE:
    integer idate;
    date31_(&idate, &iy, &im, &id);
    RETVAL =     idate;
    OUTPUT:
    RETVAL

void
date32(iy, im, id, itd)
    integer *  iy
    integer *  im
    integer *  id
    integer *  itd
    CODE:
    date32_(iy, im, id, itd);

void
datef1(n, idate, ndate)
    integer n
    integer *  idate
    integer *  ndate
    CODE:
    datef1_(&n, idate, ndate);

void
datef2(n, iy, itd, ny, ntd)
    integer n
    integer *  iy
    integer *  itd
    integer *  ny
    integer *  ntd
    CODE:
    datef2_(&n, iy, itd, ny, ntd);

void
datef3(n, iy, im, id, ny, nm, nd)
    integer n
    integer *  iy
    integer *  im
    integer *  id
    integer *  ny
    integer *  nm
    integer *  nd
    CODE:
    datef3_(&n, iy, im, id, ny, nm, nd);

void
dateg1(n, idate, ndate)
    integer n
    integer *  idate
    integer *  ndate
    CODE:
    dateg1_(&n, idate, ndate);

void
dateg2(n, iy, itd, ny, ntd)
    integer n
    integer *  iy
    integer *  itd
    integer *  ny
    integer *  ntd
    CODE:
    dateg2_(&n, iy, itd, ny, ntd);

void
dateg3(n, iy, im, id, ny, nm, nd)
    integer n
    integer *  iy
    integer *  im
    integer *  id
    integer *  ny
    integer *  nm
    integer *  nd
    CODE:
    dateg3_(&n, iy, im, id, ny, nm, nd);

integer
dateq1()
    CODE:
    integer idate;
    dateq1_(&idate);
    RETVAL =     idate;
    OUTPUT:
    RETVAL

void
dateq2(iy, itd)
    integer *  iy
    integer *  itd
    CODE:
    dateq2_(iy, itd);

void
dateq3(iy, im, id)
    int *  iy
    int *  im
    int *  id
    CODE:
    dateq3_(iy, im, id);

void
datec1(cform, idate)
    char *  cform
    integer idate
    CODE:
    datec1_(cform, &idate, strlen(cform));

void
datec2(cform, iy, itd)
    char *  cform
    integer iy
    integer itd
    CODE:
    datec2_(cform, &iy, &itd, strlen(cform));

void
datec3(cform, iy, im, id)
    char *  cform
    integer iy
    integer im
    integer id
    CODE:
    datec3_(cform, &iy, &im, &id, strlen(cform));

integer
ndate1(idate, ndate)
    integer idate
    integer ndate
    CODE:
    RETVAL =     ndate1_(&idate, &ndate);
    OUTPUT:
    RETVAL

integer
ndate2(iy, itd, ny, ntd)
    integer iy
    integer itd
    integer ny
    integer ntd
    CODE:
    RETVAL =     ndate2_(&iy, &itd, &ny, &ntd);
    OUTPUT:
    RETVAL

integer
ndate3(iy, im, id, ny, nm, nd)
    integer iy
    integer im
    integer id
    integer ny
    integer nm
    integer nd
    CODE:
    RETVAL =     ndate3_(&iy, &im, &id, &ny, &nm, &nd);
    OUTPUT:
    RETVAL

integer
iweek1(idate)
    integer idate
    CODE:
    RETVAL =     iweek1_(&idate);
    OUTPUT:
    RETVAL

integer
iweek2(iy, itd)
    integer iy
    integer itd
    CODE:
    RETVAL =     iweek2_(&iy, &itd);
    OUTPUT:
    RETVAL

integer
iweek3(iy, im, id)
    integer iy
    integer im
    integer id
    CODE:
    RETVAL =     iweek3_(&iy, &im, &id);
    OUTPUT:
    RETVAL

integer
ndmon(iy, im)
    integer iy
    integer im
    CODE:
    RETVAL =     ndmon_(&iy, &im);
    OUTPUT:
    RETVAL

integer
ndyear(iy)
    integer iy
    CODE:
    RETVAL =     ndyear_(&iy);
    OUTPUT:
    RETVAL

void
cmon(ret_val, im)
    char *  ret_val
    integer im
    CODE:
    cmon_(ret_val, strlen(ret_val), &im);

void
cweek(ret_val, iw)
    char *  ret_val
    integer iw
    CODE:
    cweek_(ret_val, strlen(ret_val), &iw);

integer
time12(itime)
    integer itime 
    CODE:
    integer itt;
    time12_(&itime, &itt);
    RETVAL =     itt;
    OUTPUT:
    RETVAL

void
time13(itime, ih, im, is)
    integer itime
    integer *  ih
    integer *  im
    integer *  is
    CODE:
    time13_(&itime, ih, im, is);

integer
time21(itt)
    integer itt
    CODE:
    integer itime;
    time21_(&itime, &itt);
    RETVAL =     itime;
    OUTPUT:
    RETVAL

void
time23(ih, im, is, itt)
    integer *  ih
    integer *  im
    integer *  is
    integer itt
    CODE:
    time23_(ih, im, is, &itt);

integer
time31(ih, im, is)
    integer ih
    integer im
    integer is
    CODE:
    integer itime;
    time31_(&itime, &ih, &im, &is);
    RETVAL =     itime;
    OUTPUT:
    RETVAL

integer
time32(ih, im, is)
    integer ih
    integer im
    integer is 
    CODE:
    integer itt;
    time32_(&ih, &im, &is, &itt);
    RETVAL =     itt;
    OUTPUT:
    RETVAL

integer
timeq1()
    CODE:
    integer itime;
    timeq1_(&itime);
    RETVAL =     itime;
    OUTPUT:
    RETVAL

integer
timeq2()
    CODE:
    integer itt;
    timeq2_(&itt);
    RETVAL =     itt;
    OUTPUT:
    RETVAL

void
timeq3(ih, im, is)
    int ih
    int im
    int is
    CODE:
    timeq3_(&ih, &im, &is);

void
timec1(cform, itime)
    char *  cform
    integer itime
    CODE:
    timec1_(cform, &itime, strlen(cform));

void
timec2(cform, itt)
    char *  cform
    integer itt
    CODE:
    timec2_(cform, &itt, strlen(cform));

void
timec3(cform, ih, im, is)
    char *  cform
    integer ih
    integer im
    integer is
    CODE:
    timec3_(cform, &ih, &im, &is, strlen(cform));

void
dclvnm(cvname)
    char *  cvname 
    CODE:
    dclvnm_(cvname, 16);

void
cdblk(chr)
    char *  chr
    CODE:
    cdblk_(chr, strlen(chr));

char
cns(ins)
    integer ins
    CODE:
    char ret_val;
    /* cns_(&ret_val, strlen(&tret_val), &ins); */
    cns_(&ret_val, 1, &ins);
    RETVAL =     ret_val;
    OUTPUT:
    RETVAL

void
clckst()
    CODE:
    clckst_();

void
clckgt(time)
    float time
    CODE:
    clckgt_(&time);

void
clckdt(dt0)
    float dt0
    CODE:
    clckdt_(&dt0);

void
fcopen(iou, cdsn, nrl, cact, icon)
    integer iou
    char *  cdsn
    integer nrl
    char *  cact
    integer icon
    CODE:
    fcopen_(&iou, cdsn, &nrl, cact, &icon, strlen(cdsn), strlen(cact));

void
fcclos(iou, icon)
    integer iou
    integer icon
    CODE:
    fcclos_(&iou, &icon);

void
fcslfc(clx)
    char *  clx
    CODE:
    fcslfc_(clx, strlen(clx));

void
fcleol(iou, leol)
    integer iou
    logical leol
    CODE:
    fcleol_(&iou, &leol);

void
fcnrec(iou, nrec)
    integer iou
    integer nrec
    CODE:
    fcnrec_(&iou, &nrec);

void
fcgetr(iou, cbuf, icon)
    integer iou
    char *  cbuf
    integer icon
    CODE:
    fcgetr_(&iou, cbuf, &icon, strlen(cbuf));

void
fcputr(iou, cbuf, icon)
    integer iou
    char *  cbuf
    integer icon
    CODE:
    fcputr_(&iou, cbuf, &icon, strlen(cbuf));

void
fcgets(iou, ibuf, icon)
    integer iou
    integer *  ibuf
    integer icon
    CODE:
    fcgets_(&iou, ibuf, &icon);

void
fcputs(iou, ibuf, icon)
    integer iou
    integer *  ibuf
    integer icon
    CODE:
    fcputs_(&iou, ibuf, &icon);

void
fcrwnd(iou, icon)
    integer iou
    integer icon
    CODE:
    fcrwnd_(&iou, &icon);

void
fcpack()
    CODE:
    fcpack_();

doublereal
rngu1(iseed)
    integer iseed
    CODE:
    RETVAL =     rngu1_(&iseed);
    OUTPUT:
    RETVAL

doublereal
rngu2(iseed)
    integer iseed
    CODE:
    RETVAL =     rngu2_(&iseed);
    OUTPUT:
    RETVAL

doublereal
rngu3(iseed)
    integer iseed
    CODE:
    RETVAL =     rngu3_(&iseed);
    OUTPUT:
    RETVAL

void
hexdic(ip, cp)
    integer ip
    char *  cp
    CODE:
    hexdic_(&ip, cp, strlen(cp));

integer
hexdci(cp)
    char *  cp 
    CODE:
    integer ip;
    hexdci_(cp, &ip, strlen(cp));
    RETVAL =     ip;
    OUTPUT:
    RETVAL

doublereal
r4ibm(ii)
    integer ii
    CODE:
    RETVAL =     r4ibm_(&ii);
    OUTPUT:
    RETVAL

doublereal
r4ieee(ii)
    integer ii
    CODE:
    RETVAL =     r4ieee_(&ii);
    OUTPUT:
    RETVAL

