#!/usr/local/bin/perl
#
#/* PROGRAM MAP3D2      */
{
    use DCL;

    $NX = 37;
    $NY = 37;
    $XMIN = 0.0;
    $XMAX = 360.0;
    $YMIN = -90.0;
    $YMAX = 90.0;
    $PI = 3.14159;
    $DRAD = $PI / 180.0;

    #/*-- Ĵ´ؿ ----*/
    for ($J = 0; $J < $NY; $J++) {
        for ($I = 0; $I < $NX; $I++) {
	    $ALON = ($XMIN + ($XMAX-$XMIN)*($I)/($NX-1)) * $DRAD;
	    $ALAT = ($YMIN + ($YMAX-$YMIN)*($J)/($NY-1)) * $DRAD;
	    $SLAT = sin($ALAT);
	    $P[$J*$NX+$I] = 3*sqrt(1-$SLAT*$SLAT)*$SLAT*cos($ALON)
		- 0.5*(3*$SLAT*$SLAT-1);
	}
    }

    #/*--  ----*/
    print STDERR " WORKSTATION ID (I)  ? ;\n";
    sgpwsn();
    chomp($IWS = <STDIN>);

    gropn($IWS);
    sglset("LSOFTF", 0);
    grfrm();

    sgswnd($XMIN, $XMAX, $YMIN, $YMAX);
    sgsvpt(0.1, 0.9, 0.1, 0.9);
    sgssim(0.4, 0.0, 0.0);
    sgsmpl(135.0, 35.0, 0.0);
    sgstxy(-180., 180., 0., 90.);
    sgstrn(30);
    sgstrf();

    for ($K = 3; $K >= -5; $K--) {
	$TLEV1 = 0.4 * $K;
	$TLEV2 = $TLEV1 + 0.4;
	if ($K <= -1) {
	    $IPAT = 600 + abs($K + 1);
	} else {
	    $IPAT = 30 + $K;
	}
	uestlv($TLEV1, $TLEV2, $IPAT);
    }

    uetone(\@P, $NX, $NX, $NY);

    udgclb(\@P, $NX, $NX, $NY, 0.4);
    udcntr(\@P, $NX, $NX, $NY);

    umpmap("coast_world");
    umpglb();

    grcls();

}
