#!/usr/local/bin/perl -w
#
#      PROGRAM U2D5
{
    use DCL;

    $NX = 37;
    $NY = 37;
    $XMIN = 0.0;
    $XMAX = 360.0;
    $YMIN = -90.0;
    $YMAX = 90.0;
    $PI = 3.14159;
    $DRAD = ($PI/180);

    my($IWS, $I, $J, $K, $IPAT);
    my(@P, $ALON, $ALAT, $SLAT, $TLEV1, $TLEV2);

    for ($J = 0; $J < $NY; $J++) {
	for ($I = 0; $I < $NX; $I++) {
	    $ALON = ($XMIN + ($XMAX-$XMIN)*($I)/($NX-1)) * $DRAD;
	    $ALAT = ($YMIN + ($YMAX-$YMIN)*($J)/($NY-1)) * $DRAD;
	    $SLAT = sin($ALAT);
	    $P[$J*$NX+$I] = 3*sqrt(1-$SLAT*$SLAT)*$SLAT*cos($ALON)
		- 0.5*(3*$SLAT*$SLAT-1);
        }
    }

    print STDERR " WORKSTATION ID (I)  ? ;\n";
    sgpwsn();
    chomp($IWS = <STDIN>);

    gropn($IWS);
    sglset("LSOFTF", 1);
    grfrm();

    grswnd($XMIN, $XMAX, $YMIN, $YMAX);
    grsvpt(0.2,  0.8,  0.2,  0.8);
    grstrn(1);
    grstrf();

    for ($K = -5; $K <= 3; $K++) {
	$TLEV1 = 0.4*$K;
	$TLEV2 = $TLEV1 + 0.4;
	if ($K <= -1) {
	    $IPAT = 600 + abs($K+1);
	} else {
	    $IPAT =  30 + $K;
	}
	uestlv($TLEV1, $TLEV2, $IPAT);
    }

    usdaxs();
    udgclb(\@P, $NX, $NX, $NY, 0.4);
    udcntr(\@P, $NX, $NX, $NY);
    uetone(\@P, $NX, $NX, $NY);
    
    grcls();
    
}
