/* -*- C -*-
	   grph1_.h  -- C header file for GFD DENNOU Library
Name:
    grph1_.h  -- C/C++ header file for GFD DENNOU Library GRPH1 package.

Description:
        This is a C/C++ header file for GFD DENNOU library.
    This header includes headers for GRPH1 package.

Author:
        This code is written by Taichu Tanaka. If you have any
    trouble, please report to:  taichu@ihas.nagoya-u.ac.jp .

 $Id: grph1_.h,v 0.4 1997/10/03 14:51:46 taichu Exp $
 */
#ifndef _GRPH1__H_
#define _GRPH1__H_
#ifndef F2C_INCLUDE
#include <f2c.h>
#endif /* !F2C_INCLUDE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

extern void csgi_(char* ret_val, ftnlen ret_val_len, integer* ic);
extern integer isgc_(char* ch, ftnlen ch_len);
extern integer isgtrc_(char* ctr, ftnlen ctr_len);
extern void scplu_(integer* n, real* upx, real* upy, real* upz);
extern void scplv_(integer* n, real* vpx, real* vpy, real* vpz);
extern void scqpli_(integer* index);
extern void scspli_(integer* index);
extern void scplzu_(integer* n, real* upx, real* upy, real* upz, integer* index);
extern void scplzv_(integer* n, real* vpx, real* vpy, real* vpz, integer* index);
extern void scpmu_(integer* n, real* upx, real* upy, real* upz);
extern void scpmv_(integer* n, real* vpx, real* vpy, real* vpz);
extern void scqpmi_(integer* index);
extern void scqpms_(real* rsize);
extern void scqpmt_(integer* itype);
extern void scspmi_(integer* index);
extern void scspms_(real* rsize);
extern void scspmt_(integer* itype);
extern void scpmzu_(integer* n, real* upx, real* upy, real* upz, integer* itype, integer* index, real* rsize);
extern void scpmzv_(integer* n, real* vpx, real* vpy, real* vpz, integer* itype, integer* index, real* rsize);
extern void scqeye_(real* xeye3, real* yeye3, real* zeye3);
extern void scseye_(real* xeye3, real* yeye3, real* zeye3);
extern void scqlog_(logical* lxlog3, logical* lylog3, logical* lzlog3);
extern void scslog_(logical* lxlog3, logical* lylog3, logical* lzlog3);
extern void scqobj_(real* xobj3, real* yobj3, real* zobj3);
extern void scsobj_(real* xobj3, real* yobj3, real* zobj3);
extern void scqorg_(real* simfac, real* vxorg3, real* vyorg3, real* vzorg3);
extern void scsorg_(real* simfac, real* vxorg3, real* vyorg3, real* vzorg3);
extern void scqpln_(integer* ixax, integer* iyax, real* sect);
extern void scspln_(integer* ixax, integer* iyax, real* sect);
extern void scsprj_(void);
extern void scstrf_(void);
extern void scqtrn_(integer* itr3);
extern void scstrn_(integer* itr3);
extern void scqvpt_(real* vxmin, real* vxmax, real* vymin, real* vymax, real* vzmin, real* vzmax);
extern void scsvpt_(real* vxmin, real* vxmax, real* vymin, real* vymax, real* vzmin, real* vzmax);
extern void scqwnd_(real* uxmin, real* uxmax, real* uymin, real* uymax, real* uzmin, real* uzmax);
extern void scswnd_(real* uxmin, real* uxmax, real* uymin, real* uymax, real* uzmin, real* uzmax);
extern void scqtnp_(integer* itpat1, integer* itpat2);
extern void scstnp_(integer* itpat1, integer* itpat2);
extern void sctnu_(real* upx, real* upy, real* upz);
extern void sctnv_(real* vpx, real* vpy, real* vpz);
extern void sctnzu_(real* upx, real* upy, real* upz, integer* itpat1, integer* itpat2);
extern void sctnzv_(real* vpx, real* vpy, real* vpz, integer* itpat1, integer* itpat2);
extern void sglar_(real* rx1, real* ry1, real* rx2, real* ry2);
extern void sglau_(real* ux1, real* uy1, real* ux2, real* uy2);
extern void sglav_(real* vx1, real* vy1, real* vx2, real* vy2);
extern void sgqlai_(integer* index);
extern void sgqlat_(integer* itype);
extern void sgslai_(integer* index);
extern void sgslat_(integer* itype);
extern void sglazr_(real* rx1, real* ry1, real* rx2, real* ry2, integer* itype, integer* index);
extern void sglazu_(real* ux1, real* uy1, real* ux2, real* uy2, integer* itype, integer* index);
extern void sglazv_(real* vx1, real* vy1, real* vx2, real* vy2, integer* itype, integer* index);
extern void sglnr_(real* rx1, real* ry1, real* rx2, real* ry2);
extern void sglnu_(real* ux1, real* uy1, real* ux2, real* uy2);
extern void sglnv_(real* vx1, real* vy1, real* vx2, real* vy2);
extern void sgqlni_(integer* index);
extern void sgslni_(integer* index);
extern void sglnzr_(real* rx1, real* ry1, real* rx2, real* ry2, integer* index);
extern void sglnzu_(real* ux1, real* uy1, real* ux2, real* uy2, integer* index);
extern void sglnzv_(real* vx1, real* vy1, real* vx2, real* vy2, integer* index);
extern void sgcls_(void);
extern void sgfrm_(void);
extern void sginit_(void);
extern void sgopn_(integer* iws);
extern void sgiget_(char* cp, integer* ipara, ftnlen cp_len);
extern void sgiset_(char* cp, integer* ipara, ftnlen cp_len);
extern void sgistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void sglget_(char* cp, logical* ipara, ftnlen cp_len);
extern void sglset_(char* cp, logical* ipara, ftnlen cp_len);
extern void sglstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void sgpget_(char* cp, void* ipara, ftnlen cp_len);
extern void sgpset_(char* cp, void* ipara, ftnlen cp_len);
extern void sgpstx_(char* cp, void* ipara, ftnlen cp_len);
extern void sgrget_(char* cp, real* ipara, ftnlen cp_len);
extern void sgrset_(char* cp, real* ipara, ftnlen cp_len);
extern void sgrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void sgplr_(integer* n, real* rpx, real* rpy);
extern void sgplu_(integer* n, real* upx, real* upy);
extern void sgplv_(integer* n, real* vpx, real* vpy);
extern void sgqpli_(integer* index);
extern void sgqplt_(integer* itype);
extern void sgspli_(integer* index);
extern void sgsplt_(integer* itype);
extern void sgplzr_(integer* n, real* rpx, real* rpy, integer* itype, integer* index);
extern void sgplzu_(integer* n, real* upx, real* upy, integer* itype, integer* index);
extern void sgplzv_(integer* n, real* vpx, real* vpy, integer* itype, integer* index);
extern void sgpmr_(integer* n, real* rpx, real* rpy);
extern void sgpmu_(integer* n, real* upx, real* upy);
extern void sgpmv_(integer* n, real* vpx, real* vpy);
extern void sgqpmi_(integer* index);
extern void sgqpms_(real* rsize);
extern void sgqpmt_(integer* itype);
extern void sgspmi_(integer* index);
extern void sgspms_(real* rsize);
extern void sgspmt_(integer* itype);
extern void sgpmzr_(integer* n, real* rpx, real* rpy, integer* itype, integer* index, real* rsize);
extern void sgpmzu_(integer* n, real* upx, real* upy, integer* itype, integer* index, real* rsize);
extern void sgpmzv_(integer* n, real* vpx, real* vpy, integer* itype, integer* index, real* rsize);
extern void sgpqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void sgpqid_(char* cp, integer* idx, ftnlen cp_len);
extern void sgpqnp_(integer* ncp);
extern void sgpqvl_(integer* idx, integer* ipara);
extern void sgpsvl_(integer* idx, integer* ipara);
extern void sgpwsn_(void);
extern void sgqmpl_(real* plx, real* ply, real* plrot);
extern void sgsmpl_(real* plx, real* ply, real* plrot);
extern void sgnplc_(void);
extern void sgqplc_(char* charx, ftnlen charx_len);
extern void sgqpls_(real* rsize);
extern void sgsplc_(char* charx, ftnlen charx_len);
extern void sgspls_(real* rsize);
extern void sgqsim_(real* simfac, real* vxoff, real* vyoff);
extern void sgssim_(real* simfac, real* vxoff, real* vyoff);
extern void sgstrf_(void);
extern void sgqtrn_(integer* itr);
extern void sgstrn_(integer* itr);
extern void sgqtxy_(real* txmin, real* txmax, real* tymin, real* tymax);
extern void sgstxy_(real* txmin, real* txmax, real* tymin, real* tymax);
extern void sgqvpt_(real* vxmin, real* vxmax, real* vymin, real* vymax);
extern void sgsvpt_(real* vxmin, real* vxmax, real* vymin, real* vymax);
extern void sgqwnd_(real* uxmin, real* uxmax, real* uymin, real* uymax);
extern void sgswnd_(real* uxmin, real* uxmax, real* uymin, real* uymax);
extern void sgqtnp_(integer* itpat);
extern void sgstnp_(integer* itpat);
extern void sgtnr_(integer* n, real* rpx, real* rpy);
extern void sgtnu_(integer* n, real* upx, real* upy);
extern void sgtnv_(integer* n, real* vpx, real* vpy);
extern void sgtnzr_(integer* n, real* rpx, real* rpy, integer* itpat);
extern void sgtnzu_(integer* n, real* upx, real* upy, integer* itpat);
extern void sgtnzv_(integer* n, real* vpx, real* vpy, integer* itpat);
extern void sgtrln_(char* ctl, integer* ntx, ftnlen ctl_len);
extern void sgtrls_(char* ctl, char* cts, ftnlen ctl_len, ftnlen cts_len);
extern void sgtrnl_(integer* ntx, char* ctl, ftnlen ctl_len);
extern void sgtrns_(integer* ntx, char* cts, ftnlen cts_len);
extern void sgtrqf_(integer* ntx, logical* ltr);
extern void sgtrsl_(char* cts, char* ctl, ftnlen cts_len, ftnlen ctl_len);
extern void sgtrsn_(char* cts, integer* ntx, ftnlen cts_len);
extern void sgqtxc_(integer* icent);
extern void sgqtxi_(integer* index);
extern void sgqtxr_(integer* irota);
extern void sgqtxs_(real* rsize);
extern void sgstxc_(integer* icent);
extern void sgstxi_(integer* index);
extern void sgstxr_(integer* irota);
extern void sgstxs_(real* rsize);
extern void sgtxr_(real* rx, real* ry, char* chars, ftnlen chars_len);
extern void sgtxu_(real* ux, real* uy, char* chars, ftnlen chars_len);
extern void sgtxv_(real* vx, real* vy, char* chars, ftnlen chars_len);
extern void sgtxzr_(real* rx, real* ry, char* chars, real* rsize, integer* irota, integer* icent, integer* index, ftnlen chars_len);
extern void sgtxzu_(real* ux, real* uy, char* chars, real* rsize, integer* irota, integer* icent, integer* index, ftnlen chars_len);
extern void sgtxzv_(real* vx, real* vy, char* chars, real* rsize, integer* irota, integer* icent, integer* index, ftnlen chars_len);
extern void sldiv_(char* cform, integer* ix, integer* iy, ftnlen cform_len);
extern void sldivz_(real* xamin, real* xamax, real* yamin, real* yamax, char* cform, integer* ix, integer* iy, real* xbmin, real* xbmax, real* ybmin, real* ybmax, ftnlen cform_len);
extern void slform_(real* dxa, real* dya);
extern void slinit_(real* wxmax, real* wymax, real* fact);
extern void slsize_(char* cszez, ftnlen cszez_len);
extern void slmgn_(real* xl, real* xr, real* yb, real* yt);
extern void slmgnz_(real* xamin, real* xamax, real* yamin, real* yamax, real* xl, real* xr, real* yb, real* yt);
extern void slpage_(integer* lev, integer* ifrm, integer* ipage);
extern void slpcnr_(void);
extern void slpvpc_(integer* index, real* rc);
extern void slpvpr_(integer* index);
extern void slpwvc_(integer* index, real* rc);
extern void slpwvr_(integer* index);
extern void slpwwc_(integer* index, real* rc);
extern void slpwwr_(integer* index);
extern void slqrct_(integer* lev, integer* ifrm, real* xamin, real* xamax, real* yamin, real* yamax);
extern void slqsiz_(char* csize, real* dx, real* dy, ftnlen csize_len);
extern void slrat_(real* rx, real* ry);
extern void slratz_(real* xamin, real* xamax, real* yamin, real* yamax, real* rx, real* ry);
extern void sldttl_(integer* nt);
extern void slpttl_(void);
extern void slsttl_(char* cttl, char* cside, real* px, real* py, real* ht, integer* nt, ftnlen cttl_len, ftnlen cside_len);
extern void sltlcv_(char* ctlin, char* ctlout, integer* lout, ftnlen ctlin_len, ftnlen ctlout_len);
extern void slzttl_(char* cside, char* cttl, real* px, real* py, real* rsize, integer* index, ftnlen cside_len, ftnlen cttl_len);
extern void stepr2_(void);
extern void stfpr2_(real* x, real* y, real* rx, real* ry);
extern void stfpr3_(real* x, real* y, real* z__, real* rx, real* ry);
extern void stipr2_(real* rx, real* ry, real* x, real* y);
extern void strpr2_(void);
extern void stspr2_(integer* ix, integer* iy, real* sect);
extern void stspr3_(real* xfc, real* yfc, real* zfc, real* theta, real* phi, real* psi, real* fac, real* zview, real* rxoff, real* ryoff);
extern void stfrad_(real* x, real* y, real* rx, real* ry);
extern void stirad_(real* rx, real* ry, real* x, real* y);
extern void stsrad_(logical* lxdeg, logical* lydeg);
extern void stfrot_(real* ux, real* uy, real* tx, real* ty);
extern void stirot_(real* tx, real* ty, real* ux, real* uy);
extern void stsrot_(real* theta, real* phi, real* psi);
extern void stftr3_(real* ux, real* uy, real* uz, real* vx, real* vy, real* vz);
extern void stslg3_(logical* lxlg, logical* lylg, logical* lzlg);
extern void stsrd3_(logical* lxrd, logical* lyrd, logical* lzrd);
extern void ststr3_(integer* itr, real* cxa, real* cya, real* cza, real* vxoff, real* vyoff, real* vzoff);
extern void stftrf_(real* ux, real* uy, real* vx, real* vy);
extern void stitrf_(real* vx, real* vy, real* ux, real* uy);
extern void stqtrf_(logical* lmapa);
extern void ststrf_(logical* lmapa);
extern void stftrn_(real* ux, real* uy, real* vx, real* vy);
extern void stitrn_(real* vx, real* vy, real* ux, real* uy);
extern void ststrn_(integer* itr, real* cxa, real* cya, real* vxoff, real* vyoff);
extern void stfusr_(real* ux, real* uy, real* xx, real* yy);
extern void stiusr_(real* xx, real* yy, real* ux, real* uy);
extern void stsusr_(void);
extern void stfwtr_(real* rx, real* ry, real* wx, real* wy);
extern void stiwtr_(real* wx, real* wy, real* rx, real* ry);
extern void stqwrc_(real* wsxmn, real* wsxmx, real* wsymn, real* wsymx);
extern void stqwtr_(real* rxmin, real* rxmax, real* rymin, real* rymax, real* wxmin, real* wxmax, real* wymin, real* wymax, integer* iwtrf);
extern void stswrc_(real* wsxmn, real* wsxmx, real* wsymn, real* wsymx);
extern void stswtr_(real* rxmin, real* rxmax, real* rymin, real* rymax, real* wxmin, real* wxmax, real* wymin, real* wymax, integer* iwtrf);
extern void swcget_(char* cp, char* cpara, ftnlen cp_len, ftnlen cpara_len);
extern void swcset_(char* cp, char* cpara, ftnlen cp_len, ftnlen cpara_len);
extern void swcstx_(char* cp, char* cpara, ftnlen cp_len, ftnlen cpara_len);
extern void swcqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void swcqid_(char* cp, integer* idx, ftnlen cp_len);
extern void swcqnp_(integer* ncp);
extern void swcqvl_(integer* idx, char* cval, ftnlen cval_len);
extern void swcsvl_(integer* idx, char* cval, ftnlen cval_len);
extern void swdcls_(void);
extern void swdopn_(void);
extern void swfint_(real* wx, real* wy, integer* iwx, integer* iwy);
extern void swgcls_(void);
extern void swgmov_(real* wx, real* wy);
extern void swgopn_(void);
extern void swgplt_(real* wx, real* wy);
extern void swgton_(integer* np, real* wpx, real* wpy, integer* itpat);
extern void swicls_(void);
extern void swidat_(integer* image, integer* nlen);
extern void swiint_(integer* iwx, integer* iwy, real* wx, real* wy);
extern void swiopn_(integer* iwx, integer* iwy, integer* imw, integer* imh);
extern void swocls_(char* cobj, ftnlen cobj_len);
extern void swoopn_(char* cobj, char* comm, ftnlen cobj_len, ftnlen comm_len);
extern void swpcls_(void);
extern void swpopn_(void);
extern void swqclc_(logical* lclatr);
extern void swqimc_(logical* limatr);
extern void swqpnt_(real* wx, real* wy, integer* mb);
extern void swqptc_(logical* lptatr);
extern void swqrct_(real* wsxmn, real* wsxmx, real* wsymn, real* wsymx, real* fact);
extern void swqtnc_(logical* ltnatr);
extern void swqwdc_(logical* lwdatr);
extern void swscli_(integer* iclidx);
extern void swsrot_(integer* iwtrot);
extern void swswdi_(integer* iwdidx);
extern void swiget_(char* cp, integer* ipara, ftnlen cp_len);
extern void swiset_(char* cp, integer* ipara, ftnlen cp_len);
extern void swistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void swlget_(char* cp, logical* ipara, ftnlen cp_len);
extern void swlset_(char* cp, logical* ipara, ftnlen cp_len);
extern void swlstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void swpget_(char* cp, void* ipara, ftnlen cp_len);
extern void swpset_(char* cp, void* ipara, ftnlen cp_len);
extern void swpstx_(char* cp, void* ipara, ftnlen cp_len);
extern void swrget_(char* cp, real* ipara, ftnlen cp_len);
extern void swrset_(char* cp, real* ipara, ftnlen cp_len);
extern void swrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void swiqvl_(integer* idx, integer* ipara);
extern void swisvl_(integer* idx, integer* ipara);
extern void swlqvl_(integer* idx, integer* ipara);
extern void swlsvl_(integer* idx, integer* ipara);
extern void swpqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void swpqid_(char* cp, integer* idx, ftnlen cp_len);
extern void swpqnp_(integer* ncp);
extern void swpqvl_(integer* idx, integer* ipara);
extern void swpsvl_(integer* idx, integer* ipara);
extern void swrqvl_(integer* idx, integer* ipara);
extern void swrsvl_(integer* idx, integer* ipara);
extern void swqfnm_(char* cpara, char* cfname, ftnlen cpara_len, ftnlen cfname_len);
extern void szcltn_(integer* icpat, integer* maxcli);
extern void szfont_(integer* ifont, integer* iposx, integer* nchar, char* ckx, char* cky, integer* len, ftnlen ckx_len, ftnlen cky_len);
extern void szl3cl_(void);
extern void szl3op_(integer* index);
extern void szl3zu_(integer* n, real* u3x, real* u3y, real* u3z);
extern void szl3zv_(integer* n, real* v3x, real* v3y, real* v3z);
extern void szlacl_(void);
extern void szlaop_(integer* itype, integer* index);
extern void szlazr_(real* rx1, real* ry1, real* rx2, real* ry2);
extern void szlazu_(real* ux1, real* uy1, real* ux2, real* uy2);
extern void szlazv_(real* vx1, real* vy1, real* vx2, real* vy2);
extern void szlncl_(void);
extern void szlnop_(integer* index);
extern void szlnzr_(real* rx1, real* ry1, real* rx2, real* ry2);
extern void szlnzu_(real* ux1, real* uy1, real* ux2, real* uy2);
extern void szlnzv_(real* vx1, real* vy1, real* vx2, real* vy2);
extern void szm3cl_(void);
extern void szm3op_(integer* itype, integer* index, real* rsize);
extern void szm3zu_(integer* n, real* upx, real* upy, real* upz);
extern void szm3zv_(integer* n, real* vpx, real* vpy, real* vpz);
extern void szcll3_(void);
extern void szmvl3_(real* sx, real* sy, real* sz);
extern void szopl3_(void);
extern void szpll3_(real* sx, real* sy, real* sz);
extern void szcllc_(void);
extern void szcrst_(void);
extern void szmvlc_(real* vx, real* vy);
extern void szoplc_(void);
extern void szpllc_(real* vx, real* vy);
extern void szqchz_(char* ch, real* h__, ftnlen ch_len);
extern void szschz_(char* ch, real* h__, ftnlen ch_len);
extern void szclld_(void);
extern void szmvld_(real* vx, real* vy);
extern void szopld_(void);
extern void szplld_(real* vx, real* vy);
extern void szqtyz_(integer* ipat);
extern void szstyz_(integer* ipat);
extern void szcllp_(void);
extern void szmvlp_(real* vx, real* vy);
extern void szoplp_(void);
extern void szpllp_(real* vx, real* vy);
extern void szcllr_(void);
extern void szmvlr_(real* rx, real* ry);
extern void szoplr_(void);
extern void szpllr_(real* rx, real* ry);
extern void szcllt_(void);
extern void szmvlt_(real* tx, real* ty);
extern void szoplt_(void);
extern void szpllt_(real* tx, real* ty);
extern void szcllu_(void);
extern void szmvlu_(real* ux, real* uy);
extern void szoplu_(void);
extern void szpllu_(real* ux, real* uy);
extern void szcllv_(void);
extern void szmvlv_(real* vx, real* vy);
extern void szoplv_(void);
extern void szpllv_(real* vx, real* vy);
extern void szcllz_(void);
extern void szmvlz_(real* rx, real* ry);
extern void szoplz_(void);
extern void szpllz_(real* rx, real* ry);
extern void szclsv_(void);
extern void szmvsv_(real* vx, real* vy);
extern void szopsv_(void);
extern void szplsv_(real* vx, real* vy);
extern void szcltp_(void);
extern void szoptp_(void);
extern void szqtmd_(logical* lhard);
extern void szstmd_(logical* lhard);
extern void szsttp_(real* vx, real* vy);
extern void szcltr_(void);
extern void szoptr_(void);
extern void szsttr_(real* rx, real* ry);
extern void szclts_(void);
extern void szopts_(void);
extern void szstts_(real* vx, real* vy);
extern void sztits_(integer* itpat);
extern void szcltt_(void);
extern void szoptt_(void);
extern void szsttt_(real* tx, real* ty);
extern void szcltu_(void);
extern void szoptu_(void);
extern void szsttu_(real* ux, real* uy);
extern void szcltv_(void);
extern void szoptv_(void);
extern void szsttv_(real* vx, real* vy);
extern void szcltz_(void);
extern void szoptz_(void);
extern void szsttz_(real* rx, real* ry);
extern void sztitz_(integer* itpat);
extern void szgcll_(real* xx, real* yy, logical* lcont, logical* lmove, integer* ii);
extern void szpcll_(real* vx0, real* vy0, real* vx1, real* vy1, logical* lvalid, integer* ii);
extern void szqcll_(real* vxmin, real* vxmax, real* vymin, real* vymax, integer* ii);
extern void szscll_(real* vxmin, real* vxmax, real* vymin, real* vymax, integer* ii);
extern void szgclx_(real* tx, real* ty, logical* lcont, logical* lmove);
extern void szpclx_(real* tx0, real* ty0, real* tx1, real* ty1, logical* lvalid, logical* lbound);
extern void szqclx_(real* xbnd1, real* xbnd2);
extern void szsclx_(real* xbnd1, real* xbnd2);
extern void szgcly_(real* tx, real* ty, logical* lcont);
extern void szpcly_(real* tx0, real* ty0, real* tx1, real* ty1, logical* lvalid, logical* lbound);
extern void szqcly_(real* ybnd1, real* ybnd2);
extern void szscly_(real* ybnd1, real* ybnd2);
extern void szgipl_(real* x, real* y, logical* lcont);
extern void szpipl_(real* x0, real* y0, real* x1, real* y1, integer* mode);
extern void szgipt_(real* tx, real* ty, logical* lcont);
extern void szpipt_(real* tx0, real* ty0, real* tx1, real* ty1, integer* mode);
extern void szgipz_(real* uxg0, real* uyg0, real* uxg1, real* uyg1, integer* n0);
extern void szpipz_(real* uxp0, real* uyp0, real* uxp1, real* uyp1, integer* nn);
extern void szplcl_(void);
extern void szplop_(integer* itype, integer* index);
extern void szplzr_(integer* n, real* rpx, real* rpy);
extern void szplzu_(integer* n, real* upx, real* upy);
extern void szplzv_(integer* n, real* vpx, real* vpy);
extern void szpmcl_(void);
extern void szpmop_(integer* itype, integer* index, real* rsize);
extern void szpmzr_(integer* n, real* rpx, real* rpy);
extern void szpmzu_(integer* n, real* upx, real* upy);
extern void szpmzv_(integer* n, real* vpx, real* vpy);
extern void szqtxw_(char* chars, integer* nc, real* wxch, real* wych, ftnlen chars_len);
extern void szqgcx_(real* ty, real* tx);
extern void szqgcy_(real* tx, real* ty);
extern void szsgcl_(real* tx0, real* ty0, real* tx1, real* ty1);
extern void szqidx_(integer* index);
extern void szsidx_(integer* index);
extern void szslti_(integer* itype, integer* index);
extern void szqtni_(integer* itpat);
extern void szstni_(integer* itpat);
extern void szqtyp_(integer* itype);
extern void szstyp_(integer* itype);
extern void szt3cl_(void);
extern void szt3op_(integer* itpat1, integer* itpat2);
extern void szt3zu_(real* upx, real* upy, real* upz);
extern void szt3zv_(real* vpx, real* vpy, real* vpz);
extern void sztncl_(void);
extern void sztnop_(integer* itpat);
extern void sztnsv_(integer* n, real* vpx, real* vpy, integer* irota, real* rspce, integer* itype, integer* index);
extern void sztnzr_(integer* n, real* rpx, real* rpy);
extern void sztnzu_(integer* n, real* upx, real* upy);
extern void sztnzv_(integer* n, real* vpx, real* vpy);
extern void sztxcl_(void);
extern void sztxop_(real* rsize, integer* irota, integer* icent, integer* index);
extern void sztxwv_(real* vx, real* vy, char* chars, ftnlen chars_len);
extern void sztxzr_(real* rx, real* ry, char* chars, ftnlen chars_len);
extern void sztxzu_(real* ux, real* uy, char* chars, ftnlen chars_len);
extern void sztxzv_(real* vx, real* vy, char* chars, ftnlen chars_len);
extern doublereal szxmod_(real* x);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* !_GRPH1__H_ */
