/* -*- C -*-
	   grph2_.h  -- C header file for GFD DENNOU Library
Name:
    grph2_.h  -- C/C++ header file for GFD DENNOU Library GRPH2 package.

Description:
        This is a C/C++ header file for GFD DENNOU library.
    This header includes headers for GRPH2 package.

Author:
        This code is written by Taichu Tanaka. If you have any
    trouble, please report to:  taichu@ihas.nagoya-u.ac.jp .

 $Id: grph2_.h,v 0.4 1997/10/03 14:52:13 taichu Exp $
 */
#ifndef _GRPH2__H_
#define _GRPH2__H_
#ifndef F2C_INCLUDE
#include <f2c.h>
#endif /* !F2C_INCLUDE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

extern void csblbl_(char* ret_val, ftnlen ret_val_len, real* ufac, real* uoff, char* cunit__, ftnlen cunit_len);
extern void grinit_(void);
extern void grcls_(void);
extern void grfig_(void);
extern void grfrm_(void);
extern void gropn_(integer* iws);
extern void grsmpl_(real* plx, real* ply, real* plrot);
extern void grssim_(real* simfac, real* vxoff, real* vyoff);
extern void grstrf_(void);
extern void grstrn_(integer* itr);
extern void grstxy_(real* txmin, real* txmax, real* tymin, real* tymax);
extern void grsvpt_(real* vxmin, real* vxmax, real* vymin, real* vymax);
extern void grswnd_(real* uxmin, real* uxmax, real* uymin, real* uymax);
extern integer iueton_(real* zlev);
extern integer iuwgx_(real* ux);
extern integer iuwgy_(real* uy);
extern logical ludchk_(integer* i__, integer* j, integer* k, integer* l, integer* ibr);
extern logical luxchk_(char* cside, ftnlen cside_len);
extern logical luychk_(char* cside, ftnlen cside_len);
extern integer nucchr_(char* cs, integer* nd, ftnlen cs_len);
extern integer nucday_(char* cs, integer* nd, ftnlen cs_len);
extern doublereal rudlev_(integer* nlev);
extern doublereal rudval_(real* zz, real* cz);
extern doublereal ruwgx_(integer* ix);
extern doublereal ruwgy_(integer* iy);
extern void uciget_(char* cp, integer* ipara, ftnlen cp_len);
extern void uciset_(char* cp, integer* ipara, ftnlen cp_len);
extern void ucistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void uclget_(char* cp, logical* ipara, ftnlen cp_len);
extern void uclset_(char* cp, logical* ipara, ftnlen cp_len);
extern void uclstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void ucpget_(char* cp, void* ipara, ftnlen cp_len);
extern void ucpset_(char* cp, void* ipara, ftnlen cp_len);
extern void ucpstx_(char* cp, void* ipara, ftnlen cp_len);
extern void ucrget_(char* cp, real* ipara, ftnlen cp_len);
extern void ucrset_(char* cp, real* ipara, ftnlen cp_len);
extern void ucrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void ucpqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void ucpqid_(char* cp, integer* idx, ftnlen cp_len);
extern void ucpqnp_(integer* ncp);
extern void ucpqvl_(integer* idx, integer* ipara);
extern void ucpsvl_(integer* idx, integer* ipara);
extern void ucxacl_(char* cside, integer* jd0, integer* nd, ftnlen cside_len);
extern void ucxady_(char* cside, integer* jd0, integer* nd, ftnlen cside_len);
extern void ucxamn_(char* cside, integer* jd0, integer* nd, ftnlen cside_len);
extern void ucxayr_(char* cside, integer* jd0, integer* nd, ftnlen cside_len);
extern void ucyacl_(char* cside, integer* jd0, integer* nd, ftnlen cside_len);
extern void ucyady_(char* cside, integer* jd0, integer* nd, ftnlen cside_len);
extern void ucyamn_(char* cside, integer* jd0, integer* nd, ftnlen cside_len);
extern void ucyayr_(char* cside, integer* jd0, integer* nd, ftnlen cside_len);
extern void udbclr_(integer* i__, integer* j, integer* k, integer* l, integer* ibr);
extern void udbset_(integer* i__, integer* j, integer* k, integer* l, integer* ibr);
extern void udcntr_(real* z__, integer* mx, integer* nx, integer* ny);
extern void udcntz_(real* z__, integer* mx, integer* nx, integer* ny, integer* ibr, integer* nbr2);
extern void udgcla_(real* xmin, real* xmax, real* dx);
extern void udgclb_(real* z__, integer* mx, integer* nx, integer* ny, real* dx);
extern void udgrdn_(integer* mode, integer* ix, integer* iy, integer* k, integer* jx, integer* jy, integer* jk);
extern void udiclr_(integer* ix, integer* n);
extern void uddclv_(real* zlev);
extern void udiclv_(void);
extern void udqcln_(integer* nlev);
extern void udqclv_(real* zlev, integer* indx, integer* ityp, char* clv, real* hl, integer* nlev, ftnlen clv_len);
extern void udqclz_(logical* lset);
extern void udsclv_(real* zlev, integer* indx, integer* ityp, char* clv, real* hl, ftnlen clv_len);
extern void udsclz_(logical* lset);
extern void udlabl_(real* val, char* cval, ftnlen cval_len);
extern void udqfmt_(char* cfmt, ftnlen cfmt_len);
extern void udsfmt_(char* cfmt, ftnlen cfmt_len);
extern void udline_(real* z__, integer* mx, integer* kx, integer* ky, integer* kk, real* cx, logical* lopen, integer* ibr);
extern void udiget_(char* cp, integer* ipara, ftnlen cp_len);
extern void udiset_(char* cp, integer* ipara, ftnlen cp_len);
extern void udistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void udlget_(char* cp, logical* ipara, ftnlen cp_len);
extern void udlset_(char* cp, logical* ipara, ftnlen cp_len);
extern void udlstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void udpget_(char* cp, void* ipara, ftnlen cp_len);
extern void udpset_(char* cp, void* ipara, ftnlen cp_len);
extern void udpstx_(char* cp, void* ipara, ftnlen cp_len);
extern void udrget_(char* cp, real* ipara, ftnlen cp_len);
extern void udrset_(char* cp, real* ipara, ftnlen cp_len);
extern void udrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void udpqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void udpqid_(char* cp, integer* idx, ftnlen cp_len);
extern void udpqnp_(integer* ncp);
extern void udpqvl_(integer* idx, integer* ipara);
extern void udpsvl_(integer* idx, integer* ipara);
extern void uduxuy_(real* z__, integer* mx, integer* ix, integer* iy, integer* k, real* cx, real* ux, real* uy);
extern void ueaint_(void);
extern void uearea_(real* xp, real* yp, real* zp, real* vlvm, real* ax, real* ay, integer* np, integer* ni, integer* ng);
extern void uegtla_(real* xmin, real* xmax, real* dx);
extern void uegtlb_(real* z__, integer* mx, integer* nx, integer* ny, real* dx);
extern void ueitlv_(void);
extern void ueqntl_(integer* nton);
extern void ueqtlv_(real* tlev1, real* tlev2, integer* ipat, integer* iton);
extern void ueqtlz_(logical* lset);
extern void uestlv_(real* tlev1, real* tlev2, integer* ipat);
extern void uestlz_(logical* lset);
extern void ueiget_(char* cp, integer* ipara, ftnlen cp_len);
extern void ueiset_(char* cp, integer* ipara, ftnlen cp_len);
extern void ueistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void uelget_(char* cp, logical* ipara, ftnlen cp_len);
extern void uelset_(char* cp, logical* ipara, ftnlen cp_len);
extern void uelstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void uepget_(char* cp, void* ipara, ftnlen cp_len);
extern void uepset_(char* cp, void* ipara, ftnlen cp_len);
extern void uepstx_(char* cp, void* ipara, ftnlen cp_len);
extern void uerget_(char* cp, real* ipara, ftnlen cp_len);
extern void uerset_(char* cp, real* ipara, ftnlen cp_len);
extern void uerstx_(char* cp, real* ipara, ftnlen cp_len);
extern void uepqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void uepqid_(char* cp, integer* idx, ftnlen cp_len);
extern void uepqnp_(integer* ncp);
extern void uepqvl_(integer* idx, integer* ipara);
extern void uepsvl_(integer* idx, integer* ipara);
extern void uestln_(real* tlevn, integer* ipatn, integer* nton);
extern void uetonc_(real* z__, integer* mx, integer* nx, integer* ny);
extern void uetone_(real* z__, integer* mx, integer* nx, integer* ny);
extern void uetonf_(real* z__, integer* mx, integer* nx, integer* ny);
extern void uezchk_(real* z__, integer* mx, integer* nx, integer* ny, char* cname, integer* istat, ftnlen cname_len);
extern void ugiget_(char* cp, integer* ipara, ftnlen cp_len);
extern void ugiset_(char* cp, integer* ipara, ftnlen cp_len);
extern void ugistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void uglget_(char* cp, logical* ipara, ftnlen cp_len);
extern void uglset_(char* cp, logical* ipara, ftnlen cp_len);
extern void uglstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void ugpget_(char* cp, void* ipara, ftnlen cp_len);
extern void ugpset_(char* cp, void* ipara, ftnlen cp_len);
extern void ugpstx_(char* cp, void* ipara, ftnlen cp_len);
extern void ugrget_(char* cp, real* ipara, ftnlen cp_len);
extern void ugrset_(char* cp, real* ipara, ftnlen cp_len);
extern void ugrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void ugpqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void ugpqid_(char* cp, integer* idx, ftnlen cp_len);
extern void ugpqnp_(integer* ncp);
extern void ugpqvl_(integer* idx, integer* ipara);
extern void ugpsvl_(integer* idx, integer* ipara);
extern void ugdut_(void);
extern void ugsut_(char* cside, char* cttl, ftnlen cside_len, ftnlen cttl_len);
extern void ugunit_(void);
extern void ugvect_(real* u, integer* mu, real* v, integer* mv, integer* nx, integer* ny);
extern void uhbra_(integer* n, real* upx1, real* upx2, real* upy);
extern void uhbraz_(integer* n, real* upx1, real* upx2, real* upy, integer* itpat1, integer* itpat2, real* rsize);
extern void uhbrf_(integer* n, real* upx1, real* upx2, real* upy);
extern void uhbrfz_(integer* n, real* upx1, real* upx2, real* upy, integer* itype, integer* index, real* rsize);
extern void uhbrl_(integer* n, real* upx, real* upy);
extern void uhbrlz_(integer* n, real* upx, real* upy, integer* itype, integer* index, real* rsize);
extern void uhbxa_(integer* n, real* upx1, real* upx2, real* upy);
extern void uhbxaz_(integer* n, real* upx1, real* upx2, real* upy, integer* itpat1, integer* itpat2);
extern void uhbxf_(integer* n, real* upx1, real* upx2, real* upy);
extern void uhbxfz_(integer* n, real* upx1, real* upx2, real* upy, integer* itype, integer* index);
extern void uhbxl_(integer* n, real* upx, real* upy);
extern void uhbxlz_(integer* n, real* upx, real* upy, integer* itype, integer* index);
extern void uhdif_(integer* n, real* upx1, real* upx2, real* upy);
extern void uhdifz_(integer* n, real* upx1, real* upx2, real* upy, integer* itpat1, integer* itpat2);
extern void uherb_(integer* n, real* upx1, real* upx2, real* upy);
extern void uherbz_(integer* n, real* upx1, real* upx2, real* upy, integer* itype, integer* index, real* rsize);
extern void uliget_(char* cp, integer* ipara, ftnlen cp_len);
extern void uliset_(char* cp, integer* ipara, ftnlen cp_len);
extern void ulistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void ullget_(char* cp, logical* ipara, ftnlen cp_len);
extern void ullset_(char* cp, logical* ipara, ftnlen cp_len);
extern void ullstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void ulpget_(char* cp, void* ipara, ftnlen cp_len);
extern void ulpset_(char* cp, void* ipara, ftnlen cp_len);
extern void ulpstx_(char* cp, void* ipara, ftnlen cp_len);
extern void ulrget_(char* cp, real* ipara, ftnlen cp_len);
extern void ulrset_(char* cp, real* ipara, ftnlen cp_len);
extern void ulrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void ulpqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void ulpqid_(char* cp, integer* idx, ftnlen cp_len);
extern void ulpqnp_(integer* ncp);
extern void ulpqvl_(integer* idx, integer* ipara);
extern void ulpsvl_(integer* idx, integer* ipara);
extern void ulqxbl_(real* bl, integer* nbl);
extern void ulsxbl_(real* bl, integer* nbl);
extern void ulxlbl_(real* bl, integer* nbl, integer* inum);
extern void ulxlog_(char* cside, integer* nlbl, integer* nticks, ftnlen cside_len);
extern void ulxqfm_(char* cxfmt, ftnlen cxfmt_len);
extern void ulxsfm_(char* cxfmt, ftnlen cxfmt_len);
extern void ulqybl_(real* bl, integer* nbl);
extern void ulsybl_(real* bl, integer* nbl);
extern void ulylbl_(real* bl, integer* nbl, integer* inum);
extern void ulylog_(char* cside, integer* nlbl, integer* nticks, ftnlen cside_len);
extern void ulyqfm_(char* cyfmt, ftnlen cyfmt_len);
extern void ulysfm_(char* cyfmt, ftnlen cyfmt_len);
extern void umbndc_(real* xmin, real* xmax, real* ymin, real* ymax);
extern void umbndp_(real* vxmin, real* vxmax, real* vymin, real* vymax);
/*---- ????
extern void umbndr_(S_fp func, S_fp ftr, real* xmin, real* xmax, real* ymin, real* ymax);
????----*/
extern void uminit_(void);
extern void umpfit_(void);
extern void umiget_(char* cp, integer* ipara, ftnlen cp_len);
extern void umiset_(char* cp, integer* ipara, ftnlen cp_len);
extern void umistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void umlget_(char* cp, logical* ipara, ftnlen cp_len);
extern void umlset_(char* cp, logical* ipara, ftnlen cp_len);
extern void umlstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void umpget_(char* cp, void* ipara, ftnlen cp_len);
extern void umpset_(char* cp, void* ipara, ftnlen cp_len);
extern void umpstx_(char* cp, void* ipara, ftnlen cp_len);
extern void umrget_(char* cp, real* ipara, ftnlen cp_len);
extern void umrset_(char* cp, real* ipara, ftnlen cp_len);
extern void umrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void umpglb_(void);
extern void umpgrd_(void);
extern void umplim_(void);
extern void umpmap_(char* cdsn, ftnlen cdsn_len);
extern void umpqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void umpqid_(char* cp, integer* idx, ftnlen cp_len);
extern void umpqnp_(integer* ncp);
extern void umpqvl_(integer* idx, integer* ipara);
extern void umpsvl_(integer* idx, integer* ipara);
extern void umqfnm_(char* cpara, char* cfname, ftnlen cpara_len, ftnlen cfname_len);
extern void umqtxy_(real* txminz, real* txmaxz, real* tyminz, real* tymaxz);
extern void umqcnt_(real* xcnt, real* ycnt, real* rot);
extern void umscnt_(real* xcnt, real* ycnt, real* rot);
extern void umscom_(void);
extern void umqcwd_(real* xcntr, real* ycntr, real* r__);
extern void umscwd_(real* xcntr, real* ycntr, real* r__);
extern void umsgrd_(void);
extern void umspct_(void);
extern void umspcw_(void);
extern void umspdf_(void);
extern void umqpnt_(integer* n, real* uxa, real* uya);
extern void umqptn_(integer* n);
extern void umrpnt_(void);
extern void umspnt_(integer* n, real* ux, real* uy);
extern void umsppt_(void);
extern void umspwd_(void);
extern void umstvz_(void);
extern void uscget_(char* cp, char* cpara, ftnlen cp_len, ftnlen cpara_len);
extern void uscset_(char* cp, char* cpara, ftnlen cp_len, ftnlen cpara_len);
extern void uscstx_(char* cp, char* cpara, ftnlen cp_len, ftnlen cpara_len);
extern void uschvl_(real* x, char* chx, ftnlen chx_len);
extern void uscqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void uscqid_(char* cp, integer* idx, ftnlen cp_len);
extern void uscqnp_(integer* ncp);
extern void uscqvl_(integer* idx, char* cval, ftnlen cval_len);
extern void uscsvl_(integer* idx, char* cval, ftnlen cval_len);
extern void usdaxs_(void);
extern void usgrph_(integer* n, real* x, real* y);
extern void usinit_(void);
extern void uspfit_(void);
extern void usiget_(char* cp, integer* ipara, ftnlen cp_len);
extern void usiset_(char* cp, integer* ipara, ftnlen cp_len);
extern void usistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void uslget_(char* cp, logical* ipara, ftnlen cp_len);
extern void uslset_(char* cp, logical* ipara, ftnlen cp_len);
extern void uslstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void uspget_(char* cp, void* ipara, ftnlen cp_len);
extern void uspset_(char* cp, void* ipara, ftnlen cp_len);
extern void uspstx_(char* cp, void* ipara, ftnlen cp_len);
extern void usrget_(char* cp, real* ipara, ftnlen cp_len);
extern void usrset_(char* cp, real* ipara, ftnlen cp_len);
extern void usrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void uspqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void uspqid_(char* cp, integer* idx, ftnlen cp_len);
extern void uspqnp_(integer* ncp);
extern void uspqvl_(integer* idx, integer* ipara);
extern void uspsvl_(integer* idx, integer* ipara);
extern void usspnt_(integer* n, real* x, real* y);
extern void ussttl_(char* cxttl, char* cxunit, char* cyttl, char* cyunit, ftnlen cxttl_len, ftnlen cxunit_len, ftnlen cyttl_len, ftnlen cyunit_len);
extern void usurdl_(real* umin, real* umax, real* vmin, real* vmax);
extern void usurdt_(real* umin, real* umax, real* vmin, real* vmax, real* dut);
/*----????
extern void usqdut_(real* dutq);
extern void usurdu_(real* umin, real* umax, real* vmin, real* vmax);
????----*/
extern void ususcl_(char* caxis, real* umin, real* umax, real* vmin, real* vmax, ftnlen caxis_len);
extern void ususcu_(char* caxis, real* umin, real* umax, real* vmin, real* vmax, integer* mode, ftnlen caxis_len);
extern void uswapz_(real* x1, real* x2, integer* n);
extern void usxaxl_(char* cxs, ftnlen cxs_len);
extern void usxaxs_(char* cside, ftnlen cside_len);
extern void usxaxu_(char* cxs, ftnlen cxs_len);
extern void usxoff_(char* cxs, ftnlen cxs_len);
extern void usxsub_(char* cxa, char* cya, char* clabel, real* rlbl, ftnlen cxa_len, ftnlen cya_len, ftnlen clabel_len);
extern void usyaxl_(char* cys, ftnlen cys_len);
extern void usyaxs_(char* cside, ftnlen cside_len);
extern void usyaxu_(char* cys, ftnlen cys_len);
extern void usyoff_(char* cys, ftnlen cys_len);
extern void usysub_(char* cya, char* cxa, char* clabel, real* rlbl, ftnlen cya_len, ftnlen cxa_len, ftnlen clabel_len);
extern void uszdgt_(real* umin, real* umax, real* dul, integer* maxdgt, real* uoff, real* ufact, integer* ndgt, integer* ldgt);
extern void uuinit_(void);
extern void uulin_(integer* n, real* upx, real* upy);
extern void uulinz_(integer* n, real* upx, real* upy, integer* itype, integer* index);
extern void uumrk_(integer* n, real* upx, real* upy);
extern void uumrkz_(integer* n, real* upx, real* upy, integer* itype, integer* index, real* rsize);
extern void uuiget_(char* cp, integer* ipara, ftnlen cp_len);
extern void uuiset_(char* cp, integer* ipara, ftnlen cp_len);
extern void uuistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void uulget_(char* cp, logical* ipara, ftnlen cp_len);
extern void uulset_(char* cp, logical* ipara, ftnlen cp_len);
extern void uulstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void uupget_(char* cp, void* ipara, ftnlen cp_len);
extern void uupset_(char* cp, void* ipara, ftnlen cp_len);
extern void uupstx_(char* cp, void* ipara, ftnlen cp_len);
extern void uurget_(char* cp, real* ipara, ftnlen cp_len);
extern void uurset_(char* cp, real* ipara, ftnlen cp_len);
extern void uurstx_(char* cp, real* ipara, ftnlen cp_len);
extern void uupqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void uupqid_(char* cp, integer* idx, ftnlen cp_len);
extern void uupqnp_(integer* ncp);
extern void uupqvl_(integer* idx, integer* ipara);
extern void uupsvl_(integer* idx, integer* ipara);
extern void uuqarp_(integer* itpt1, integer* itpt2);
extern void uusarp_(integer* itpt1, integer* itpt2);
extern void uuqbrs_(real* rsize);
extern void uusbrs_(real* rsize);
extern void uuqebi_(integer* index);
extern void uuqebs_(real* rsize);
extern void uuqebt_(integer* itype);
extern void uusebi_(integer* index);
extern void uusebs_(real* rsize);
extern void uusebt_(integer* itype);
extern void uuqfri_(integer* index);
extern void uuqfrt_(integer* itype);
extern void uusfri_(integer* index);
extern void uusfrt_(integer* itype);
extern void uuqidv_(real* umin, real* umax);
extern void uusidv_(real* umin, real* umax);
extern void uuqlni_(integer* index);
extern void uuqlnt_(integer* itype);
extern void uuslni_(integer* index);
extern void uuslnt_(integer* itype);
extern void uuqmki_(integer* index);
extern void uuqmks_(real* rsize);
extern void uuqmkt_(integer* itype);
extern void uusmki_(integer* index);
extern void uusmks_(real* rsize);
extern void uusmkt_(integer* itype);
extern void uvbra_(integer* n, real* upx, real* upy1, real* upy2);
extern void uvbraz_(integer* n, real* upx, real* upy1, real* upy2, integer* itpat1, integer* itpat2, real* rsize);
extern void uvbrf_(integer* n, real* upx, real* upy1, real* upy2);
extern void uvbrfz_(integer* n, real* upx, real* upy1, real* upy2, integer* itype, integer* index, real* rsize);
extern void uvbrl_(integer* n, real* upx, real* upy);
extern void uvbrlz_(integer* n, real* upx, real* upy, integer* itype, integer* index, real* rsize);
extern void uvbxa_(integer* n, real* upx, real* upy1, real* upy2);
extern void uvbxaz_(integer* n, real* upx, real* upy1, real* upy2, integer* itpat1, integer* itpat2);
extern void uvbxf_(integer* n, real* upx, real* upy1, real* upy2);
extern void uvbxfz_(integer* n, real* upx, real* upy1, real* upy2, integer* itype, integer* index);
extern void uvbxl_(integer* n, real* upx, real* upy);
extern void uvbxlz_(integer* n, real* upx, real* upy, integer* itype, integer* index);
extern void uvdif_(integer* n, real* upx, real* upy1, real* upy2);
extern void uvdifz_(integer* n, real* upx, real* upy1, real* upy2, integer* itpat1, integer* itpat2);
extern void uverb_(integer* n, real* upx, real* upy1, real* upy2);
extern void uverbz_(integer* n, real* upx, real* upy1, real* upy2, integer* itype, integer* index, real* rsize);
extern void uwdflt_(integer* nx, integer* ny);
extern void uwigxi_(void);
extern void uwqgxi_(real* ux, integer* iux, real* frac);
extern void uwigyi_(void);
extern void uwqgyi_(real* uy, integer* iuy, real* frac);
extern void uwqgxa_(real* xp, integer* nx);
extern void uwqgxb_(real* uxmin, real* uxmax, integer* nx);
extern void uwqgxz_(logical* lsetx);
extern void uwsgxa_(real* xp, integer* nx);
extern void uwsgxb_(real* uxmin, real* uxmax, integer* nx);
extern void uwsgxz_(logical* lsetx);
extern void uwqgya_(real* yp, integer* ny);
extern void uwqgyb_(real* uymin, real* uymax, integer* ny);
extern void uwqgyz_(logical* lsety);
extern void uwsgya_(real* yp, integer* ny);
extern void uwsgyb_(real* uymin, real* uymax, integer* ny);
extern void uwsgyz_(logical* lsety);
extern void uxaxdv_(char* cside, real* dx1, real* dx2, ftnlen cside_len);
extern void uxaxlb_(char* cside, real* ux1, integer* n1, real* ux2, char* ch, integer* nc, integer* n2, ftnlen cside_len, ftnlen ch_len);
extern void uxaxnm_(char* cside, real* ux1, integer* n1, real* ux2, integer* n2, ftnlen cside_len);
extern void uxmttl_(char* cside, char* cttl, real* px, ftnlen cside_len, ftnlen cttl_len);
extern void uxpaxs_(char* cside, integer* islct, ftnlen cside_len);
extern void uxplba_(real* ux, char* ch, integer* nc, integer* n, real* upy, real* roffx, real* rsize, integer* irota, integer* icent, integer* index, ftnlen ch_len);
extern void uxplbb_(real* ux, char* ch, integer* nc, integer* n, real* upy, real* roffx, real* rsize, integer* irota, integer* icent, integer* index, real* rbtwn, logical* lbound, logical* lbmsg, ftnlen ch_len);
extern void uxplbl_(char* cside, integer* islct, real* ux, char* ch, integer* nc, integer* n, ftnlen cside_len, ftnlen ch_len);
extern void uxpnum_(char* cside, integer* islct, real* ux, integer* n, ftnlen cside_len);
extern void uxqfmt_(char* cfmt, ftnlen cfmt_len);
extern void uxsfmt_(char* cfmt, ftnlen cfmt_len);
extern void uxptmk_(char* cside, integer* islct, real* ux, integer* n, ftnlen cside_len);
extern void uxptmz_(real* ux, integer* n, real* upy, real* roffx, real* rtick, integer* index);
extern void uxpttl_(char* cside, integer* islct, char* cttl, real* px, ftnlen cside_len, ftnlen cttl_len);
extern void uxsaxs_(char* cside, ftnlen cside_len);
extern void uxsaxz_(char* cside, real* roffx, ftnlen cside_len);
extern void uxroff_(void);
extern void uxsoff_(void);
extern void uxsttl_(char* cside, char* cttl, real* px, ftnlen cside_len, ftnlen cttl_len);
extern void uyaxdv_(char* cside, real* dy1, real* dy2, ftnlen cside_len);
extern void uyaxlb_(char* cside, real* uy1, integer* n1, real* uy2, char* ch, integer* nc, integer* n2, ftnlen cside_len, ftnlen ch_len);
extern void uyaxnm_(char* cside, real* uy1, integer* n1, real* uy2, integer* n2, ftnlen cside_len);
extern void uymttl_(char* cside, char* cttl, real* px, ftnlen cside_len, ftnlen cttl_len);
extern void uypaxs_(char* cside, integer* islct, ftnlen cside_len);
extern void uyplba_(real* uy, char* ch, integer* nc, integer* n, real* upx, real* roffy, real* rsize, integer* irota, integer* icent, integer* index, ftnlen ch_len);
extern void uyplbb_(real* uy, char* ch, integer* nc, integer* n, real* upx, real* roffy, real* rsize, integer* irota, integer* icent, integer* index, real* rbtwn, logical* lbound, logical* lbmsg, ftnlen ch_len);
extern void uyplbl_(char* cside, integer* islct, real* uy, char* ch, integer* nc, integer* n, ftnlen cside_len, ftnlen ch_len);
extern void uypnum_(char* cside, integer* islct, real* uy, integer* n, ftnlen cside_len);
extern void uyqfmt_(char* cfmt, ftnlen cfmt_len);
extern void uysfmt_(char* cfmt, ftnlen cfmt_len);
extern void uyptmk_(char* cside, integer* islct, real* uy, integer* n, ftnlen cside_len);
extern void uyptmz_(real* uy, integer* n, real* upx, real* roffy, real* rtick, integer* index);
extern void uypttl_(char* cside, integer* islct, char* cttl, real* px, ftnlen cside_len, ftnlen cttl_len);
extern void uysaxs_(char* cside, ftnlen cside_len);
extern void uysaxz_(char* cside, real* roffy, ftnlen cside_len);
extern void uyroff_(void);
extern void uysoff_(void);
extern void uysttl_(char* cside, char* cttl, real* px, ftnlen cside_len, ftnlen cttl_len);
extern void uzfact_(real* rfact);
extern void uzinit_(void);
extern void uziget_(char* cp, integer* ipara, ftnlen cp_len);
extern void uziset_(char* cp, integer* ipara, ftnlen cp_len);
extern void uzistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void uzlget_(char* cp, logical* ipara, ftnlen cp_len);
extern void uzlset_(char* cp, logical* ipara, ftnlen cp_len);
extern void uzlstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void uzpget_(char* cp, void* ipara, ftnlen cp_len);
extern void uzpset_(char* cp, void* ipara, ftnlen cp_len);
extern void uzpstx_(char* cp, void* ipara, ftnlen cp_len);
extern void uzrget_(char* cp, real* ipara, ftnlen cp_len);
extern void uzrset_(char* cp, real* ipara, ftnlen cp_len);
extern void uzrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void uzpqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void uzpqid_(char* cp, integer* idx, ftnlen cp_len);
extern void uzpqnp_(integer* ncp);
extern void uzpqvl_(integer* idx, integer* ipara);
extern void uzprst_(void);
extern void uzpsav_(void);
extern void uzpsvl_(integer* idx, integer* ipara);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* !_GRPH2__H_ */
