/* -*- C -*-
	   math1_.h  -- C header file for GFD DENNOU Library
Name:
    math1_.h  -- C/C++ header file for GFD DENNOU Library MATH1 package.

Description:
        This is a C/C++ header file for GFD DENNOU library.
    This header includes headers and wrappers for MATH1 package.

Author:
        This code is written by Taichu Tanaka. If you have any
    trouble, please report to:  taichu@ihas.nagoya-u.ac.jp .

 $Id: math1_.h,v 0.4 1997/10/03 14:52:38 taichu Exp $
 */
#ifndef _MATH1__H_
#define _MATH1__H_
#ifndef F2C_INCLUDE
#include <f2c.h>
#endif /* !F2C_INCLUDE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

extern void cr2c_(real* theta, real* x0, real* y0, real* x1, real* y1);
extern void cfsrch_(char* cplist, integer* np, char* cflist, integer* nf, char* cfname, ftnlen cplist_len, ftnlen cflist_len, ftnlen cfname_len);
extern void cladj_(char* chr, ftnlen chr_len);
extern void cr3c_(real* theta, real* phi, real* psi, real* x0, real* y0, real* z0, real* x1, real* y1, real* z1);
extern void cr3s_(real* theta, real* phi, real* psi, real* theta0, real* phi0, real* theta1, real* phi1);
extern void cradj_(char* chr, ftnlen chr_len);
extern void crvrs_(char* chr, ftnlen chr_len);
extern void ct2bc_(real* u, real* v, real* x, real* y);
extern void ct2ch_(real* x, real* y, real* u, real* v);
extern void ct2cp_(real* x, real* y, real* r__, real* theta);
extern void ct2ec_(real* u, real* v, real* x, real* y);
extern void ct2hc_(real* u, real* v, real* x, real* y);
extern void ct2pc_(real* r__, real* theta, real* x, real* y);
extern void ct3cs_(real* x, real* y, real* z__, real* r__, real* theta, real* phi);
extern void ct3sc_(real* r__, real* theta, real* phi, real* x, real* y, real* z__);
extern void dxfloc_(integer* nd, integer* ns, integer* np, integer* ncp);
extern void dxiloc_(integer* nd, integer* ns, integer* np, integer* ncp);
extern doublereal ffromc_(char* cx, ftnlen cx_len);
extern void glcget_(char* cp, char* cpara, ftnlen cp_len, ftnlen cpara_len);
extern void glcset_(char* cp, char* cpara, ftnlen cp_len, ftnlen cpara_len);
extern void glcstx_(char* cp, char* cpara, ftnlen cp_len, ftnlen cpara_len);
extern void gliget_(char* cp, integer* ipara, ftnlen cp_len);
extern void gliset_(char* cp, integer* ipara, ftnlen cp_len);
extern void glistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void gllget_(char* cp, logical* ipara, ftnlen cp_len);
extern void gllset_(char* cp, logical* ipara, ftnlen cp_len);
extern void gllstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void glpget_(char* cp, void* ipara, ftnlen cp_len);
extern void glpset_(char* cp, void* ipara, ftnlen cp_len);
extern void glpstx_(char* cp, void* ipara, ftnlen cp_len);
extern void glrget_(char* cp, real* ipara, ftnlen cp_len);
extern void glrset_(char* cp, real* ipara, ftnlen cp_len);
extern void glrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void glqfnm_(char* cpara, char* cfname, ftnlen cpara_len, ftnlen cfname_len);
extern void gnrset_(void);
extern void gnsave_(void);
extern void gnge_(real* rx, real* bx, integer* ip);
extern void gngt_(real* rx, real* bx, integer* ip);
extern void gnle_(real* rx, real* bx, integer* ip);
extern void gnlt_(real* rx, real* bx, integer* ip);
extern void gnqblk_(real* xb, integer* nb);
extern void gnsblk_(real* xb, integer* nb);
extern void iadd_(integer* ix, integer* n, integer* jx, integer* ii);
extern void iadd0_(integer* ix, integer* n, integer* jx, integer* ii);
extern void iadd1_(integer* ix, integer* n, integer* jx, integer* ii);
extern integer iblkge_(real* rx, integer* n, real* rr);
extern integer iblkgt_(real* rx, integer* n, real* rr);
extern integer iblkle_(real* rx, integer* n, real* rr);
extern integer iblklt_(real* rx, integer* n, real* rr);
extern integer ifromc_(char* cx, ftnlen cx_len);
extern integer igus_(real* rx);
extern integer imax_(integer* ix, integer* n, integer* jx);
extern integer imax0_(integer* ix, integer* n, integer* jx);
extern integer imax1_(integer* ix, integer* n, integer* jx);
extern integer imin_(integer* ix, integer* n, integer* jx);
extern integer imin0_(integer* ix, integer* n, integer* jx);
extern integer imin1_(integer* ix, integer* n, integer* jx);
extern void imlt_(integer* ix, integer* n, integer* jx, integer* ii);
extern void imlt0_(integer* ix, integer* n, integer* jx, integer* ii);
extern void imlt1_(integer* ix, integer* n, integer* jx, integer* ii);
extern integer imod_(integer* ix, integer* id);
extern integer indxcf_(char* cx, integer* n, integer* jd, char* ch, ftnlen cx_len, ftnlen ch_len);
extern integer indxcl_(char* cx, integer* n, integer* jd, char* ch, ftnlen cx_len, ftnlen ch_len);
extern integer indxif_(integer* ix, integer* n, integer* jd, integer* ii);
extern integer indxil_(integer* ix, integer* n, integer* jd, integer* ii);
extern integer indxmf_(char* cx, integer* n, integer* jd, char* ch, ftnlen cx_len, ftnlen ch_len);
extern integer indxml_(char* cx, integer* n, integer* jd, char* ch, ftnlen cx_len, ftnlen ch_len);
extern integer indxnf_(char* cx, integer* n, integer* jd, char* ch, ftnlen cx_len, ftnlen ch_len);
extern integer indxnl_(char* cx, integer* n, integer* jd, char* ch, ftnlen cx_len, ftnlen ch_len);
extern integer indxrf_(real* rx, integer* n, integer* jd, real* rr);
extern integer indxrl_(real* rx, integer* n, integer* jd, real* rr);
extern integer irge_(real* rx);
extern integer irgt_(real* rx);
extern integer irle_(real* rx);
extern integer irlt_(real* rx);
extern void iset_(integer* ix, integer* n, integer* jx, integer* ii);
extern void iset0_(integer* ix, integer* n, integer* jx, integer* ii);
extern void iset1_(integer* ix, integer* n, integer* jx, integer* ii);
extern integer isum_(integer* ix, integer* n, integer* jx);
extern integer isum0_(integer* ix, integer* n, integer* jx);
extern integer isum1_(integer* ix, integer* n, integer* jx);
extern integer iufopn_(void);
extern integer jfromc_(char* cx, ftnlen cx_len);
extern logical lchreq_(char* ch1, char* ch2, ftnlen ch1_len, ftnlen ch2_len);
extern integer lenb_(char* c__, ftnlen c_len);
extern integer lenc_(char* c__, ftnlen c_len);
extern integer leny_(char* c__, ftnlen c_len);
extern integer lenz_(char* c__, ftnlen c_len);
extern logical lfromc_(char* cx, ftnlen cx_len);
extern logical lreq_(real* x, real* y);
extern logical lreq0_(real* x, real* y);
extern logical lreq1_(real* x, real* y);
extern logical lreqa_(real* x, real* y, real* epsl);
extern logical lrge_(real* x, real* y);
extern logical lrge0_(real* x, real* y);
extern logical lrge1_(real* x, real* y);
extern logical lrgea_(real* x, real* y, real* epsl);
extern logical lrgt_(real* x, real* y);
extern logical lrgt0_(real* x, real* y);
extern logical lrgt1_(real* x, real* y);
extern logical lrgta_(real* x, real* y, real* epsl);
extern logical lrle_(real* x, real* y);
extern logical lrle0_(real* x, real* y);
extern logical lrle1_(real* x, real* y);
extern logical lrlea_(real* x, real* y, real* epsl);
extern logical lrlt_(real* x, real* y);
extern logical lrlt0_(real* x, real* y);
extern logical lrlt1_(real* x, real* y);
extern logical lrlta_(real* x, real* y, real* epsl);
extern logical lrne_(real* x, real* y);
extern logical lrne0_(real* x, real* y);
extern logical lrne1_(real* x, real* y);
extern logical lrnea_(real* x, real* y, real* epsl);
extern void mpfaza_(real* xlon, real* ylat, real* x, real* y);
extern void mpiaza_(real* x, real* y, real* xlon, real* ylat);
extern void mpfazm_(real* xlon, real* ylat, real* x, real* y);
extern void mpiazm_(real* x, real* y, real* xlon, real* ylat);
extern void mpfbon_(real* xlon, real* ylat, real* x, real* y);
extern void mpibon_(real* x, real* y, real* xlon, real* ylat);
extern void mpsbon_(real* ylat0);
extern void mpfcoa_(real* xlon, real* ylat, real* x, real* y);
extern void mpicoa_(real* x, real* y, real* xlon, real* ylat);
extern void mpscoa_(real* ylat0);
extern void mpfcoc_(real* xlon, real* ylat, real* x, real* y);
extern void mpicoc_(real* x, real* y, real* xlon, real* ylat);
extern void mpscoc_(real* ylat1, real* ylat2);
extern void mpfcon_(real* xlon, real* ylat, real* x, real* y);
extern void mpicon_(real* x, real* y, real* xlon, real* ylat);
extern void mpscon_(real* ylat0);
extern void mpfcyl_(real* xlon, real* ylat, real* x, real* y);
extern void mpicyl_(real* x, real* y, real* xlon, real* ylat);
extern void mpfek6_(real* xlon, real* ylat, real* x, real* y);
extern void mpiek6_(real* x, real* y, real* xlon, real* ylat);
extern void mpfhmr_(real* xlon, real* ylat, real* x, real* y);
extern void mpihmr_(real* x, real* y, real* xlon, real* ylat);
extern void mpfktd_(real* xlon, real* ylat, real* x, real* y);
extern void mpiktd_(real* x, real* y, real* xlon, real* ylat);
extern void mpfmer_(real* xlon, real* ylat, real* x, real* y);
extern void mpimer_(real* x, real* y, real* xlon, real* ylat);
extern void mpfmwd_(real* xlon, real* ylat, real* x, real* y);
extern void mpimwd_(real* x, real* y, real* xlon, real* ylat);
extern void mpfmwl_(real* xlon, real* ylat, real* x, real* y);
extern void mpimwl_(real* x, real* y, real* xlon, real* ylat);
extern void mpfotg_(real* xlon, real* ylat, real* x, real* y);
extern void mpiotg_(real* x, real* y, real* xlon, real* ylat);
extern void mpsotg_(real* r0);
extern void mpfpst_(real* xlon, real* ylat, real* x, real* y);
extern void mpipst_(real* x, real* y, real* xlon, real* ylat);
extern void mpzek6_(real* phi, real* alpha, real* f, real* df);
extern void mpzktd_(real* phi, real* alpha, real* f, real* df);
extern void mpzmwd_(real* phi, real* alpha, real* f, real* df);
extern void mpznwt_(S_fp func, real* phi, real* alpha);
extern void msgdmp_(char* clev, char* csub, char* cmsg, ftnlen clev_len, ftnlen csub_len, ftnlen cmsg_len);
extern void mszdmp_(char* cmsg, integer* iunit, integer* lnsize, ftnlen cmsg_len);
extern integer nindxc_(char* cx, integer* n, integer* jd, char* ch, ftnlen cx_len, ftnlen ch_len);
extern integer nindxi_(integer* ix, integer* n, integer* jd, integer* ii);
extern integer nindxm_(char* cx, integer* n, integer* jd, char* ch, ftnlen cx_len, ftnlen ch_len);
extern integer nindxn_(char* cx, integer* n, integer* jd, char* ch, ftnlen cx_len, ftnlen ch_len);
extern integer nindxr_(real* rx, integer* n, integer* jd, real* rr);
extern void radd_(real* rx, integer* n, integer* jx, real* rr);
extern void radd0_(real* rx, integer* n, integer* jx, real* rr);
extern void radd1_(real* rx, integer* n, integer* jx, real* rr);
extern doublereal ramp_(real* rx, integer* n, integer* jx);
extern doublereal ramp0_(real* rx, integer* n, integer* jx);
extern doublereal ramp1_(real* rx, integer* n, integer* jx);
extern doublereal rave_(real* rx, integer* n, integer* jx);
extern doublereal rave0_(real* rx, integer* n, integer* jx);
extern doublereal rave1_(real* rx, integer* n, integer* jx);
extern doublereal rcor_(real* rx, real* ry, integer* n, integer* jx, integer* jy);
extern doublereal rcov_(real* rx, real* ry, integer* n, integer* jx, integer* jy);
extern doublereal rd2r_(real* x);
extern doublereal rexp_(real* rx, integer* ib, integer* ie);
extern doublereal rfpi_(void);
extern doublereal rfromc_(char* cx, ftnlen cx_len);
extern doublereal rgnge_(real* rx);
extern doublereal rgngt_(real* rx);
extern doublereal rgnle_(real* rx);
extern doublereal rgnlt_(real* rx);
extern doublereal rmax_(real* rx, integer* n, integer* jx);
extern doublereal rmax0_(real* rx, integer* n, integer* jx);
extern doublereal rmax1_(real* rx, integer* n, integer* jx);
extern doublereal rmin_(real* rx, integer* n, integer* jx);
extern doublereal rmin0_(real* rx, integer* n, integer* jx);
extern doublereal rmin1_(real* rx, integer* n, integer* jx);
extern void rmlt_(real* rx, integer* n, integer* jx, real* rr);
extern void rmlt0_(real* rx, integer* n, integer* jx, real* rr);
extern void rmlt1_(real* rx, integer* n, integer* jx, real* rr);
extern doublereal rmod_(real* rx, real* rd);
extern doublereal rprd_(real* rx, real* ry, integer* n, integer* jx, integer* jy);
extern doublereal rr2d_(real* x);
extern doublereal rrms_(real* rx, integer* n, integer* jx);
extern doublereal rrms0_(real* rx, integer* n, integer* jx);
extern doublereal rrms1_(real* rx, integer* n, integer* jx);
extern void rset_(real* rx, integer* n, integer* jx, real* rr);
extern void rset0_(real* rx, integer* n, integer* jx, real* rr);
extern void rset1_(real* rx, integer* n, integer* jx, real* rr);
extern doublereal rstd_(real* rx, integer* n, integer* jx);
extern doublereal rstd0_(real* rx, integer* n, integer* jx);
extern doublereal rstd1_(real* rx, integer* n, integer* jx);
extern doublereal rsum_(real* rx, integer* n, integer* jx);
extern doublereal rsum0_(real* rx, integer* n, integer* jx);
extern doublereal rsum1_(real* rx, integer* n, integer* jx);
extern void rtcenv_(char* cpfix, char* cp, char* cval, ftnlen cpfix_len, ftnlen cp_len, ftnlen cval_len);
extern void rtcget_(char* cpfix, char* cp, char* cpara, integer* max__, ftnlen cpfix_len, ftnlen cp_len, ftnlen cpara_len);
extern void rtcopt_(char* cpfix, char* cp, char* cval, ftnlen cpfix_len, ftnlen cp_len, ftnlen cval_len);
extern void rtcxfl_(char* cpfix, char* cp, char* cval, ftnlen cpfix_len, ftnlen cp_len, ftnlen cval_len);
extern void rtpenv_(char* cpfix, char* cp, void* ipara, ftnlen cpfix_len, ftnlen cp_len);
extern void rtpget_(char* cpfix, char* cp, void* ipara, integer* max__, ftnlen cpfix_len, ftnlen cp_len);
extern void rtpopt_(char* cpfix, char* cp, void* ipara, ftnlen cpfix_len, ftnlen cp_len);
extern void rtpxfl_(char* cpfix, char* cp, void* ipara, ftnlen cpfix_len, ftnlen cp_len);
extern doublereal rvar_(real* rx, integer* n, integer* jx);
extern doublereal rvar0_(real* rx, integer* n, integer* jx);
extern doublereal rvar1_(real* rx, integer* n, integer* jx);
extern doublereal rvmax_(real* rx, integer* ns, integer* np, integer* nq, integer* nd);
extern doublereal rvmax0_(real* rx, integer* ns, integer* np, integer* nq, integer* nd);
extern doublereal rvmax1_(real* rx, integer* ns, integer* np, integer* nq, integer* nd);
extern doublereal rvmin_(real* rx, integer* ns, integer* np, integer* nq, integer* nd);
extern doublereal rvmin0_(real* rx, integer* ns, integer* np, integer* nq, integer* nd);
extern doublereal rvmin1_(real* rx, integer* ns, integer* np, integer* nq, integer* nd);
extern void viadd_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void viadd0_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void viadd1_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vicon_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, integer* ii);
extern void vicon0_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, integer* ii);
extern void vicon1_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, integer* ii);
extern void vidiv_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vidiv0_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vidiv1_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vifct_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, integer* ii);
extern void vifct0_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, integer* ii);
extern void vifct1_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, integer* ii);
extern void vifna_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, U_fp ifna);
extern void vifna0_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, I_fp ifna);
extern void vifna1_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, I_fp ifna);
extern void vifnb_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz, U_fp ifnb);
extern void vifnb0_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz, I_fp ifnb);
extern void vifnb1_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz, I_fp ifnb);
extern void vignn_(integer* ix, integer* n, integer* jx);
extern void viinc_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, integer* ii);
extern void viinc0_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, integer* ii);
extern void viinc1_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy, integer* ii);
extern void vimlt_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vimlt0_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vimlt1_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void viset0_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy);
extern void viset1_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy);
extern void viset_(integer* ix, integer* iy, integer* n, integer* jx, integer* jy);
extern void visub_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void visub0_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void visub1_(integer* ix, integer* iy, integer* iz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vradd_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vradd0_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vradd1_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vrcon_(real* rx, real* ry, integer* n, integer* jx, integer* jy, real* rr);
extern void vrcon0_(real* rx, real* ry, integer* n, integer* jx, integer* jy, real* rr);
extern void vrcon1_(real* rx, real* ry, integer* n, integer* jx, integer* jy, real* rr);
extern void vrdiv_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vrdiv0_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vrdiv1_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vrfct_(real* rx, real* ry, integer* n, integer* jx, integer* jy, real* rr);
extern void vrfct0_(real* rx, real* ry, integer* n, integer* jx, integer* jy, real* rr);
extern void vrfct1_(real* rx, real* ry, integer* n, integer* jx, integer* jy, real* rr);
extern void vrfna_(real* rx, real* ry, integer* n, integer* jx, integer* jy, U_fp rfna);
extern void vrfna0_(real* rx, real* ry, integer* n, integer* jx, integer* jy, E_fp rfna);
extern void vrfna1_(real* rx, real* ry, integer* n, integer* jx, integer* jy, E_fp rfna);
extern void vrfnb_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz, U_fp rfnb);
extern void vrfnb0_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz, E_fp rfnb);
extern void vrfnb1_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz, E_fp rfnb);
extern void vrgnn_(real* rx, integer* n, integer* jx);
extern void vrinc_(real* rx, real* ry, integer* n, integer* jx, integer* jy, real* rr);
extern void vrinc0_(real* rx, real* ry, integer* n, integer* jx, integer* jy, real* rr);
extern void vrinc1_(real* rx, real* ry, integer* n, integer* jx, integer* jy, real* rr);
extern void vrmlt_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vrmlt0_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vrmlt1_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vrset0_(real* rx, real* ry, integer* n, integer* jx, integer* jy);
extern void vrset1_(real* rx, real* ry, integer* n, integer* jx, integer* jy);
extern void vrset_(real* rx, real* ry, integer* n, integer* jx, integer* jy);
extern void vrsub_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vrsub0_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern void vrsub1_(real* rx, real* ry, real* rz, integer* n, integer* jx, integer* jy, integer* jz);
extern doublereal xmplon_(real* xlon);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* !_MATH1__H_ */
