/* -*- C -*-
	   math2_.h  -- C header file for GFD DENNOU Library
Name:
    math2_.h  -- C/C++ header file for GFD DENNOU Library MATH2 package.

Description:
        This is a C/C++ header file for GFD DENNOU library.
    This header includes headers for MATH2 package.

Author:
        This code is written by Taichu Tanaka. If you have any
    trouble, please report to:  taichu@ihas.nagoya-u.ac.jp .

 $Id: math2_.h,v 0.4 1997/10/03 14:52:59 taichu Exp $
 */
#ifndef _MATH2__H_
#define _MATH2__H_
#ifndef F2C_INCLUDE
#include <f2c.h>
#endif /* !F2C_INCLUDE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

extern void radf5_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2, real* wa3, real* wa4);
extern void cfftb_(integer* n, real* c__, real* wsave);
extern void cfftb1_(integer* n, real* c__, real* ch, real* wa, integer* ifac);
extern void cfftf_(integer* n, real* c__, real* wsave);
extern void cfftf1_(integer* n, real* c__, real* ch, real* wa, integer* ifac);
extern void cffti_(integer* n, real* wsave);
extern void cffti1_(integer* n, real* wa, integer* ifac);
extern void cosqb_(integer* n, real* x, real* wsave);
extern void cosqb1_(integer* n, real* x, real* w, real* xh);
extern void cosqf_(integer* n, real* x, real* wsave);
extern void cosqf1_(integer* n, real* x, real* w, real* xh);
extern void cosqi_(integer* n, real* wsave);
extern void cost_(integer* n, real* x, real* wsave);
extern void costi_(integer* n, real* wsave);
extern void ezfft1_(integer* n, real* wa, integer* ifac);
extern void ezfftb_(integer* n, real* r__, real* azero, real* a, real* b, real* wsave);
extern void ezfftf_(integer* n, real* r__, real* azero, real* a, real* b, real* wsave);
extern void ezffti_(integer* n, real* wsave);
extern void odiget_(char* cp, integer* ipara, ftnlen cp_len);
extern void odiset_(char* cp, integer* ipara, ftnlen cp_len);
extern void odistx_(char* cp, integer* ipara, ftnlen cp_len);
extern void odlget_(char* cp, logical* ipara, ftnlen cp_len);
extern void odlset_(char* cp, logical* ipara, ftnlen cp_len);
extern void odlstx_(char* cp, logical* ipara, ftnlen cp_len);
extern void odpget_(char* cp, void* ipara, ftnlen cp_len);
extern void odpset_(char* cp, void* ipara, ftnlen cp_len);
extern void odpstx_(char* cp, void* ipara, ftnlen cp_len);
extern void odrget_(char* cp, real* ipara, ftnlen cp_len);
extern void odrset_(char* cp, real* ipara, ftnlen cp_len);
extern void odrstx_(char* cp, real* ipara, ftnlen cp_len);
extern void odpqcp_(integer* idx, char* cp, ftnlen cp_len);
extern void odpqid_(char* cp, integer* idx, ftnlen cp_len);
extern void odpqnp_(integer* ncp);
extern void odpqvl_(integer* idx, integer* ipara);
extern void odpsvl_(integer* idx, integer* ipara);
extern void odrk1_(integer* n, U_fp fcn, real* t, real* dt, real* x, real* dx, real* xout, real* work);
extern void odrk2_(integer* n, S_fp fcn, real* t, real* dt, real* x, real* dx, real* xout, real* work);
extern void odrk4_(integer* n, S_fp fcn, real* t, real* dt, real* x, real* dx, real* xout, real* work);
extern void odrk4r_(integer* n, S_fp fcn, real* t, real* dt, real* epsl, real* x, real* work);
extern void odrk4s_(integer* n, S_fp fcn, real* t, real* dt, real* epsl, real* x, real* work);
extern void odrkdu_(integer* n, S_fp algr, S_fp fcn, real* t, real* tend, integer* istep, real* x, real* work);
extern void odrkdv_(integer* n, S_fp steper, U_fp fcn, real* t, real* tend, real* dt, real* x, real* work);
extern void odrkg_(integer* n, S_fp fcn, real* t, real* dt, real* x, real* dx, real* xout, real* work);
extern void odrkgr_(integer* n, S_fp fcn, real* t, real* dt, real* epsl, real* x, real* work);
extern void odrkgs_(integer* n, S_fp fcn, real* t, real* dt, real* epsl, real* x, real* work);
extern void passb_(integer* nac, integer* ido, integer* ip, integer* l1, integer* idl1, real* cc, real* c1, real* c2, real* ch, real* ch2, real* wa);
extern void passb2_(integer* ido, integer* l1, real* cc, real* ch, real* wa1);
extern void passb3_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2);
extern void passb4_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2, real* wa3);
extern void passb5_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2, real* wa3, real* wa4);
extern void passf_(integer* nac, integer* ido, integer* ip, integer* l1, integer* idl1, real* cc, real* c1, real* c2, real* ch, real* ch2, real* wa);
extern void passf2_(integer* ido, integer* l1, real* cc, real* ch, real* wa1);
extern void passf3_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2);
extern void passf4_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2, real* wa3);
extern void passf5_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2, real* wa3, real* wa4);
extern void radb2_(integer* ido, integer* l1, real* cc, real* ch, real* wa1);
extern void radb3_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2);
extern void radfg_(integer* ido, integer* ip, integer* l1, integer* idl1, real* cc, real* c1, real* c2, real* ch, real* ch2, real* wa);
extern void radb4_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2, real* wa3);
extern void radb5_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2, real* wa3, real* wa4);
extern void radbg_(integer* ido, integer* ip, integer* l1, integer* idl1, real* cc, real* c1, real* c2, real* ch, real* ch2, real* wa);
extern void radf2_(integer* ido, integer* l1, real* cc, real* ch, real* wa1);
extern void radf3_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2);
extern void radf4_(integer* ido, integer* l1, real* cc, real* ch, real* wa1, real* wa2, real* wa3);
extern void rfftb_(integer* n, real* r__, real* wsave);
extern void rfftb1_(integer* n, real* c__, real* ch, real* wa, integer* ifac);
extern void rfftf_(integer* n, real* r__, real* wsave);
extern void rfftf1_(integer* n, real* c__, real* ch, real* wa, integer* ifac);
extern void rffti_(integer* n, real* wsave);
extern void rffti1_(integer* n, real* wa, integer* ifac);
extern void shfftb_(integer* nfft, real* xfft, real* wfft);
extern void shfftf_(integer* nfft, real* xfft, real* wfft);
extern void shfg2w_(integer* mm, integer* jm, integer* im, real* g, real* w, real* h__, real* wfft);
extern void shfw2g_(integer* mm, integer* jm, integer* im, real* w, real* g, real* h__, real* wfft);
extern void shfwga_(integer* mm, integer* jm, integer* im, integer* m1, integer* m2, real* w, real* g, real* h__, real* wfft);
extern void shfwgj_(integer* mm, integer* im, integer* m1, integer* m2, real* wj, real* gj, real* h__, real* wfft);
extern void shfwgm_(integer* jm, integer* im, integer* m, real* wr, real* wi, real* g, real* h__, real* wfft);
extern void shfwgz_(integer* jm, integer* im, real* wz, real* g);
extern void shinic_(integer* mm, integer* jm, real* xw, real* px);
extern void shinif_(integer* nfft, real* wfft);
extern void shinip_(integer* mm, integer* jm, real* ys, real* yc, real* py);
extern void shinir_(integer* mm, real* r__);
extern void shinit_(integer* mm, integer* jm, integer* im, real* y, real* ys, real* yc, real* x, real* xs, real* xc, real* xw, real* z__, real* py, real* px, real* r__, real* wfft);
extern void shinix_(integer* jm, real* x, real* xs, real* xc, real* xw);
extern void shiniy_(integer* jm, real* y, real* ys, real* yc);
extern void shiniz_(integer* jm, real* x, real* y, real* z__);
extern void shlbwj_(integer* mm, integer* jm, integer* m, integer* j, integer* isw, real* sm, real* wmj, real* sd, real* pmj, real* yc, real* r__);
extern void shlbwl_(integer* mm, integer* m, real* sd, real* ws, real* wa, real* pmj);
extern void shlbwm_(integer* mm, integer* jm, integer* m, integer* isw, real* sm, real* wm, real* sd, real* pm, real* yc, real* r__);
extern void shlbwu_(integer* mm, integer* jm, integer* m, integer* isw, real* sm, real* wm, real* sd, real* pm, real* ys, real* yc, real* py, real* r__);
extern void shlfwl_(integer* mm, integer* jm, integer* n, integer* m, real* wx, real* sd, real* pm);
extern void shlfwm_(integer* mm, integer* jm, integer* m, integer* isw, real* wm, real* sm, real* sd, real* xc, real* pm, real* wy, real* wx, real* r__, real* z__);
extern void shlfwu_(integer* mm, integer* jm, integer* m, integer* isw, real* wm, real* sm, real* sd, real* xs, real* xc, real* pm, real* wy, real* wx, real* px, real* r__, real* z__);
extern void shlsds_(integer* mm, integer* m, integer* isw, real* sd, real* sm, real* r__);
extern void shlssd_(integer* mm, integer* m, integer* isw, real* sm, real* sd, real* r__);
extern void shly2x_(integer* jm, integer* m, integer* isw, real* wm, real* wx, real* wy, real* z__);
extern void shmdxj_(real* wrd, real* wid);
extern void shmdxm_(integer* jm, real* wr, real* wi);
extern void shms2w_(integer* mm, integer* jm, integer* isw, real* s, real* w, real* sd, real* pm, real* ys, real* yc, real* py, real* r__);
extern void shmsri_(integer* mm, integer* m, real* sr, real* si);
extern void shmswa_(integer* mm, integer* jm, integer* isw, integer* m1, integer* m2, real* s, real* w, real* sd, real* pm, real* ys, real* yc, real* py, real* r__);
extern void shmswj_(integer* mm, integer* jm, integer* isw, integer* j, integer* m1, integer* m2, real* s, real* wj, real* sd, real* pmj, real* ys, real* yc, real* py, real* r__);
extern void shmswm_(integer* mm, integer* jm, integer* m, integer* isw, real* s, real* wr, real* wi, real* sd, real* pm, real* ys, real* yc, real* py, real* r__);
extern void shmswz_(integer* mm, integer* jm, integer* isw, real* s, real* wz, real* sd, real* pm, real* ys, real* yc, real* py, real* r__);
extern void shmw2s_(integer* mm, integer* jm, integer* isw, real* w, real* s, real* sd, real* pm, real* xs, real* xc, real* px, real* wy, real* wx, real* r__, real* z__);
extern void shmwjm_(integer* mm, integer* jm, integer* isw, integer* j, integer* m, real* s, real* wjr, real* wji, real* sd, real* pmj, real* ys, real* yc, real* py, real* r__);
extern void shmwjz_(integer* mm, integer* jm, integer* isw, integer* j, real* s, real* wjd, real* sd, real* pmj, real* ys, real* yc, real* py, real* r__);
extern void shnm2l_(integer* mm, integer* n, integer* m, integer* lr, integer* li);
extern void sholap_(integer* mm, integer* ind, real* a, real* b);
extern void shpfun_(integer* mm, integer* jm, integer* m, real* fun, real* pm, real* ys, real* yc, real* py, real* r__);
extern void shppma_(integer* mm, integer* jm, integer* m, real* pm, real* ys, real* py, real* r__);
extern void shppmj_(integer* mm, integer* jm, integer* m, integer* j, real* pmj, real* ys, real* py, real* r__);
extern void shtfun_(integer* mm, integer* jm, integer* m, real* fun, real* q);
extern void shtg2s_(integer* mm, integer* jm, integer* im, integer* isw, real* g, real* w, real* s, real* q);
extern void shtg2w_(integer* mm, integer* jm, integer* im, real* g, real* w, real* q);
extern void shtint_(integer* mm, integer* jm, integer* im, real* q);
extern void shtlap_(integer* mm, integer* ind, real* a, real* b);
extern void shtlbw_(integer* mm, integer* jm, integer* m, integer* isw, real* sm, real* wm, real* q);
extern void shtlfw_(integer* mm, integer* jm, integer* m, integer* isw, real* wm, real* sm, real* q);
extern void shtlib_(void);
extern void shtnml_(integer* mm, integer* n, integer* m, integer* lr, integer* li);
extern void shts2g_(integer* mm, integer* jm, integer* im, integer* isw, real* s, real* w, real* g, real* q);
extern void shts2w_(integer* mm, integer* jm, integer* isw, real* s, real* w, real* q);
extern void shtsga_(integer* mm, integer* jm, integer* im, integer* isw, integer* m1, integer* m2, real* s, real* w, real* g, real* q);
extern void shtsgj_(integer* mm, integer* jm, integer* im, integer* isw, integer* j, integer* m1, integer* m2, real* s, real* wj, real* gj, real* q);
extern void shtsgm_(integer* mm, integer* jm, integer* im, integer* m, integer* isw, real* s, real* wr, real* wi, real* g, real* q);
extern void shtsgz_(integer* mm, integer* jm, integer* im, integer* isw, real* s, real* wz, real* g, real* q);
extern void shtswa_(integer* mm, integer* jm, integer* isw, integer* m1, integer* m2, real* s, real* w, real* q);
extern void shtswj_(integer* mm, integer* jm, integer* isw, integer* j, integer* m1, integer* m2, real* s, real* wj, real* q);
extern void shtswm_(integer* mm, integer* jm, integer* m, integer* isw, real* s, real* wr, real* wi, real* q);
extern void shtswz_(integer* mm, integer* jm, integer* isw, real* s, real* wz, real* q);
extern void shtw2g_(integer* mm, integer* jm, integer* im, real* w, real* g, real* q);
extern void shtw2s_(integer* mm, integer* jm, integer* isw, real* s, real* w, real* q);
extern void shtwga_(integer* mm, integer* jm, integer* im, integer* m1, integer* m2, real* w, real* g, real* q);
extern void shtwgj_(integer* mm, integer* im, integer* m1, integer* m2, real* wj, real* gj, real* q);
extern void shtwgm_(integer* mm, integer* jm, integer* im, integer* m, real* wr, real* wi, real* g, real* q);
extern void shtwgz_(integer* jm, integer* im, real* wz, real* g);
extern void sinqb_(integer* n, real* x, real* wsave);
extern void sinqf_(integer* n, real* x, real* wsave);
extern void sinqi_(integer* n, real* wsave);
extern void sint_(integer* n, real* x, real* wsave);
extern void sint1_(integer* n, real* war, real* was, real* xh, real* x, integer* ifac);
extern void sinti_(integer* n, real* wsave);
extern void vcintr_(complex* cx, integer* n, integer* jx);
extern void vrintr_(real* rx, integer* n, integer* jx);
extern void vrrnm_(real* rx, real* ry, integer* n, integer* jx, integer* jy, integer* nb);
extern void vrrnm0_(real* rx, real* ry, integer* n, integer* jx, integer* jy, integer* nb);
extern void vrrnm1_(real* rx, real* ry, integer* n, integer* jx, integer* jy, integer* nb);
extern void vs1din_(real* wz, integer* nw, integer* ix, real* x);
extern void vs1int_(real* wz, integer* nw, integer* ix);
extern void vs1out_(real* wz, integer* nw, integer* ix);
extern void vs2din_(real* wz, integer* nw, integer* ix, integer* iy, real* x, real* y);
extern void vs2int_(real* wz, integer* nw, integer* ix, integer* iy);
extern void vs2out_(real* wz, integer* nw, integer* ix, integer* iy);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* !_MATH2__H_ */
