/* -*- C -*-
	   misc1_.h  -- C header file for GFD DENNOU Library
Name:
    misc1_.h  -- C/C++ header file for GFD DENNOU Library MISC1 package.

Description:
        This is a C/C++ header file for GFD DENNOU library.
    This header includes headers for MISC1 package.

Author:
        This code is written by Taichu Tanaka. If you have any
    trouble, please report to:  taichu@ihas.nagoya-u.ac.jp .

 $Id: misc1_.h,v 0.4 1997/10/03 14:48:04 taichu Exp $
 */
#ifndef _MISC1__H_
#define _MISC1__H_
#ifndef F2C_INCLUDE
#include <f2c.h>
#endif /* !F2C_INCLUDE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

extern void bitpci_(char* cp, integer* ip, ftnlen cp_len);
extern void bitpic_(integer* ip, char* cp, ftnlen cp_len);
extern long iand_(long* i, long* j);
extern long ior_(long* i, long* j);
extern long ishift_(long *i, long* nshift);
extern void cmon_(char* ret_val, ftnlen ret_val_len, integer* im);
extern void cdblk_(char* chr, ftnlen chr_len);
extern void chngc_(char* ch, char* ca, char* cb, ftnlen ch_len, ftnlen ca_len, ftnlen cb_len);
extern void chngi_(char* ch, char* ca, integer* ii, char* cfmt, ftnlen ch_len, ftnlen ca_len, ftnlen cfmt_len);
extern void chngr_(char* ch, char* ca, real* rr, char* cfmt, ftnlen ch_len, ftnlen ca_len, ftnlen cfmt_len);
extern void chval_(char* cfmt, real* val, char* cval, ftnlen cfmt_len, ftnlen cval_len);
extern void clower_(char* ch, ftnlen ch_len);
extern void cns_(char* ret_val, ftnlen ret_val_len, integer* ins);
extern void cupper_(char* ch, ftnlen ch_len);
extern void cweek_(char* ret_val, ftnlen ret_val_len, integer* iw);
extern void date12_(integer* idate, integer* iy, integer* itd);
extern void date13_(integer* idate, integer* iy, integer* im, integer* id);
extern void date21_(integer* idate, integer* iy, integer* itd);
extern void date23_(integer* iy, integer* im, integer* id, integer* itd);
extern void date31_(integer* idate, integer* iy, integer* im, integer* id);
extern void date32_(integer* iy, integer* im, integer* id, integer* itd);
extern void datec1_(char* cform, integer* idate, ftnlen cform_len);
extern void datec2_(char* cform, integer* iy, integer* itd, ftnlen cform_len);
extern void datec3_(char* cform, integer* iy, integer* im, integer* id, ftnlen cform_len);
extern void datef1_(integer* n, integer* idate, integer* ndate);
extern void datef2_(integer* n, integer* iy, integer* itd, integer* ny, integer* ntd);
extern void datef3_(integer* n, integer* iy, integer* im, integer* id, integer* ny, integer* nm, integer* nd);
extern void dateg1_(integer* n, integer* idate, integer* ndate);
extern void dateg2_(integer* n, integer* iy, integer* itd, integer* ny, integer* ntd);
extern void dateg3_(integer* n, integer* iy, integer* im, integer* id, integer* ny, integer* nm, integer* nd);
extern void dateq1_(integer* idate);
extern void dateq2_(integer* iy, integer* itd);
extern void dateq3_(int* iy, int* im, int* id);
extern void fcclos_(integer* iou, integer* icon);
extern void fcgetr_(integer* iou, char* cbuf, integer* icon, ftnlen cbuf_len);
extern void fcgets_(integer* iou, integer* ibuf, integer* icon);
extern void fcleol_(integer* iou, logical* leol);
extern void fcnrec_(integer* iou, integer* nrec);
extern void fcopen_(integer* iou, char* cdsn, integer* nrl, char* cact, integer* icon, ftnlen cdsn_len, ftnlen cact_len);
extern void fcpack_(void);
extern void fcputr_(integer* iou, char* cbuf, integer* icon, ftnlen cbuf_len);
extern void fcputs_(integer* iou, integer* ibuf, integer* icon);
extern void fcrwnd_(integer* iou, integer* icon);
extern void fcslfc_(char* clx, ftnlen clx_len);
extern void gbyte_(integer* npack, integer* iout, integer* ibit, integer* nbits);
extern void gbytes_(integer* npack, integer* isam, integer* ibit, integer* nbits, integer* nskip, integer* iter);
extern void hexdci_(char* cp, integer* ip, ftnlen cp_len);
extern void hexdic_(integer* ip, char* cp, ftnlen cp_len);
extern integer iweek1_(integer* idate);
extern integer iweek2_(integer* iy, integer* itd);
extern integer iweek3_(integer* iy, integer* im, integer* id);
extern logical lchr_(char* char__, char* cref, ftnlen char_len, ftnlen cref_len);
extern logical lchra_(char* ch, ftnlen ch_len);
extern logical lchrb_(char* ch, ftnlen ch_len);
extern logical lchrc_(char* ch, ftnlen ch_len);
extern logical lchrd_(char* ch, ftnlen ch_len);
extern logical lchrf_(char* ch, ftnlen ch_len);
extern logical lchrl_(char* ch, ftnlen ch_len);
extern logical lchrs_(char* ch, ftnlen ch_len);
extern integer ndate1_(integer* idate, integer* ndate);
extern integer ndate2_(integer* iy, integer* itd, integer* ny, integer* ntd);
extern integer ndate3_(integer* iy, integer* im, integer* id, integer* ny, integer* nm, integer* nd);
extern integer ndmon_(integer* iy, integer* im);
extern integer ndyear_(integer* iy);
extern doublereal r4ibm_(integer* ii);
extern doublereal r4ieee_(integer* ii);
extern doublereal rngu0_(integer* iseed);
extern doublereal rngu1_(integer* iseed);
extern doublereal rngu2_(integer* iseed);
extern doublereal rngu3_(integer* iseed);
extern void sbyte_(integer* npack, integer* iout, integer* ibit, integer* nbits);
extern void sbytes_(integer* npack, integer* isam, integer* ibit, integer* nbits, integer* nskip, integer* iter);
extern void time12_(integer* itime, integer* itt);
extern void time13_(integer* itime, integer* ih, integer* im, integer* is);
extern void time21_(integer* itime, integer* itt);
extern void time23_(integer* ih, integer* im, integer* is, integer* itt);
extern void time31_(integer* itime, integer* ih, integer* im, integer* is);
extern void time32_(integer* ih, integer* im, integer* is, integer* itt);
extern void timec1_(char* cform, integer* itime, ftnlen cform_len);
extern void timec2_(char* cform, integer* itt, ftnlen cform_len);
extern void timec3_(char* cform, integer* ih, integer* im, integer* is, ftnlen cform_len);
extern void timeq1_(integer* itime);
extern void timeq2_(integer* itt);
extern void timeq3_(int* ih, int* im, int* is);
extern void dclvnm_(char* cvname, int Lvname);
extern void clckst_(void);
extern void clckgt_(float* time);
extern void clckdt_(float* dt0);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* !_MISC1__H_ */
